/* bxbasm : AFile.c : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012     */



/* ----- includes ----- */
#include "prototyp.h"



void Do_lprint()
{   char ch, varname[VAR_NAME], format[VAR_NAME], temp[6];
    int pi, len, type, wflag=0, mark;


    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);           /* #VARX1, output$ */
    e_pos = pi;
    ch = p_string[pi];
    strcpy(format, get_varname());
    pi = e_pos;
    ch = p_string[pi];

    writeln("  invoke fopen, addr Lprint$, addr Lprnmode$");
    writeln("  push eax");

    pi = e_pos;
    ch = p_string[pi];
    s_holder[0] = '\0';

    while((pi < len) && (ch != '\n'))  /* process up to line terminator */
    {
        pi = get_alpha(pi, len);
        ch = p_string[pi];

        if(pi < len)
        {
            e_pos = pi;
            strcpy(varname, get_varname());
            type = get_ObjectType(varname);

            if(type == 0)              /* output a string$ */
            {
                if(wflag == 1)
                {
                    strcat(s_holder, ",");
                }

                strcpy(temp, "VARX");
                s_pos = pi;
                mark = find_strng(temp);
                mark--;

                if(mark == pi)
                {
                    strcat(s_holder, "addr ");
                }
                strcat(s_holder, varname);
                wflag = 1;
            }
            else                       /* output a value */
            {
                if(wflag == 1)
                {
                    strcat(s_holder, ",");
                }
                strcat(s_holder, varname);
                wflag = 1;
            }

            pi = e_pos;
            ch = p_string[pi];
        }
    }

    write_str("  invoke fprintf, eax, addr ");
    write_str(format);
    write_str(", ");
    writeln(s_holder);
    writeln("  pop  eax");
    writeln("  invoke fclose, eax");
}
/*------- end Do_lprint ----------*/



void parse_chdrive()
{   char ch, varname[VAR_NAME], temp[6];
    int pi, drive, len, ndx;


    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];

    if(ch == '\"')                     /* CHDRIVE "A" */
    {
        pi = get_alpha(pi, len);
        ch = p_string[pi];
        drive = ch;

        if(isupper(ch))
        {
            drive -= 64;               /* is an uppercase */
        }
        else
        {
            drive -= 96;               /* is a lowercase */
        }

        sprintf(temp, "%d", drive);

        write_str("  invoke _chdrive, ");
        writeln(temp);
    }
    else if(isdigit(ch))               /* CHDRIVE 1 */
    {
        ndx = 0;

        while(isdigit(ch))
        {
            temp[ndx] = ch;
            pi++;
            ch = p_string[pi];
            ndx++;
        }
        temp[ndx] = '\0';

        write_str("  invoke _chdrive, ");
        writeln(temp);
    }
    else                               /* CHDRIVE drive */
    {
        strcpy(varname, get_varname());

        write_str("  invoke _chdrive, ");
        writeln(varname);
    }
}
/*------- end parse_chdrive ----------*/



void parse_name()
{   char varname[VAR_NAME], temp[6];
    int pi, mark, len;


    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);

    strcpy(temp, "VARX");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;

    strcpy(varname, get_varname());

    write_str("  invoke rename, ");

    if(mark == pi)
    {
        write_str("addr ");
    }

    write_str(varname);

    pi = e_pos;
    pi = get_alpha(pi, len);

    s_pos = pi;
    mark = find_strng(temp);
    mark--;

    e_pos = pi;
    strcpy(varname, get_varname());

    write_str(", ");

    if(mark == pi)
    {
        write_str("addr ");
    }

    writeln(varname);
}
/*------- end parse_name ----------*/



void parse_kill()
{   char varname[VAR_NAME], temp[6];
    int pi, mark, len;


    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);

    strcpy(temp, "VARX");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;

    strcpy(varname, get_varname());

    write_str("  invoke remove, ");

    if(mark == pi)
    {
        write_str("addr ");
    }

    writeln(varname);
}
/*------- end parse_kill ----------*/



void parse_rmd()
{   char varname[VAR_NAME], temp[6];
    int pi, mark, len;


    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);

    strcpy(temp, "VARX");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;

    strcpy(varname, get_varname());

    write_str("  invoke _rmdir, ");

    if(mark == pi)
    {
        write_str("addr ");
    }

    writeln(varname);
}
/*------- end parse_rmd ----------*/



void parse_mkd()
{   char varname[VAR_NAME], temp[6];
    int pi, mark, len;


    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);

    strcpy(temp, "VARX");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;

    strcpy(varname, get_varname());

    write_str("  invoke _mkdir, ");

    if(mark == pi)
    {
        write_str("addr ");
    }

    writeln(varname);
}
/*------- end parse_mkd ----------*/



void parse_chd()
{   char varname[VAR_NAME], temp[6];
    int pi, mark, len;


    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);

    strcpy(temp, "VARX");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;

    strcpy(varname, get_varname());

    write_str("  invoke _chdir, ");

    if(mark == pi)
    {
        write_str("addr ");
    }

    writeln(varname);
}
/*------- end parse_chd ----------*/



void parse_shell()                /* SHELL "command" */
{   char varname[VAR_NAME];       /* "FILES *.*" */
    int pi, len;


    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;
    strcpy(varname, get_varname());

    write_str("  invoke system, addr ");
    writeln(varname);
}
/*------- end parse_shell ----------*/



void print_file(int len)
{   char ch, fhandle[4], varname[VAR_NAME], format[VAR_NAME], temp[6];
    int pi, port, type, wflag=0, mark;
    double file_no;


    pi = e_pos;
    pi = get_alpha(pi, len);           /* #VARX1$, #1, output$ */
    e_pos = pi;
    ch = p_string[pi];
    strcpy(format, get_varname());

    pi = e_pos;
    ch = p_string[pi];
    pi = get_digit(pi, len);           /* WRITE#1, output$ */
    e_pos = pi;
    file_no = get_avalue();
    port = (int) file_no;
    port--;
    sprintf(fhandle, "%d", port);

    write_str("  mov  eax, ");
    writeln(fhandle);
    writeln("  call getfilehandle");   /* EAX now has the FP */

    getfilehandle = 1;

    pi = e_pos;
    ch = p_string[pi];
    s_holder[0] = '\0';

    while((pi < len) && (ch != '\n'))  /* process up to line terminator */
    {
        pi = get_alpha(pi, len);
        ch = p_string[pi];

        if(pi < len)
        {
            e_pos = pi;
            strcpy(varname, get_varname());
            type = get_ObjectType(varname);

            if(type == 0)              /* output a string$ */
            {
                if(wflag == 1)
                {
                    strcat(s_holder, ",");
                }

                strcpy(temp, "VARX");
                s_pos = pi;
                mark = find_strng(temp);
                mark--;

                if(mark == pi)
                {
                    strcat(s_holder, "addr ");
                }
                strcat(s_holder, varname);
                wflag = 1;
            }
            else                       /* output a value */
            {
                if(wflag == 1)
                {
                    strcat(s_holder, ",");
                }
                strcat(s_holder, varname);
                wflag = 1;
            }

            pi = e_pos;
            ch = p_string[pi];
        }
    }

    write_str("  invoke fprintf, eax, addr ");
    write_str(format);
    write_str(", ");
    writeln(s_holder);

 /* printf("s_holder=%s\n", s_holder); */
}
/*------- end print_file ----------*/



void lineinput_io()
{   char ch, fhandle[4], varname[VAR_NAME];
    int pi, len, port;
    double file_no;


    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];
    pi = get_digit(pi, len);           /* LINE INPUT #1, input$ */
    e_pos = pi;
    file_no = get_avalue();
    port = (int) file_no;
    port--;
    sprintf(fhandle, "%d", port);

    pi = e_pos;
    ch = p_string[pi];

    pi = get_alpha(pi, len);
    e_pos = pi;
    strcpy(varname, get_varname());

    writeln("; --------------------------------------------------");
    write_str("  mov  esi, offset ");
    writeln(varname);
    write_str("  mov  edi, [");
    write_str(varname);
    writeln("]");
    writeln("  call clearLngstrng_bffr");

    clearLngstrngbffr = 1;

    write_str("  mov  eax, ");
    writeln(fhandle);
    writeln("  call getfilehandle");   /* EAX now has the FP */

    getfilehandle = 1;

    write_str("  invoke fgets, ");
    write_str(varname);
    writeln(", BUFSIZE, eax");
}
/*------- end lineinput_io ----------*/



void Do_rset()
{   char ch, varname[VAR_NAME], length[4];
    int pi, ii, len, fld_len, ndx, cnt, ibool;
    int func, ab_code=19, x=line_ndx;
    double value;


    len = strlen(p_string);
    pi = e_pos;
    strcpy(varname, get_varname());    /* get destination name */
    pi = e_pos;

    write_str("  mov  edi, [");
    write_str(varname);
    writeln("]");

    ndx = -1;
    ibool = 1;

    while((ndx < (IOARRAY - 1)) && (ibool != 0))
    {
        ndx++;
        cnt = fld_bffr[ndx].fld_count;

        if(cnt > 0)
        {
            ii = -1;

            while((ibool != 0) && (ii < cnt))
            {
                ii++;
                ibool = strcmp(fld_bffr[ndx].str_name[ii], varname);
            }
        }
    }

    if(ibool == 0)
    {
        fld_len = fld_bffr[ndx].str_len[ii];
        sprintf(length, "%d", fld_len);
    }
    else
    {
        a_bort(ab_code, x);
    }

    pi = get_alnum(pi, len);
    ch = p_string[pi];

    if((pi < len) && (isdigit(ch)))
    {
        e_pos = pi;
        value = get_avalue();          /* get function number */
        func = (int) value;

        if(func == 11)
        {
            mkistr(len);
        }
        else
        {
            mkdstr(len);
        }
    }
    else if((pi < len) && (isalpha(ch)))
    {
        pi = get_alpha(pi, len);       /* advance to varname */
        e_pos = pi;
        strcpy(varname, get_varname());     /* get source name */
        pi = e_pos;

        write_str("  mov  esi, [");
        write_str(varname);
        writeln("]\t\t; source string");
        write_str("  mov  edx, ");
        writeln(length);
        writeln("  call  rsetstr");

        asnrsetstr = 1;
    }
    else
    {
        a_bort(ab_code, x);
    }
}
/*------- end Do_rset ----------*/



void Do_get()
{   char ch, fhandle[6], bffsiz[6], varname[VAR_NAME];
    int len, pi, ndx, buffsize;
    double file_no;


    len = strlen(p_string);            /* GET 1, record% */
    pi = e_pos;
    pi = get_digit(pi,len);
    e_pos = pi;
    file_no = get_avalue();
    ndx = (int) file_no;
    ndx--;
    sprintf(fhandle, "%d", ndx);
    pi = e_pos;

    buffsize = fld_bffr[ndx].bfr_size;
    sprintf(bffsiz, "%d", buffsize);

    writeln("; --------------------------------------------------");

    pi = get_alpha(pi, len);
    ch = p_string[pi];

    if((pi < len) && (isalpha(ch)))
    {
        e_pos = pi;
        strcpy(varname, get_varname());     /* get destination name */

        write_str("  mov  eax, ");
        writeln(varname);
        writeln("  dec  eax");
        writeln("  mov  ebx, eax");
        write_str("  mov  eax, ");
        writeln(bffsiz);
        writeln("  mul  bx");
        writeln("  push eax\t\t\t; save this record number");
        write_str("  mov  eax, ");
        writeln(fhandle);
        writeln("  call getfilehandle");
        writeln("  pop  ebx");
        writeln("  invoke fseek, eax, ebx, SEEK_SET");
    }

    writeln("; --------------------------------------------------");
    writeln("  mov  edi, offset iobuffers");

    if(ndx > 0)
    {
        write_str("  add  edi, (");
        write_str(fhandle);
        writeln(" * 4)");
    }

    writeln("  mov  esi, [edi]");
    writeln("  push esi");
    write_str("  add  esi, ");
    writeln(bffsiz);
    writeln("  mov  eax, 0");
    writeln("  mov  [esi], al");
    write_str("  mov  eax, ");
    writeln(fhandle);
    writeln("  call getfilehandle");
    writeln("  pop esi");
    write_str("  invoke fread, esi, ");
    write_str(bffsiz);
    writeln(", 1, eax");

    getfilehandle = 1;
}
/*------- end Do_get ----------*/



void Do_put()
{   char ch, fhandle[6], bffsiz[6], varname[VAR_NAME];
    int len, pi, ndx, buffsize;
    double file_no;


    len = strlen(p_string);       /* PUT 1, record% */
    pi = e_pos;
    pi = get_digit(pi,len);
    e_pos = pi;
    file_no = get_avalue();
    ndx = (int) file_no;
    ndx--;
    sprintf(fhandle, "%d", ndx);
    pi = e_pos;

    buffsize = fld_bffr[ndx].bfr_size;
    sprintf(bffsiz, "%d", buffsize);

    writeln("; --------------------------------------------------");

    pi = get_alpha(pi, len);
    ch = p_string[pi];

    if((pi < len) && (isalpha(ch)))
    {
        e_pos = pi;
        strcpy(varname, get_varname());     /* get destination name */

        write_str("  mov  eax, ");
        writeln(varname);
        writeln("  dec  eax");
        writeln("  mov  ebx, eax");
        write_str("  mov  eax, ");
        writeln(bffsiz);
        writeln("  mul  bx");
        writeln("  push eax\t\t\t; save this record number");
        write_str("  mov  eax, ");
        writeln(fhandle);
        writeln("  call getfilehandle");
        writeln("  pop  ebx");
        writeln("  invoke fseek, eax, ebx, SEEK_SET");
    }

    writeln("; --------------------------------------------------");
    writeln("  mov  edi, offset iobuffers");

    if(ndx > 0)
    {
        write_str("  add  edi, (");
        write_str(fhandle);
        writeln(" * 4)");
    }

    writeln("  mov  esi, [edi]");
    writeln("  push esi");
    write_str("  add  esi, ");
    writeln(bffsiz);
    writeln("  mov  eax, 0");
    writeln("  mov  [esi], al");
    write_str("  mov  eax, ");
    writeln(fhandle);
    writeln("  call getfilehandle");
    writeln("  pop esi");
    write_str("  invoke fwrite, esi, ");
    write_str(bffsiz);
    writeln(", 1, eax");

    getfilehandle = 1;
}
/*------- end Do_put ----------*/



void Do_lset()
{   char ch, varname[VAR_NAME], length[4];
    int pi, ii, len, fld_len, ndx, cnt, ibool;
    int func, ab_code=19, x=line_ndx;
    double value;


    len = strlen(p_string);
    pi = e_pos;
    strcpy(varname, get_varname());    /* get destination name */
    pi = e_pos;

    write_str("  mov  edi, [");
    write_str(varname);
    writeln("]");

    ndx = -1;
    ibool = 1;

    while((ndx < (IOARRAY - 1)) && (ibool != 0))
    {
        ndx++;
        cnt = fld_bffr[ndx].fld_count;

        if(cnt > 0)
        {
            ii = -1;

            while((ibool != 0) && (ii < cnt))
            {
                ii++;
                ibool = strcmp(fld_bffr[ndx].str_name[ii], varname);
            }
        }
    }

    if(ibool == 0)
    {
        fld_len = fld_bffr[ndx].str_len[ii];
        sprintf(length, "%d", fld_len);
    }
    else
    {
        a_bort(ab_code, x);
    }

    pi = get_alnum(pi, len);
    ch = p_string[pi];

    if((pi < len) && (isdigit(ch)))
    {
        e_pos = pi;
        value = get_avalue();     /* get function number */
        func = (int) value;

        if(func == 11)
        {
            mkistr(len);
        }
        else
        {
            mkdstr(len);
        }
    }
    else if((pi < len) && (isalpha(ch)))
    {
        pi = get_alpha(pi, len);       /* advance to varname */
        e_pos = pi;
        strcpy(varname, get_varname());     /* get source name */
        pi = e_pos;

        write_str("  mov  esi, [");
        write_str(varname);
        writeln("]\t\t; source string");
        write_str("  mov  edx, ");
        writeln(length);
        writeln("  call  lsetstr");

        asnlsetstr = 1;
    }
    else
    {
        a_bort(ab_code, x);
    }
}
/*------- end Do_lset ----------*/



void Do_field()
{   char varname[VAR_NAME], fhandle[4], temp[6], str[3];
    int pi, handle, len, mark, slen;
    int ii, ndx, varcnt, cnt;
    double value;
    unsigned size;


    len = strlen(p_string);       /* FIELD #1, 1 AS a$, 2 AS b$, 3 AS c$ */
    pi = e_pos;
    value = get_avalue();         /* get var count */
    pi = e_pos;
    varcnt = (int) value;

    pi = get_digit(pi, len);
    e_pos = pi;

    value = get_avalue();         /* get file number */
    pi = e_pos;
    handle = (int) value;
    handle--;
    ndx = handle;
    sprintf(fhandle, "%d", handle);

    writeln("; --------------------------------------------------");
    writeln("  mov  edi, offset iobuffers\t\t; FIELD #, data...");

    if(handle > 0)                /* adjust pointer to this file */
    {
        write_str("  add  edi, (");
        write_str(fhandle);
        writeln(" * 4)");
    }

    writeln("  mov  eax, [edi]");      /* EDI now points to the buffer */

    cnt = fld_bffr[ndx].fld_count;

    if(cnt > 0)
    {
        free(fld_bffr[ndx].str_len);

        for(ii = 0; ii < cnt; ii++)
        {
            free(fld_bffr[ndx].str_name[ii]);
        }

        free(fld_bffr[ndx].str_name);
        fld_bffr[ndx].fld_count = 0;
    }

    cnt = 0;
    size = varcnt;           /* store the "AS" count in the structure */
    fld_bffr[ndx].fld_count = varcnt;
    fld_bffr[ndx].str_len = malloc(size * sizeof(int));
    fld_bffr[ndx].str_name = malloc(size * sizeof(char *));

    for(ii = 0; ii < size; ii++)
    {
        fld_bffr[ndx].str_name[ii] = malloc(VAR_NAME * sizeof(char));
        fld_bffr[ndx].str_name[ii][0] = '\0';
    }

    while(pi < len)          /* move to the string length position */
    {
        pi = get_digit(pi, len);
        e_pos = pi;
        value = get_avalue();     /* get string length */
        pi = e_pos;
        slen = (int) value;
        fld_bffr[ndx].str_len[cnt] = slen;
        sprintf(str, "%d", slen);

        strcpy(temp, "AS ");
        s_pos = pi;
        mark = find_strng(temp);
        mark--;

        if((mark > 0) && (mark < len))
        {
            pi = mark;
            pi += 2;
            pi = get_alpha(pi, len);
            e_pos = pi;
            strcpy(varname, get_varname());      /* get varname */
            pi = e_pos;
            strcpy(fld_bffr[ndx].str_name[cnt], varname);  /* save it */

            write_str("  mov  ");
            write_str(varname);
            writeln(", eax\t\t\t; create string pointer");
            write_str("  add  eax, ");
            writeln(str);

            cnt++;
        }
        else
        {
            pi = len;
        }
    }

    writeln("; --------------------------------------------------");
}
/*------- end Do_field ----------*/



void input_io()
{   char ch, fhandle[4], varname[VAR_NAME];
    int pi, len, port, type, wflag=0;
    double file_no;


    len = strlen(p_string);
    pi = e_pos;
    pi = get_digit(pi, len);      /* INPUT #1, input$ */
    e_pos = pi;                   /*  READ #1, input$ */
    file_no = get_avalue();
    port = (int) file_no;
    port--;
    sprintf(fhandle, "%d", port);

    writeln("; --------------------------------------------------");
    writeln("  mov  edi, offset iobuffers");

    if(port > 0)
    {
        write_str("  add  edi, (");
        write_str(fhandle);
        writeln(" * 4)");
    }

    writeln("  mov  esi, [edi]");
    writeln("  mov  integer, esi");    /* hang on to iobuffer addr */
    write_str("  mov  eax, ");
    writeln(fhandle);
    writeln("  call getfilehandle");   /* EAX now has the FP */
    writeln("  mov  esi, integer");
    writeln("  invoke fgets, esi, BUFSIZE, eax");
    writeln("  mov  esi, integer");    /* ESI = iobuffer address */

    pi = e_pos;
    ch = p_string[pi];

    while((pi < len) && (ch != '\n'))   /* process up to line terminator */
    {
        pi = get_alpha(pi, len);
        ch = p_string[pi];

        if(pi < len)
        {
            e_pos = pi;
            strcpy(varname, get_varname());
            type = get_ObjectType(varname);
            pi = e_pos;

            if(type == 0)              /* input a string$ */
            {
                write_str("  mov  edi, [");      /* destination address */
                write_str(varname);
                writeln("]");
                writeln("  call movstrng_bffr");
                write_str("  mov  ");
                write_str(varname);
                writeln(", eax");      /* save string address */

                clearstrngbffr = 1;
                movstrngbffr = 1;
            }
            else                       /* output a value */
            {
                if(type < 3)
                {
                    write_str("  mov  edi, offset ");
                    writeln(varname);
                    writeln("  call readintstr");

                    readintstr = 1;
                }
                else if(type < 5)
                {
                    write_str("  mov  edi, offset ");
                    writeln(varname);
                    writeln("  call readfltstr");

                    readfltstr = 1;
                }
                else                   /* if(type == 5) */
                {
                    write_str("  mov  edi, offset ");
                    writeln(varname);
                    writeln("  call readQintstr");

                    readQintstr = 1;
                }
            }

            pi = e_pos;
            ch = p_string[pi];
        }
    }

    getfilehandle = 1;
}
/*------- end input_io ----------*/



void write_io()
{   char ch, fhandle[4], varname[VAR_NAME], format[VAR_NAME];
    int pi, len, port, type, wflag=0;
    double file_no;


    len = strlen(p_string);
    strcpy(format, get_varname());

    pi = e_pos;
    ch = p_string[pi];
    pi = get_digit(pi, len);           /* WRITE#1, output$ */
    e_pos = pi;
    file_no = get_avalue();
    port = (int) file_no;
    port--;
    sprintf(fhandle, "%d", port);

    write_str("  mov  eax, ");
    writeln(fhandle);
    writeln("  call getfilehandle");   /* EAX now has the FP */

    getfilehandle = 1;

    pi = e_pos;
    ch = p_string[pi];
    s_holder[0] = '\0';

    while((pi < len) && (ch != '\n'))  /* process up to line terminator */
    {
        pi = get_alpha(pi, len);
        ch = p_string[pi];

        if(pi < len)
        {
            e_pos = pi;
            strcpy(varname, get_varname());
            type = get_ObjectType(varname);

            if(type == 0)              /* output a string$ */
            {
                if(wflag == 1)
                {
                    strcat(s_holder, ",");
                }

                strcat(s_holder, varname);
                wflag = 1;
            }
            else                       /* output a value */
            {
                if(wflag == 1)
                {
                    strcat(s_holder, ",");
                }

                strcat(s_holder, varname);
                wflag = 1;
            }

            pi = e_pos;
            ch = p_string[pi];
        }
    }

    write_str("  invoke fprintf, eax, addr ");
    write_str(format);
    write_str(", ");
    writeln(s_holder);

/* printf("s_holder=%s\n", s_holder); */
}
/*------- end write_io ----------*/



void parse_open()
{   char ch, fhandle[4], mode[VAR_NAME], filename[PATH], temp[6];
    int pi, len, mark, handle, buffer, iomode;
    double value;


    len = strlen(p_string);
    pi = e_pos;
    value = get_avalue();              /* get I/O Mode */
    iomode = (int) value;

    pi = e_pos;
    ch = p_string[pi];
    pi = get_upper(pi, len);
    e_pos = pi;
    strcpy(mode, get_varname());       /* file mode variable */
    pi = e_pos;

    pi = get_digit(pi, len);
    e_pos = pi;
    value = get_avalue();
    handle = (int) value;
    handle--;                          /* decrement handle number */
    pi = e_pos;

    pi = get_alpha(pi, len);           /* path\file name */
    strcpy(temp, "VARX");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;

    if((mark >= 0) && (mark == pi))
    {
        mark = 1;
    }
    else
    {
        mark = 0;
    }

    e_pos = pi;
    strcpy(filename, get_varname());
    pi = e_pos;
    pi = get_digit(pi, len);
    ch = p_string[pi];

    if((pi < len) && (isdigit(ch)))
    {
        e_pos = pi;
        value = get_avalue();
        buffer = (int) value;
    }
    else
    {
        buffer = 256;        /* record length (random) */
    }

    fld_bffr[handle].bfr_size = buffer;

    writeln("; --------------------------------------------------");

    if(mark == 1)            /* OPEN a quoted string */
    {
        write_str("  invoke fopen, addr ");
        write_str(filename);
        write_str(", addr ");
        write_str(mode);
        writeln("\t; OPEN file");

        if(iomode == 1)
        {
            writeln("  .if eax == NULL");
            write_str("    invoke fopen, addr ");
            write_str(filename);
            writeln(", addr _Altern_$");
            writeln("  .endif");
        }
    }
    else                     /* OPEN a filename string */
    {
        write_str("  mov  eax, [");
        write_str(filename);
        writeln("]");
        write_str("  invoke fopen, eax, addr ");
        write_str(mode);
        writeln("\t; OPEN file");

        if(iomode == 1)
        {
            writeln("  .if eax == NULL");
            writeln("    invoke fopen, eax, addr _Altern_$");
            writeln("  .endif");
        }
    }

    writeln("  mov  edi, offset iohandles");

    if(handle > 0)
    {
        sprintf(fhandle, "%d", handle);
        write_str("  add  edi, (");
        write_str(fhandle);
        writeln(" * 4)");
    }

    writeln("  mov  [edi], eax");
    writeln("  mov  edi, offset iobuffers");

    if(handle > 0)
    {
        write_str("  add  edi, (");
        write_str(fhandle);
        writeln(" * 4)");
    }

    sprintf(temp, "%d", buffer);

    write_str("  mov  eax, ");
    writeln(temp);
    writeln("  call setupiobuffer");

    setupiobuffer = 1;
}
/*------ end parse_open -------*/



void Do_fclose()
{   char ch, fhandle[4];
    int pi, len, handle;
    double value;


    len = strlen(p_string);
    pi = 0;
    pi = iswhite(pi);
    ch = p_string[pi];

    writeln("; --------------------------------------------------");

    if(pi < len)
    {
        while((pi < len) && (ch != '\0'))
        {
            pi = get_digit(pi, len);
            e_pos = pi;
            value = get_avalue();
            handle = (int) value;
            handle--;                  /* decrement handle number */
            sprintf(fhandle, "%d", handle);

            write_str("  mov  eax, ");
            writeln(fhandle);
            writeln("  call closeafile");

            closeafile = 1;

            pi = e_pos;
            ch = p_string[pi];
        }
    }
    else
    {
        writeln("  call closeallfiles");

        filecloseall = 1;
    }
}
/*------ end do_fclose -------*/



/*--- do not delete!!! called by: Main ---*/
void init_fldbffrs()
{   int ii;
    unsigned size=1;


    for(ii=0; ii < IOARRAY; ii++)           /* initialize Field buffers */
    {
        fld_bffr[ii].f_bffr = malloc(size * sizeof(char));
        fld_bffr[ii].f_bffr[0] = '\0';
        fld_bffr[ii].bfr_size = 1;
        fld_bffr[ii].record = 1;
        fld_bffr[ii].fld_count = 0;
        fld_bffr[ii].flag = 0;
    }
}
/*-------- end init_fldbffrs --------*/
/*--- do not delete!!! called by: Main ---*/

