/* bxbasm : ALoops.c : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012      */


/* ----- function prototypes ----- */
#include "prototyp.h"



void Do_do()                 /* parse a DO-WHILE statement */
{   char Label[LLEN];


    strcat(indent, "  ");

    strcpy(WhileArray[whileLblCtr], get_NewLabel());  /* END-WHILE label */
    strcpy(BreakArray[breakCtr], WhileArray[whileLblCtr]); /* BREAK */
    breakCtr++;
    whileLblCtr++;
    strcpy(WhileArray[whileLblCtr], get_NewLabel());  /* DO label */

    strcpy(Label, WhileArray[whileLblCtr]);
    whileLblCtr++;
    PostLabel(Label);

    write_str(indent);
    writeln(";--------------------<do>");

    dowhileflag = 1;
}
/*------- end Do_do -------*/



void Do_dowhile()            /* parse a DO-WHILE statement */
{   char Label[LLEN];
    int len, mark_or;


    write_str(indent);
    writeln(";--------------------<end-do>");

    Or_pi = 0;
    mark_or = wcheck_or();        /* is there an: or */
    wboolexpress();               /* evaluate condition */
    wor_true(mark_or);

    whileLblCtr--;
    strcpy(Label, WhileArray[whileLblCtr]);
    WhileArray[whileLblCtr][0] = '\0';

    write_str(indent);
    write_str("jmp  ");
    writeln(Label);

    whileLblCtr--;
    strcpy(Label, WhileArray[whileLblCtr]);
    WhileArray[whileLblCtr][0] = '\0';
    PostLabel(Label);

    breakCtr--;
    BreakArray[breakCtr][0] = '\0';

    len = strlen(indent);
    len = len - 2;
    indent[len] = '\0';
    indcnt--;

    opcntr = 0;
    dowhileflag = 0;

}
/*------- end Do_dowhile -------*/



void Do_break()              /* parse an BREAK statement */
{   char label[LLEN];
    int count;


    count = breakCtr - 1;
    strcpy(label, BreakArray[count]);

    write_str(indent);
    write_str("jmp  ");
    write_str(label);
    writeln("\t\t;--------------------<break>");

}
/*------- end Do_break -------*/



void Do_loop()               /* parse a LOOP statement */
{   char Label[LLEN];


    strcat(indent, "  ");

    strcpy(LoopArray[loopLblCtr], get_NewLabel());    /* ENDLOOP label */
    strcpy(BreakArray[breakCtr], LoopArray[loopLblCtr]);
    breakCtr++;
    loopLblCtr++;

    strcpy(LoopArray[loopLblCtr], get_NewLabel());    /* LOOP label */
    strcpy(Label, LoopArray[loopLblCtr]);
    PostLabel(Label);
    loopLblCtr++;

    write_str(indent);
    writeln(";--------------------<loop>");

}
/*------- end Do_loop -------*/



void Do_endloop()            /* parse an LEND statement */
{   char label[LLEN];
    int len;


    loopLblCtr--;
    strcpy(label, LoopArray[loopLblCtr]);
    LoopArray[loopLblCtr][0] = '\0';

    write_str(indent);
    write_str("jmp  ");
    writeln(label);
    write_str(indent);
    writeln(";--------------------<end-loop>");

    len = strlen(indent);
    len = len - 2;
    indent[len] = '\0';
    indcnt--;

    loopLblCtr--;
    strcpy(label, LoopArray[loopLblCtr]);
    LoopArray[loopLblCtr][0] = '\0';
    PostLabel(label);

    breakCtr--;
    BreakArray[breakCtr][0] = '\0';
}
/*------- end Do_endloop -------*/



void Do_while()              /* parse a WHILE statement */
{   char Label[LLEN];
    int pi, mark_or;


    if(dowhileflag == 1)     /* a DO-WHILE statement */
    {
        Do_dowhile();
        return;
    }

    pi = e_pos;
    strcat(indent, "  ");

    write_str(indent);
    writeln(";--------------------<while>");

    strcpy(WhileArray[whileLblCtr], get_NewLabel());       /* WEND label */

    strcpy(BreakArray[breakCtr], WhileArray[whileLblCtr]); /* BREAK */
    breakCtr++;
    whileLblCtr++;
    strcpy(WhileArray[whileLblCtr], get_NewLabel());       /* WHILE label */

    strcpy(Label, WhileArray[whileLblCtr]);
    whileLblCtr++;
    PostLabel(Label);

    Or_pi = 0;
    mark_or = wcheck_or();        /* is there an: or */
    wboolexpress();               /* evaluate condition */

    write_str(indent);
    writeln(";--------------------<block>");

    wor_true(mark_or);
    opcntr = 0;
}
/*------- end Do_while -------*/



void Do_wend()               /* parse an WEND statement */
{   char label[LLEN];
    int len;


    write_str(indent);
    writeln(";--------------------<end-block>");

    whileLblCtr--;
    strcpy(label, WhileArray[whileLblCtr]);
    WhileArray[whileLblCtr][0] = '\0';

    write_str(indent);
    write_str("jmp  ");
    writeln(label);
    write_str(indent);
    writeln(";--------------------<wend>");

    len = strlen(indent);
    len = len - 2;
    indent[len] = '\0';
    indcnt--;

    whileLblCtr--;
    strcpy(label, WhileArray[whileLblCtr]);
    WhileArray[whileLblCtr][0] = '\0';
    PostLabel(label);

    breakCtr--;
    BreakArray[breakCtr][0] = '\0';
}
/*------- end Do_wend -------*/



void wboolexpress()
{   int pi, unary, type, op, ab_code=14, x=line_ndx;


    pi = e_pos;
    unary = isUnary_Exp();        /* is it a unary expression */

    if(unary != 0)
    {
        op = do_UnaryExp(unary);
    }
    else
    {
        type = get_Exptype();     /* string, numeric, or eof */

 /* printf("type=%d\n", type); /**/

        switch(type)
        {   case 0:
                op = Sboolterm(type);  /* a string evaluation */
                break;
            case 1:
            case 2:
                op = Nboolterm(type);  /* numeric evaluation */
                break;
            case 3:
            case 4:
//                op = Sboolterm(type);  /* a string evaluation */
                op = Nboolterm(type);  /* numeric evaluation */
                break;
            case 5:
                op = is_eof();         /* an EOF evaluation */
                break;
            default:
                /* a_bort(ab_code,x); */
                break;
        }
    }

    op = WIsAndOrOp(op);          /* --- process AND / OR --- */

    if(op != 0)
    {
        opcntr++;
        wboolexpress();           /* do: AND/OR */
    }
}
/*------- end wboolexpress --------*/



int WIsAndOrOp(int op)
{   char ch, jump[10], this_label[LLEN];
    int pi, ibool, wlabel;


    pi = e_pos;
    pi = iswhiter(pi);
    ch = p_string[pi];
    e_pos = pi;
    wlabel = whileLblCtr - 2;
    strcpy(this_label, WhileArray[wlabel]);

    if(op > 6)                    /* a UNARY condition */
    {
        if(op == 7)               /* a NOT condition */
        {
            op = 6;
            ch = '|';             /* force 'jump' */
            strcpy(jump, jump_if(op, ch));
        }
        else
        {
            op = 6;
            ch = ' ';             /* force 'jump' */
            strcpy(jump, jump_if(op, ch));
        }

        ch = p_string[pi];

        switch(ch)
        {   case '&':                  /* AND */
                ibool = look_Or();     /* is there an OR to jump to */

                if(ibool == 1)
                {
                    strcpy(this_label, label_Or);
                }

                write_str(indent);
                write_str(jump);
                writeln(this_label);

                op = 1;
                break;
            case '|':                  /* OR */
                strcpy(this_label, wlabel_block);

                write_str(indent);
                write_str(jump);
                writeln(this_label);

                if(label_Or[0] != '\0')
                {
                    PostLabel(label_Or);
                    label_Or[0] = '\0';
                }

                op = 2;
                break;
            case '^':                  /* NOT */
                write_str(indent);
                write_str(jump);
                writeln(this_label);

                op = 3;
                break;
            default:
                write_str(indent);
                write_str(jump);
                writeln(this_label);

                op = 0;
                pi--;
                break;
        }

        pi++;
        pi = iswhiter(pi);
    }
    else                          /* a normal BINARY condition */
    {
        switch(ch)
        {   case '&':                  /* AND */
                ibool = look_Or();     /* is there an OR to jump to */

                if(ibool == 1)
                {
                    strcpy(this_label, label_Or);
                }

                strcpy(jump, jump_if(op, ch));

                write_str(indent);
                write_str(jump);
                writeln(this_label);

                op = 1;
                break;
            case '|':                  /* OR */
                strcpy(this_label, wlabel_block);
                strcpy(jump, jump_if(op, ch));

                write_str(indent);
                write_str(jump);
                writeln(this_label);

                if(label_Or[0] != '\0')
                {
                    PostLabel(label_Or);
                    label_Or[0] = '\0';
                }

                op = 2;
                break;
            case '^':                  /* NOT */
                strcpy(jump, jump_if(op, ch));

                write_str(indent);
                write_str(jump);
                writeln(this_label);

                op = 3;
                break;
            default:
                strcpy(jump, jump_if(op, ch));

                write_str(indent);
                write_str(jump);
                writeln(this_label);

                op = 0;
                pi--;
                break;
        }

        pi++;
        pi = iswhiter(pi);
    }

    e_pos = pi;

    return op;
}
/*------- end WIsAndOrOp --------*/



int do_UnaryExp(int ibool)        /* a unary expression */
{   int op;


    switch(ibool)
    {   case 1:                   /* boolean NOT expression */
            op = Unary_NOT();
            break;
        case 2:                   /* boolean TRUE expression */
            op = Unary_TRUE();
            break;
    }

    return op;
}
/*------- end do_Unary_Exp --------*/



int Unary_NOT()              /* a unary NOT condition */
{   char temp[6];
    int pi, type, op, mark;


    pi = e_pos;
    pi = get_rightExp(pi);
    e_pos = pi;
    type = get_vtype(pi);    /* numeric evaluation */

    if(type == 1)
    {
        op = WNrelation();
    }
    else if(type == 5)
    {
        strcpy(temp, "EOF");
        s_pos = pi;
        mark = find_strng(temp);
        mark--;

        if(mark == pi)
        {
            op = is_eof();   /* an EOF evaluation */
            op++;
        }
    }

    return op;
}
/*------- end Unary_NOT --------*/



int Unary_TRUE()             /* a unary TRUE condition */
{   char temp[6];
    int pi, type, op, mark;


    pi = e_pos;
    pi = get_rightExp(pi);
    e_pos = pi;
    type = get_vtype(pi);    /* numeric evaluation */

    if(type == 1)
    {
        op = x_WNrelation();
    }
    else if(type == 5)
    {
        strcpy(temp, "EOF");
        s_pos = pi;
        mark = find_strng(temp);
        mark--;

        if(mark == pi)
        {
            op = is_eof();   /* an EOF evaluation */
        }
    }

    return op;
}
/*------- end Unary_TRUE --------*/



int x_WNrelation()           /* a unary TRUE condition */
{   char varname[VAR_NAME];
    int pi, op;


    pi = e_pos;
    pi = get_rightExp(pi);
    e_pos = pi;

    write_str(indent);
    writeln("mov  eax, 0");

    strcpy(varname, get_varname());

    write_str(indent);
    write_str("cmp  eax, ");
    writeln(varname);

    op = 6;

    return op;
}
/*------- end x_WNrelation --------*/



int WNrelation()
{   char varname[VAR_NAME];
    int op;


    write_str(indent);
    writeln("mov  eax, 0");

    strcpy(varname, get_varname());

    write_str(indent);
    write_str("cmp  eax, ");
    writeln(varname);

    op = 8;

    return op;
}
/*------- end WNrelation --------*/



int isUnary_Exp()            /* return: is it a unary expression */
{   char ch;
    int pi, ibool=0;


    pi = e_pos;
    pi = iswhiter(pi);
    ch = p_string[pi];

    if(ch == '<')
    {
        ibool = 1;                /* 'NOT' boolean expression */
    }
    else if(isalpha(ch))
    {
        pi = get_NextOp(pi);      /* get past this varname */
        ch = p_string[pi];        /* what is the next char ? */

        if(strchr(" $#!%@&", ch)) /* variable type, skip it */
        {
            pi++;
            pi = iswhiter(pi);
            ch = p_string[pi];
        }

        if(strchr("&|^\n\0", ch)) /* AND, OR, NOT or terminated */
        {
            ibool = 2;
        }
    }

    return ibool;
}
/*------- end isUnary_Exp ---------*/



void wor_true(int mark_or)   /* does this statement contain an OR */
{   char block[LLEN];


    if(mark_or > 0)
    {
        strcpy(block, wlabel_block);
        PostLabel(block);
    }
}
/*------- end wor_true -------*/



int wcheck_or()              /* look ahead for an: OR */
{   char temp[3];
    int mark_or;


    s_pos = 0;
    strcpy(temp, "| ");
    mark_or = find_strng(temp);
    mark_or--;

    if(mark_or > 0)
    {
        strcpy(wlabel_block, get_NewLabel());
        Or_pi = 0;           /* keep track of recurring OR position */
    }
    else
    {
        wlabel_block[0] = '\0';
    }

    return mark_or;
}
/*------- end wcheck_or -------*/



void Do_for()
{   char varFrom[VAR_NAME], varTo[VAR_NAME], varStep[VAR_NAME];
    char Label1[LLEN], Label2[LLEN];
    int pi, sav_pi, len;


    len = strlen(p_string);

    pi = e_pos;              /* --- assign FROM --- */
    sav_pi = pi;
    pi = get_alpha(pi, len);
    strcpy(varFrom, get_varname());    /* get name for: x */
    e_pos = sav_pi;
                             /* --- make assignment -- */
    Do_let();                /* FOR x%=a TO b STEP c: */

    pi = e_pos;              /* --- get TO --- */
    s_pos = pi;
    pi = find_strng("TO");   /* work up to: TO */
    pi = while_isalnum(pi);
    pi = get_alpha(pi, len);
    e_pos = pi;
    strcpy(varTo, get_varname());      /* get name for: TO */
    pi = e_pos;

    s_pos = pi;                   /* --- get STEP --- */
    pi = find_strng("STEP");      /* work up to: STEP */
    pi = while_isalnum(pi);
    pi = get_alpha(pi, len);
    e_pos = pi;
    strcpy(varStep, get_varname());    /* get name for: STEP */
    pi = e_pos;

    strcpy(Label1, get_NewLabel());    /* --- get unique labels --- */
    strcpy(Label2, get_NewLabel());
                                  /* --- begin writing assembly code --- */
    PostLabel(Label1);

    write_str("  mov  eax, ");
    write_str(varFrom);
    writeln("\t\t;For/Next loop");

    write_str("  cmp  eax, ");
    writeln(varTo);

    write_str("  jg  ");
    write_str(Label2);
    writeln("\t\t;exit loop");
                                  /* --- save labels --- */
    strcpy(ForArray[forLabelCtr], Label1);
    forLabelCtr++;

    strcpy(ForArray[forLabelCtr], Label2);
    forLabelCtr++;

    strcpy(ForArray[forLabelCtr], varFrom);
    forLabelCtr++;

    strcpy(ForArray[forLabelCtr], varStep);
    forLabelCtr++;
}
/*-------- end Do_for ----------*/



void Do_next()
{   char varFrom[VAR_NAME], varStep[VAR_NAME];
    char Label1[LLEN], Label2[LLEN];


    forLabelCtr--;
    strcpy(varStep, ForArray[forLabelCtr]);
    ForArray[forLabelCtr][0] = '\0';

    forLabelCtr--;
    strcpy(varFrom, ForArray[forLabelCtr]);
    ForArray[forLabelCtr][0] = '\0';

    forLabelCtr--;
    strcpy(Label2, ForArray[forLabelCtr]);
    ForArray[forLabelCtr][0] = '\0';

    forLabelCtr--;
    strcpy(Label1, ForArray[forLabelCtr]);
    ForArray[forLabelCtr][0] = '\0';

    write_str("  FILD  ");
    writeln(varFrom);
    write_str("  FILD  ");
    writeln(varStep);
    writeln("  FADDP  ST(1), ST\t\t;increment counter");
    write_str("  FISTP  ");
    writeln(varFrom);

    write_str("  jmp  ");
    write_str(Label1);
    writeln("\t\t;Next n");

    PostLabel(Label2);
}
/*-------- end Do_next ---------*/


