/* bxbasm : ARdp.c : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012    */


/* special credits to: Jack Crenshaw's: "How to Build a Compiler" */
/* this is a very close implementation of his tutorial.           */


/* ----- function prototypes ----- */
#include "prototyp.h"



void Assignment()                 /* Recursive Descent Parser Main */
{
    writeln("  FINIT \t\t\t; initialize x87");

    Match('=');

    a_Expression();

}
/*---------- end Assignment ----------*/



void a_Expression()               /* Parse and Translate an Expression */
{   char ch;
    int pi, len;


    pi = e_pos;
    ch = p_string[pi];

    if(IsAddop(ch))
    {
        writeln("  FLDZ\t\t\t\t; push 0 onto stack");
    }
    else
    {
        a_Term();
        pi = e_pos;
        ch = p_string[pi];
    }

    len = strlen(p_string);

    if(pi < len)
    {
        while(IsAddop(ch) == 1)
        {
            switch(ch)
            {   case '+':
                    Add();            /* Recognize and Translate an Add */
                    break;
                case '-':
                    Subtract();       /* Recognize and Translate a Subtract */
                    break;
                default:
                    break;
            }

            pi = e_pos;
            ch = p_string[pi];
        }
    }
}
/*---------- end a_Expression ----------*/



void a_Term()                     /* Parse and Translate a Math Term */
{   char ch;
    int pi, len;


    a_Factor();

    pi = e_pos;
    ch = p_string[pi];
    len = strlen(p_string);

    if(pi < len)
    {
        while(IsMultop(ch) == 1)
        {
            switch(ch)
            {   case '*':
                    Multiply();       /* Recognize and Translate a Multiply */
                    break;
                case '/':
                    Divide();         /* Recognize and Translate a Divide */
                    break;
                case '^':
                    Power();          /* Recognize and Translate a Power Of */
                    break;
                case '%':
                    Modulo();         /* Recognize and Translate a Modulo */
                    break;
                default:
                    break;
            }

            pi = e_pos;
            ch = p_string[pi];
        }
    }
}
/*---------- end a_Term ----------*/



void a_Factor()                   /* Parse and Translate a Math Factor */
{   char ch;
    int pi, ab_code=7, x=line_ndx;


    pi = e_pos;
    ch = p_string[pi];

    if(ch == '(')
    {
        Match('(');
        a_Expression();
        Match(')');
    }
    else
    {
        if(isalpha(ch))           /* variable name */
        {
            Ident();
        }
        else if(ch == '?')        /* math function */
        {
            math_functn();
        }
        else                      /* error */
        {
            a_bort(ab_code, x);
        }
    }
}
/*---------- end a_Factor ----------*/



void math_functn()
{   int pi, type;


    pi = e_pos;                        /* enter: ?1(x) */
    pi++;                              /*    ----^     */
    e_pos = pi;
    type = (int) get_avalue();

    pi = e_pos;

    switch(type)
    {
        case 1:
            get_ABS();                 /* a = ABS(exp) */
            break;
        case 2:
            get_ASC();                 /* a = ASC(str$) */
            break;
        case 3:
            get_ATN();                 /* a! = ATN(exp) */
            break;
        case 4:
            get_COS();                 /* a! = COS(exp) */
            break;
        case 5:
            get_SIN();                 /* a! = SIN(exp) */
            break;
        case 6:
            get_TAN();                 /* a! = TAN(exp) */
            break;
        case 7:
            get_SQRT();                /* a! = SQRT(exp) */
            break;
        case 8:
            get_INT();                 /* a = INT(exp) */
            break;
        case 9:
            get_LEN();                 /* a = LEN(str$) */
            break;
        case 10:
            get_LOF();                 /* a% = LOF(fp) */
            break;
        case 11:
            get_LOC();                 /* a% = LOC(fp) */
            break;
        case 12:                       /* a# = CVD(str$) */
        case 14:                       /* a! = CVS(str$) */
            get_CVD();
            break;
        case 13:                       /* a% = CVI(str$) */
            get_CVI();
            break;
        case 15:
            get_ATAN2();               /* a! = ATAN2(exp, exp) */
            break;
        case 16:
            get_COSH();                /* a! = COSH(exp) */
            break;
        case 17:
            get_SINH();                /* a! = SINH(exp) */
            break;
        case 18:
            get_TANH();                /* a! = TANH(exp) */
            break;
        case 19:
            get_ACOS();                /* a! = ACOS(exp) */
            break;
        case 20:
            get_ASIN();                /* a! = ASIN(exp) */
            break;
        case 21:
            get_CEIL();                /* a! = CEIL(exp) */
            break;
        case 22:
            get_FLOOR();               /* a! = FLOOR(exp) */
            break;
        case 23:
            get_HYPOT();               /* a! = HYPOT(exp,exp) */
            break;
        case 24:
            get_LOG();                 /* a! = LOG(exp) */
            break;
        case 25:
            get_LOG10();               /* a! = LOG10(exp) */
            break;
        case 26:
            get_RAND();                /* a = RAND(void) */
            break;
        case 27:
            get_CLOCK();               /* a = CLOCK(void) */
            break;
        case 28:
            get_VAL();                 /* a = VAL(string$) */
            break;
        case 29:
            get_EOF();                 /* a = EOF(fp) */
            break;
        case 30:
            get_SECONDS();             /* a = SECONDS */
            break;
        case 31:
            get_DRIVE();               /* a = DRIVE() */
            break;
        case 32:
            get_EXP();                 /* a# = EXP(n#) */
            break;
        case 33:
            get_FABS();                /* a# = FABS(n#) */
            break;
        case 34:
            get_FMOD();                /* a# = FMOD(n1#,n2#) */
            break;
        case 35:
            get_LDEXP();               /* a# = ldexp(n1#,n2) */
            break;
        case 36:
            get_MODF();                /* a# = modf(n1#,n2#) */
            break;
        case 37:
            get_POW();                 /* a# = pow(n1#,n2#) */
            break;
        case 38:
            get_POW10();               /* a# = pow10(n#) */
            break;
        case 39:
            get_FREXP();               /* a# = frexp(n1#,n2) */
            break;
        case 40:
            get_LABS();                /* a! = labs(n1) */
            break;
        case 41:
            get_HiRezTimer();          /* a# = hi-rez_timer() */
            break;
        case 42:
            get_SGN();                 /* a = sgn(n) */
            break;
        case 43:
            get_MODii();               /* a = MOD(n1,n2) */
            break;
        case 44:
            get_CINT();                /* a = CINT */
            break;
        case 45:
            get_CDBL();                /* a# = CDBL */
            break;
        case 46:
            get_CSNG();                /* a! = CSNG */
            break;
        case 47:
            get_CLNG();                /* a% = CLNG */
            break;
        case 48:
            get_INSTR();               /* a = INSTR */
            break;
        case 49:
            get_TextColor();           /* a% = TXTCOLOR */
            break;
        case 50:
            get_BKColor();             /* a% = BGCOLOR */
            break;
        case 51:
            get_BKMode();              /* a = BKMODE */
            break;
        case 52:
            get_Point();               /* a% = POINT */
            break;




        default:
            /* error */
            break;
    }
}
/*---------- end math_functn ----------*/



void asn_numarry(char *name, int type)      /* assign a numeric array */
{   char varname[VAR_NAME];
    int pi, len, xcnt;


    strcpy(varname, name);             /* enter: abc% = array%(n,) */

    len = strlen(p_string);
    pi = e_pos;
    pi = get_paren(pi, len);

 /*   xcnt = get_paramsCount(pi, len);	/* get params count */

    xcnt = get_ObjectParm(varname);
    get_offset(varname, len, xcnt);

    writeln("  mov  eax, [edi]");

    if(type == 7)                      /* --- load integers --- */
    {
        writeln("  FILD dword ptr [eax]\t\t\t; load integer");
    }
    else if(type == 10)
    {
        writeln("  FILD qword ptr [eax]\t\t\t; load integer");
    }
    else if((type == 8) || (type == 9))
    {
        writeln("  FLD qword ptr [eax]\t\t\t; load float");
    }
}
/*---------- end asn_numarry ----------*/



void Ident()                      /* Parse and Translate an Identifier */
{   char ch, varname[VAR_NAME];
    int pi, type, ab_code=5, x=line_ndx;


    strcpy(varname, get_varname());
    type = get_ObjectType(varname);         /* object type specifier */

 /* printf("varname=%s type=%d\n", varname, type); */

    pi = e_pos;

    if((type >= 7) && (type <= 10))
    {
        asn_numarry(varname, type);    /* source is a numeric array */
        pi = e_pos;
        pi++;
        pi = iswhiter(pi);
        e_pos = pi;

        return;
    }

    SkipWhite();                  /* --- get variable type --- */
    pi = e_pos;
    ch = p_string[pi];

    if(ch == '(')                 /* function call */
    {
        Match('(');
        Match(')');

        write_str("  call  ");
        writeln(varname);
    }
    else if((type == 1) || (type == 2) || (type == 5))     /* load integers */
    {
        write_str("  FILD  ");
        write_str(varname);
        writeln("\t\t\t; load integer");
    }
    else if((type == 3) || (type == 4))     /* load floating pt. */
    {
        write_str("  FLD   ");
        write_str(varname);
        writeln("\t\t\t; load float");
    }
    else
    {
        a_bort(ab_code, x);
    }
}
/*---------- end Ident ----------*/



void Add()                        /* Recognize and Translate an Add */
{
    Match('+');
    a_Term();

    writeln("  FADDP ST(1), ST\t\t\t; add to ST(0) and pop");
}
/*---------- end Add ----------*/



void Subtract()                   /* Recognize and Translate a Subtract */
{
    Match('-');
    a_Term();

    writeln("  FSUBP ST(1), ST\t\t; subtract and pop");
}
/*---------- end Subtract ----------*/



void Multiply()                   /* Recognize and Translate a Multiply */
{
    Match('*');
    a_Factor();

    writeln("  FMULP ST(1), ST\t\t\t; multiply and pop");
}
/*---------- end Multiply ----------*/



void Divide()                     /* Recognize and Translate a Divide */
{
    Match('/');
    a_Factor();

    writeln("  FDIVP ST(1), ST\t\t\t; divide and pop");
}
/*---------- end Divide ----------*/



void Power()                      /* Recognize and Translate a Power Of */
{
    Match('^');

    writeln("  FSTP  qLVAR");

    a_Factor();

    writeln("  FSTP  qRVAR");
    writeln("  invoke pow, qLVAR, qRVAR");  /* double value is in ST(0) */
}
/*---------- end Power ----------*/



void Modulo()                     /* Recognize and Translate a Modulo */
{
    Match('%');

    writeln("  FSTP  qLVAR");

    a_Factor();

    writeln("  FSTP  qRVAR");
    writeln("  invoke fmod, qLVAR, qRVAR"); /* double value is in ST(0) */
}
/*---------- end Modulo ----------*/



void Match(char x)                /* Match a Specific Input Character */
{   char ch, string[6];
    int pi, ab_code=12, ln=line_ndx;


    pi = e_pos;
    ch = p_string[pi];

    if(ch != x)
    {
        strcpy(string, "\" \"");
        string[1] = x;
        strcpy(t_holder, string);
        a_bort(ab_code,ln);
    }
    else
    {
        _GetChar();
        SkipWhite();
    }
}
/*---------- end Match ----------*/



int IsAddop(char ch)              /* Recognize an Addop */
{   int ibool=0;


    if((ch == '+') || (ch == '-'))
    {
        ibool = 1;
    }

    return ibool;
}
/*---------- end IsAddop ----------*/



int IsMultop(char ch)             /* Recognize an Addop */
{   int ibool=0;


    if(strchr("*^/%", ch))
    {
        ibool = 1;
    }

    return ibool;
}
/*---------- end IsMultop ----------*/



int Is_White(char ch)
{   int ibool=0;


    if((ch == ' ') || (ch == '\t'))
    {
        ibool = -1;
    }

    return ibool;
}
/*---------- end Is_White ----------*/



void _GetChar()
{
    e_pos++;                      /* advance pointer */
}
/*---------- end _GetChar ----------*/



void SkipWhite()                  /* Skip Over Leading White Space */
{   char ch;
    int pi;


    pi = e_pos;
    ch = p_string[pi];

    while(Is_White(ch))
    {
        _GetChar();               /* advance & save pointer */
        pi = e_pos;
        ch = p_string[pi];
    }
}
/*---------- end SkipWhite ----------*/



void get_CVI()               /* convert an I/O buffer string to a number */
{   char varname[VAR_NAME];       /* a% = CVI(string$) */
    int pi, len;


    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;
    strcpy(varname, get_varname());

    write_str("  mov  esi, [");
    write_str(varname);
    writeln("]");

    if(var_type == 5)             /* check global type variable */
    {
        writeln("  mov  edi, offset qLVAR");
        writeln("  call mkqstr");
        writeln("  FILD   qLVAR");

        asnmkqstr = 1;
    }
    else
    {
        writeln("  mov  edi, offset iLVAR");
        writeln("  call mkistr");
        writeln("  FILD   iLVAR");

        asnmkistr = 1;
    }
}
/*---------- end get_CVI ----------*/



void get_CVD()               /* convert an I/O buffer string to a number */
{   char varname[VAR_NAME];       /* a# = CVD(string$) */
    int pi, len;                  /* a! = CVS(string$) */


    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;
    strcpy(varname, get_varname());

    write_str("  mov  esi, [");
    write_str(varname);
    writeln("]");
    writeln("  mov  edi, offset qLVAR");
    writeln("  call mkdstr");
    writeln("  FLD   qLVAR");

    asnmkdstr = 1;
}
/*---------- end get_CVD ----------*/



void get_LEN()                    /* get string length */
{   char varname[VAR_NAME];       /* num = LEN(string$) */
    int pi, len, type, xcnt;


    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;
    strcpy(varname, get_varname());
    type = get_ObjectType(varname);    /* object type specifier */

    if(type == 6)                 /* source is an array-string */
    {
        pi = e_pos;
        pi = get_paren(pi, len);
        xcnt = get_ObjectParm(varname);
        get_offset(varname, len, xcnt);

        writeln("  mov  eax, [edi]");  /* load string address to EAX */
    }
    else
    {
        write_str("  mov  eax, [");
        write_str(varname);
        writeln("]");
    }

    writeln("  invoke strlen, eax");
    writeln("  mov  iLVAR, eax");
    writeln("  FILD  iLVAR");
}
/*---------- end get_LEN ----------*/



void get_INT()               /* make a float number an integer */
{                            /* a% = INT(float#) */
    a_Factor();

    writeln("  invoke FpuTrunc, 0, 0, SRC1_FPU or DEST_FPU");
}
/*---------- end get_INT ----------*/



void get_SQRT()              /* get the square root of a number */
{                            /* a! = SQRT(num) */
    a_Factor();

    writeln("  FSTP  qLVAR");
    writeln("  invoke sqrt, qLVAR");   /* double value is in ST(0) */
}
/*---------- end get_SQRT ----------*/



void get_TANH()              /* get the hyperbolic tangent of a number */
{                            /* a# = TANH(num) */
    a_Factor();

    writeln("  FSTP  qLVAR");
    writeln("  invoke tanh, qLVAR");   /* double value is in ST(0) */
}
/*---------- end get_TANH ----------*/



void get_TAN()               /* get the tangent of a number */
{                            /* a# = TAN(num) */
    a_Factor();

    writeln("  FSTP  qLVAR");
    writeln("  invoke tan, qLVAR");    /* double value is in ST(0) */
}
/*---------- end get_TAN ----------*/



void get_SINH()              /* get the hyperbolic sine of a number */
{                            /* a# = SINH(num) */
    a_Factor();

    writeln("  FSTP  qLVAR");
    writeln("  invoke sinh, qLVAR");   /* double value is in ST(0) */
}
/*---------- end get_SINH ----------*/



void get_SIN()               /* get the sine of a number */
{                            /* a# = SIN(num) */
    a_Factor();

    writeln("  FSTP  qLVAR");
    writeln("  invoke sin, qLVAR");    /* double value is in ST(0) */
}
/*---------- end get_SIN ----------*/



void get_COSH()              /* get the hyperbolic cosine of a number */
{                            /* a# = COSH(num) */
    a_Factor();

    writeln("  FSTP  qLVAR");
    writeln("  invoke cosh, qLVAR");   /* double value is in ST(0) */
}
/*---------- end get_COSH ----------*/



void get_COS()               /* get the cosine of a number */
{                            /* a# = COS(num) */
    a_Factor();

    writeln("  FSTP  qLVAR");
    writeln("  invoke cos, qLVAR");    /* double value is in ST(0) */
}
/*---------- end get_COS ----------*/



void get_ATAN2()             /* get the arctangent of 2 numbers */
{                            /* a# = ATAN2(num,num) */
    int pi, len;


    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;

    a_Factor();

    writeln("  FSTP  qLVAR");

    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;

    a_Factor();

    writeln("  FSTP  qRVAR");     /* double value is in ST(0) */
    writeln("  invoke atan2, qLVAR, qRVAR");
}
/*---------- end get_ATAN2 ----------*/



void get_ATN()               /* get the arctangent of a number */
{                            /* a# = ATN(num) */
    a_Factor();

    writeln("  FSTP  qLVAR");
    writeln("  invoke atan, qLVAR");   /* double value is in ST(0) */
}
/*---------- end get_ATN ----------*/



void get_ASC()                    /* get the ascii value of a character */
{   char varname[VAR_NAME], temp[6];    /* a = ASC(chr$) */
    int pi, len, type, xcnt, mark;


    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;
    strcpy(varname, get_varname());

    strcpy(temp, "VARX");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;

    type = get_ObjectType(varname);    /* object type specifier */

    if(type == 6)                      /* source is an array-string */
    {
        pi = e_pos;
        pi = get_paren(pi, len);
        xcnt = get_ObjectParm(varname);
        get_offset(varname, len, xcnt);

        writeln("  mov  esi, [edi]");  /* load string address to ESI */
    }
    else if(mark == pi)                /* this is a temp var-name */
    {
        write_str("  mov  esi, offset ");
        write_str(varname);
        writeln("\t\t\t; load temp variable address");
    }
    else
    {
        write_str("  mov  esi, [");
        write_str(varname);
        writeln("]");
    }

    writeln("  xor  eax, eax");
    writeln("  mov  al,  [esi]");
    writeln("  mov  iLVAR, eax");
    writeln("  FILD  iLVAR");
}
/*---------- end get_ASC ----------*/



void get_ABS()               /* get the absolute value of a number */
{                            /* a% = ABS(num) */
    a_Factor();

    writeln("  FISTP  iLVAR");
    writeln("  invoke abs, iLVAR");
    writeln("  mov   iLVAR, eax");     /* integer value is in eax */
    writeln("  FILD  iLVAR");
}
/*---------- end get_ABS ----------*/



void get_ASIN()              /* get the arc sine of a number */
{                            /* a# = ASIN(num) */
    a_Factor();

    writeln("  FSTP  qLVAR");
    writeln("  invoke asin, qLVAR"); 	/* double value is in ST(0) */
}
/*---------- end get_ASIN ----------*/



void get_ACOS()              /* get the arc cosine of a number */
{                            /* a# = ACOS(num) */
    a_Factor();

    writeln("  FSTP  qLVAR");
    writeln("  invoke acos, qLVAR");   /* double value is in ST(0) */
}
/*---------- end get_ACOS ----------*/



void get_CEIL()              /* get the ceiling of a number */
{                            /* a# = CEIL(num) */
    a_Factor();

    writeln("  FSTP  qLVAR");
    writeln("  invoke ceil, qLVAR");   /* double value is in ST(0) */
}
/*---------- end get_CEIL ----------*/



void get_FLOOR()             /* get the floor of a number */
{                            /* a# = FLOOR(num) */
    a_Factor();

    writeln("  FSTP  qLVAR");
    writeln("  invoke floor, qLVAR");  /* double value is in ST(0) */
}
/*---------- end get_FLOOR ----------*/



void get_HYPOT()             /* get the hypotenuse of 2 numbers */
{                            /* a# = HYPOT(num,num) */
    int pi, len;


    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;

    a_Factor();

    writeln("  FSTP  qLVAR");

    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;

    a_Factor();

    writeln("  FSTP  qRVAR");          /* double value is in ST(0) */
    writeln("  invoke _hypot, qLVAR, qRVAR");
}
/*---------- end get_HYPOT ----------*/



void get_LOG()               /* get the log of a number */
{                            /* a# = LOG(num) */
    a_Factor();

    writeln("  FSTP  qLVAR");
    writeln("  invoke log, qLVAR");    /* double value is in ST(0) */
}
/*---------- end get_LOG ----------*/



void get_LOG10()             /* get the log10 of a number */
{                            /* a# = LOG10(num) */
    a_Factor();

    writeln("  FSTP  qLVAR");
    writeln("  invoke log10, qLVAR");  /* double value is in ST(0) */
}
/*---------- end get_LOG10 ----------*/



void get_RAND()              /* get a random number */
{   int pi;                  /* a = RAND() */

    writeln("  call  rand");
    writeln("  mov   iLVAR, eax");     /* integer value is in eax */
    writeln("  FILD  iLVAR");

    pi = e_pos;              /* xyz = RAND()... */
    pi += 2;                 /* ----------^     */
    pi = iswhiter(pi);
    e_pos = pi;
}
/*---------- end get_RAND ----------*/



void seed_rand()             /* seed random number generator */
{                            /* RANDOM(n) */
    a_Factor();

    writeln("  FISTP  iLVAR");
    writeln("  invoke srand, iLVAR");
}
/*---------- end seed_rand ----------*/



void get_CLOCK()             /* get clock ticks */
{                            /* a = CLOCK() */
    writeln("  call  clock");
    writeln("  mov   iLVAR, eax");     /* integer value is in eax */
    writeln("  FILD  iLVAR");
}
/*---------- end get_CLOCK ----------*/



void get_VAL()                    /* get value of ascii string */
{   char varname[VAR_NAME];       /* num = VAL(string$) */
    int pi, len, type, xcnt;


    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;

    strcpy(varname, get_varname());
    type = get_ObjectType(varname);    /* object type specifier */

    if(type == 6)                 /* source is an array-string */
    {
        pi = e_pos;
        pi = get_paren(pi, len);
        xcnt = get_ObjectParm(varname);
        get_offset(varname, len, xcnt);

        writeln("  mov  eax, [edi]");  /* load string address to EAX */
    }
    else
    {
        write_str("  mov  eax, [");
        write_str(varname);
        writeln("]");
    }

    writeln("  invoke StrToFloat, eax, addr qLVAR");
    writeln("  FLD  qLVAR");
}
/*---------- end get_VAL ----------*/



void get_LOC()
{   char fptr[4];        /* num = LOC(1) */
    int pi, len, ival, ab_code=27, x=line_ndx;
    double value;


    len = strlen(p_string);
    pi = e_pos;
    pi = get_digit(pi, len);

    if(pi >= len)
    {   a_bort(ab_code, x);
    }

    e_pos = pi;
    value = get_avalue();
    ival = (int) value;
    ival--;
    sprintf(fptr, "%d", ival);

    write_str("  mov  eax, ");
    writeln(fptr);
    writeln("  call getfilehandle");
    writeln("  invoke ftell, eax");
    writeln("  mov   iLVAR, eax");     /* integer value is in eax */
    writeln("  FILD  iLVAR");

    getfilehandle = 1;
}
/*---------- end get_LOC ----------*/



void get_LOF()
{   char fptr[4];        /* num = LOF(1) */
    int pi, len, ival, ab_code=27, x=line_ndx;
    double value;


    len = strlen(p_string);
    pi = e_pos;
    pi = get_digit(pi, len);

    if(pi >= len)
    {
        a_bort(ab_code, x);
    }

    e_pos = pi;
    value = get_avalue();
    ival = (int) value;
    ival--;
    sprintf(fptr, "%d", ival);

    write_str("  mov  eax, ");
    writeln(fptr);
    writeln("  call getfilelength");

    getfilelength = 1;
    getfilehandle = 1;
}
/*---------- end get_LOF ----------*/



void get_EOF()
{   char fptr[4];            /* num = EOF(1) */
    int pi, len, ival, ab_code=27, x=line_ndx;
    double value;


    len = strlen(p_string);
    pi = e_pos;
    pi = get_digit(pi, len);

    if(pi >= len)
    {
        a_bort(ab_code, x);
    }

    e_pos = pi;
    value = get_avalue();
    ival = (int) value;
    ival--;
    sprintf(fptr, "%d", ival);

    write_str("  mov  eax, ");
    writeln(fptr);
    writeln("  call getfilehandle");
    writeln("  invoke feof, eax");
    writeln("  mov   iLVAR, eax");     /* integer value is in eax */
    writeln("  FILD  iLVAR");

    getfilehandle = 1;
}
/*---------- end get_EOF ----------*/



void get_SECONDS()           /* a! = SECONDS() */
{                            /* number of seconds since: 0:0:0 GMT */

    writeln("  invoke  time, ADDR iSecond ");
    writeln("  FILD  iSecond");

}
/*------ end get_SECONDS ------*/



void get_DRIVE()             /* a = DRIVE() */
{                            /* returns the current drive number; */

    writeln("  call  _getdrive \t\t; returns the current drive number");
    writeln("  mov   iLVAR, eax");     /* integer value is in eax */
    writeln("  FILD  iLVAR");

}
/*------ end get_DRIVE ------*/



void get_EXP()               /* a# = EXP(num) */
{                            /* returns the natural exponent of number */
    a_Factor();

    writeln("  FSTP  qLVAR");
    writeln("  invoke exp, qLVAR");    /* double value is in ST(0) */

}
/*------ end get_EXP ------*/



void get_FABS()              /* a# = FABS(num) */
{                            /* returns the absolute value of a */
    a_Factor();              /* floating point number */

    writeln("  FABS ");

}
/*------ end get_FABS ------*/



void get_FMOD()              /* a# = FMOD(n1,n2) */
{   int pi, len;             /* calculates the floating point */
                             /* remainder of a n1 divided by n2 */

    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;

    a_Factor();

    writeln("  FSTP  qLVAR");

    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;

    a_Factor();

    writeln("  FSTP  qRVAR");
    writeln("  invoke fmod, qLVAR, qRVAR");

}
/*------ end get_FMOD ------*/



void get_LDEXP()             /* a# = LDEXP(n1,n2) */
{   int pi, len;             /* calculates n1 times 2, raised to */
                             /* the power of n2 */

    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;

    a_Factor();

    writeln("  FSTP  qLVAR");

    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;

    a_Factor();

    writeln("  FISTP  iRVAR");
    writeln("  invoke ldexp, qLVAR, iRVAR");

}
/*------ end get_LDEXP ------*/



void get_MODF()                   /* a# = MODF(n1,n2) */
{   char varname[VAR_NAME];       /* returns the fractional part of n1, */
    int pi, len;                  /* the whole part is stored in n2 */


    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;

    a_Factor();

    writeln("  FSTP  qLVAR");

    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;

    strcpy(varname, get_varname());		/* get n2 variable name */

    write_str("  invoke modf, qLVAR, addr ");
    writeln(varname);                  /* double varname */

}
/*------ end get_MODF ------*/



void get_POW()               /* a# = POW(n1,n2) */
{   int pi, len;             /* calculates n1 raised to the n2 power */


    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;

    a_Factor();

    writeln("  FSTP  qLVAR");

    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;

    a_Factor();

    writeln("  FSTP  qRVAR");
    writeln("  invoke pow, qLVAR, qRVAR");

}
/*------ end get_POW ------*/



void get_POW10()             /* a# = POW10(num) */
{   int pi, len;             /* calculates 10 raised to the power of num */


    writeln("  mov   eax, 10");
    writeln("  mov   iLVAR, eax");
    writeln("  FILD  iLVAR");
    writeln("  FSTP  qLVAR");

    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;

    a_Factor();

    writeln("  FSTP  qRVAR");
    writeln("  invoke pow, qLVAR, qRVAR");

}
/*------ end get_POW10 ------*/



void get_FREXP()             /* a# = FREXP(n1,n2) */
{   char varname[VAR_NAME];  /* Returns the mantissa of a floating point */
    int pi, len;             /* number (n1), as a normalized fraction. */
                        /* The power of 2 exponent of n1 is stored in n2. */

    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;

    a_Factor();

    writeln("  FSTP  qLVAR");

    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;

    strcpy(varname, get_varname());    /* get n2 variable name */

    write_str("  invoke frexp, qLVAR, addr ");
    writeln(varname);                  /* integer varname */

}
/*------ end get_FREXP ------*/



void get_LABS()
{                           /* a% = LABS(num%) */
    a_Factor();             /* returns the absolute value of a */
                            /* long number */
    writeln("  FISTP  iLVAR");
    writeln("  invoke labs, iLVAR");
    writeln("  mov   iLVAR, eax");     /* integer value is in eax */
    writeln("  FILD  iLVAR");

}
/*---------- end get_LABS ----------*/



void get_HiRezTimer()
{
    writeln("  call get_HiRez_Timer");
    writeln("  FLD qRVAR");

    hrtimer = 1;
}
/*---------- end get_HiRezTimer ----------*/



void get_SGN()                         /* a# = SGN(num) */
{   char Label1[LLEN], Label2[LLEN];   /* determines if num is */
                                       /* positive or negative */

    strcpy(Label1, get_NewLabel());    /* --- get unique labels --- */
    strcpy(Label2, get_NewLabel());

    a_Factor();

    writeln("  FLDZ \t\t\t; load zero");
    writeln("  FCOMP ST(1) \t\t; compare value to zero");
    writeln("  FSTSW AX \t\t\t; save status word to AX");
    writeln("  SAHF \t\t\t; store AH to flags register");
    write_str("  jnc ");
    writeln(Label1);
    writeln("  FLD1 \t\t\t; sign is positive");
    write_str("  jmp ");
    writeln(Label2);
    PostLabel(Label1);
    writeln("  FLDZ \t\t\t; sign is negative");
    PostLabel(Label2);

}
/*---------- end get_SGN ----------*/



void get_MODii()             /* a = MOD(n1,n2) */
{   int pi, len;


    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;

    a_Factor();

    writeln("  FSTP  qLVAR");

    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;

    a_Factor();

    writeln("  FSTP  qRVAR");
    writeln("  invoke fmod, qLVAR, qRVAR"); /* double value is in ST(0) */

}
/*---------- end get_MODii ----------*/



void get_CINT()              /* a = CINT(num#) */
{                            /* converts number to integer */
    a_Factor();              /* by rounding up */

    writeln("  FRNDINT \t\t\t ; converts number to integer");

}
/*---------- end get_CINT ----------*/



void get_CDBL()
{                       /* a# = CDBL(num) */
                        /* converts number to Double */
    a_Factor();

}
/*---------- end get_CDBL ----------*/



void get_CSNG()
{                       /* a! = CSNG(num#) */
                        /* converts number to Single */
    a_Factor();

}
/*---------- end get_CSNG ----------*/



void get_CLNG()
{                       /* a% = CLNG(num#) */
                        /* converts number to long by rounding up */
    a_Factor();
    writeln("  FRNDINT \t\t\t ; converts number to integer");

}
/*---------- end get_CLNG ----------*/














