/* bxbasm : AString.c : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012       */



/* ----- includes ----- */
#include "prototyp.h"



void asn_string(char *name)
{   char varname[VAR_NAME];
    int pi;


    strcpy(varname, name);        /* get destination */
    pi = e_pos;
    pi = iswhite(pi);
    e_pos = pi;

    Match('=');

    writeln("; --------------------------------------------------");
    writeln("  lea  eax, StringBffr");
    writeln("  mov  [eax], byte ptr 0\t\t; clear string-copy buffer");

    asnStr_express(varname);      /* now get assignment string */

    write_str("  mov  edi, [");   /* make string assignment */
    write_str(varname);
    write_str("]");
    writeln("\t\t\t; load address-pointer");
    writeln("  call copystrng_bffr\t\t; alloc memory and copy");
    write_str("  mov  ");
    write_str(varname);
    writeln(", eax\t\t\t; store address-pointer");
}
/*---------- end asn_string ----------*/



void asnStr_express(char *name)
{   char ch, varname[VAR_NAME];
    int pi, len;


    strcpy(varname, name);
    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];

    if(isdigit(ch))
    {
        asn_function(len);        /* copy a string function */
        stringcopy = 1;           /* global flag */
    }
    else
    {
        copy_string(len);         /* copy a variable */
        stringcopy = 1;           /* global flag */
    }

    pi = e_pos;
    pi++;
    pi = iswhite(pi);
    e_pos = pi;

}
/*---------- end asnStr_express ----------*/



void parse_str(char *name)
{   char varname[VAR_NAME];
    int pi;


    strcpy(varname, name);   /* get destination */
    pi = e_pos;
    pi = iswhite(pi);
    e_pos = pi;

    Match('=');

    writeln("; --------------------------------------------------");
    writeln("  lea  eax, StringBffr");
    writeln("  mov  [eax], byte ptr 0\t\t; clear string-copy buffer");

    str_express(varname);         /* now get assignment string */

    write_str("  mov  edi, [");   /* make string assignment */
    write_str(varname);
    write_str("]");
    writeln("\t\t\t; load address-pointer");
    writeln("  call copystrng_bffr\t\t; alloc memory and copy");
    write_str("  mov  ");
    write_str(varname);
    writeln(", eax\t\t\t; store address-pointer");
}
/*---------- end parse_str ----------*/



void str_express(char *name)
{   char ch, varname[VAR_NAME], temp[3];
    int pi, len, mark, catflag=0, copyflag=0;


    strcpy(varname, name);
    len = strlen(p_string);
    pi = e_pos;

    strcpy(temp, "+");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;

    if(mark > 0)             /* does this concatenate a string ? */
    {
        catflag = 1;
    }

    while(pi < len)
    {
        ch = p_string[pi];

        if(isdigit(ch))
        {
            if((catflag == 1) && (copyflag == 1))
            {
                cat_function(len);     /* cat a string function */
            }
            else
            {
                asn_function(len);     /* copy a string function */
                stringcopy = 1;        /* global flag */
                copyflag = 1;          /* local flag */
            }
        }
        else
        {
            if((catflag == 1) && (copyflag == 1))
            {
                cat_string(len);       /* concatenate a variable */
            }
            else
            {
                copy_string(len);      /* copy a variable */
                stringcopy = 1;        /* global flag */
                copyflag = 1;          /* local flag */
            }
        }

        pi = e_pos;
        pi++;
        pi = iswhite(pi);
        e_pos = pi;

        if(pi < len)
        {
            Match('+');      /* concatenate symbol */
            pi = e_pos;
        }
    }
}
/*---------- end str_express ----------*/



void cat_function(int len)
{   int type;


    type = (int) get_avalue();
    string_functions(len,type);

    writeln("  call catstrng");
}
/*---------- end cat_function ----------*/



void asn_function(int len)
{   int type;


    type = (int) get_avalue();
    string_functions(len,type);

    writeln("  call copystrng");
}
/*---------- end asn_function ----------*/



void string_functions(int len, int type)
{
    switch(type)
    {   case 1:
            chrstr(len);          /* a$ = CHR$(n) */
            break;
        case 2:
            leftstr(len);         /* a$ = LEFT$(x$,n) */
            break;
        case 3:
            rightstr(len);        /* a$ = RIGHT$(x$,n) */
            break;
        case 4:
            midstr(len);          /* a$ = MID$(x$,n,n) */
            break;
        case 5:
            spacestr(len);        /* a$ = SPACE$(n) */
            break;
        case 6:
            strsval(len);         /* a$ = STR$(n) */
            break;
        case 7:
            stringstr(len);       /* a$ = STRING$(n,c) */
            break;
        case 8:
            inkeystr();           /* a$ = INKEY$ */
            break;
        case 9:
            inputstr(len);        /* a$ = INPUT$(n) */
            break;
        case 10:                  /* LSET a$ = MKD$(n) */
        case 11:                  /* LSET a$ = MKI$(n) */
        case 12:                  /* LSET a$ = MKS$(n) */
            break;
        case 13:
            datestr();            /* a$ = DATE$ */
            break;
        case 14:
            timestr();            /* a$ = TIME$ */
            break;
        case 15:
            ucasestr();           /* a$ = UCASE$(x$) */
            break;
        case 16:
            lcasestr();           /* a$ = LCASE$(x$) */
            break;

        default:
            /* error */
            break;
    }
}
/*---------- end string_functions ----------*/





void get_INSTR()
{   char source[BUFSIZE], sample[BUFSIZE];
    char Label1[LLEN];       /* INSTR returns the position,     */
    char ch;                 /* within the source string, where */
    int pi, len;             /* sample string begins.           */
                             /* Otherwise, it returns zero      */

    strcpy(Label1, get_NewLabel());    /* --- get unique labels --- */

    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];

    if(ch == '(')
    {                                     /* advance past left paren */
        pi++;
        pi = iswhiter(pi);
        e_pos = pi;
    }

    strcpy(source, get_varname());    /* get the source */
    pi = e_pos;
    pi = get_alpha(pi, len);           /* advance to varname */
    e_pos = pi;
    strcpy(sample, get_varname());    /* get the sample */

    write_str("  invoke strlen, ");
    writeln(source);
    writeln("  mov iLVAR, eax");
    write_str("  invoke strlen, ");
    writeln(sample);
    writeln("  mov iRVAR, eax");
    writeln(";");
    writeln("  FLDZ");
    writeln("  mov eax, iLVAR");
    writeln("  mov ebx, iRVAR");
    writeln("  cmp eax, ebx");
    write_str("  jl ");
    writeln(Label1);
    writeln(";");
    write_str("  mov eax, [");
    write_str(source);
    writeln("]");
    writeln("  mov iLVAR, eax");
    write_str("  invoke strstr, ");
    write_str(source);
    write_str(", ");
    writeln(sample);
    writeln("  mov iRVAR, eax");
    writeln("  .if iRVAR != NULL");
    writeln("      FILD iRVAR");
    writeln("      FILD iLVAR");
    writeln("      FSUBP ST(1), ST");
    writeln("      FLD1");
    writeln("      FADDP ST(1), ST");
    writeln("  .endif");
    PostLabel(Label1);
    writeln(";");

}
/*---------- end get_INSTR ----------*/



void lcasestr()
{   char varname[VAR_NAME];       /* a$ = LCASE$(q$) */
    int pi;

    pi = e_pos;                  /* pi enters pointing to: ( */
    pi++;                        /* advance to first alpha: q$) */
    pi = iswhite(pi);
    e_pos = pi;

    strcpy(varname, get_varname());

    writeln("  push eax ");
    write_str("  invoke  _strlwr, ");
    write_str(varname);
    writeln("\t\t; CRT function str-to-lowercase");
    writeln("  mov esi, eax ");
    writeln("  pop eax ");

}
/*------ end lcasestr ------*/



void ucasestr()
{   char varname[VAR_NAME];       /* a$ = UCASE$(q$) */
    int pi;


    pi = e_pos;                  /* pi enters pointing to: ( */
    pi++;                        /* advance to first alpha: q$) */
    pi = iswhite(pi);
    e_pos = pi;

    strcpy(varname, get_varname());

    writeln("  push eax ");
    write_str("  invoke  _strupr, ");
    write_str(varname);
    writeln("\t\t; CRT function str-to-uppercase");
    writeln("  mov esi, eax ");
    writeln("  pop eax ");

}
/*------ end ucasestr ------*/



void mkistr(int len)         /* LSET a$ = MKI$(n%) */
{   char srcname[VAR_NAME];
    int pi, type;

/* this function is called by LSET !!! */

    pi = e_pos;                   /* pi enters pointing to: "(" */
    pi = get_alpha(pi, len);      /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());    /* get value variable name */
    type = get_ObjectType(srcname);    /* object type specifier */

    if(type == 5)
    {
        write_str("  mov  esi, offset ");
        writeln(srcname);
        writeln("  call mkqstr");

        asnmkqstr = 1;
    }
    else
    {
        write_str("  mov  esi, offset ");
        writeln(srcname);
        writeln("  call mkistr");

        asnmkistr = 1;
    }
}
/*------ end mkistr ------*/



void mkdstr(int len)              /* LSET a$ = MKD$(n) */
{   char srcname[VAR_NAME];       /* LSET a$ = MKS$(n) */
    int pi;

/* this function is called by LSET !!! */

    pi = e_pos;                   /* pi enters pointing to: "(" */
    pi = get_alpha(pi, len);      /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());    /* get value variable name */

    write_str("  mov  esi, offset ");
    writeln(srcname);
    writeln("  call mkdstr");

    asnmkdstr = 1;
}
/*------ end mkdstr ------*/



void timestr()               /* a$ = TIME$ */
{
    writeln("  call timestr");

    asntimestr = 1;
    getsystime = 1;
}
/*---------- end timestr ----------*/



void datestr()               /* a$ = DATE$ */
{
    writeln("  call datestr");

    asndatestr = 1;
    getsysdate = 1;
}
/*---------- end datestr ----------*/



void inputstr(int len)            /* a$ = INPUT$(num) */
{   char srcname[VAR_NAME];
    int pi;


    pi = e_pos;                   /* pi enters pointing to: "(" */
    pi = get_alpha(pi, len);      /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());    /* get count variable name */

    write_str("  mov  eax, ");
    write_str(srcname);
    writeln("\t\t\t; load the count");

    writeln("  call inputstr");

    asninputstr = 1;
}
/*---------- end inputstr ----------*/



void inkeystr()              /* a$ = INKEY$ */
{
    writeln("  call inkeystr");

    asninkeystr = 1;
}
/*---------- end inkeystr ----------*/



void stringstr(int len)      /* STRING$(number, character) */
{   char srcname[VAR_NAME];
    int pi, type;


    pi = e_pos;                   /* pi enters pointing to: "(" */
    pi = get_alpha(pi, len);      /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());    /* get count variable name */

    write_str("  mov  eax, ");
    write_str(srcname);
    writeln("\t\t\t; load the count");

    pi = e_pos;
    pi = get_alpha(pi, len);      /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());    /* get character variable name */
    type = get_ObjectType(srcname);    /* object type specifier */
    pi = e_pos;

    if(type == 0)
    {
        write_str("  mov  esi, offset ");
        write_str(srcname);
        writeln("\t\t\t; load temp variable address");
        writeln("  mov  ebx, [esi]");

        pi = get_paren(pi, len);
        e_pos = pi;
    }
    else
    {
        write_str("  mov  ebx, ");
        write_str(srcname);
        writeln("\t\t\t; load value");
    }

    writeln("  call stringstr");

    asnstringstr = 1;
}
/*---------- end stringstr ----------*/



void strsval(int len)             /* STR$(value) */
{   char srcname[VAR_NAME], tmp[2]={0,0};
    int pi, type;


    pi = e_pos;                   /* pi enters pointing to: "(" */
    pi = get_alpha(pi, len);      /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());    /* get value variable name */
    type = get_ObjectType(srcname);    /* object type specifier */
    pi = e_pos;

    if(type != 1)
    {
        pi = get_paren(pi, len);
        e_pos = pi;
    }

    if(type < 3)                  /* integer values */
    {
        write_str("  mov  eax, ");
        write_str(srcname);
        writeln("\t\t\t; load the value");
        writeln("  mov  integer, eax");
        writeln("  call strsIval");

        asnstrsIval = 1;
    }
    else                          /* float values */
    {
        write_str("  FLD  ");
        writeln(srcname);
        writeln("  FSTP x87buff");
        writeln("  call strsFval");

        asnstrsFval = 1;
    }
}
/*---------- end strsval ----------*/



void spacestr(int len)       /* SPACE$(number) */
{   char srcname[VAR_NAME];
    int pi;


    pi = e_pos;                   /* pi enters pointing to: "(" */
    pi = get_alpha(pi, len);      /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());    /* get count variable name */

    write_str("  mov  eax, ");
    write_str(srcname);
    writeln("\t\t\t; load the count");
    writeln("  call spacestr");

    asnspacestr = 1;
}
/*---------- end spacestr ----------*/



void midstr(int len)              /* MID$(a$, start, number) */
{   char srcname[VAR_NAME], temp[6];
    int pi, mark;


    pi = e_pos;                   /* pi enters pointing to: "(" */
    pi = get_alpha(pi, len);      /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());    /* get source string name */

    strcpy(temp, "VARX");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;

    if(mark == pi)           /* this is a temp var-name */
    {
        write_str("  mov  esi, offset ");
        write_str(srcname);
        writeln("\t\t\t; load temp variable address");
    }
    else
    {
        write_str("  mov  esi, ");
        write_str("[");
        write_str(srcname);
        write_str("]");
        writeln("\t\t\t; address of source string");
    }

    pi = e_pos;
    pi = get_alpha(pi, len);           /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());    /* get the start position */

    write_str("  mov  ebx, ");
    write_str(srcname);
    writeln("\t\t\t; load the start");
    writeln("  dec  ebx");

    pi = e_pos;
    pi = get_alpha(pi, len);           /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());    /* get the count */

    write_str("  mov  eax, ");
    write_str(srcname);
    writeln("\t\t\t; load the count");
    writeln("  call mid_str");

    asnmidstr = 1;
}
/*---------- end midstr ----------*/



void rightstr(int len)            /* RIGHT$(a$, number) */
{   char srcname[VAR_NAME], temp[6];
    int pi, mark;


    pi = e_pos;                   /* pi enters pointing to: "(" */
    pi = get_alpha(pi, len);      /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());    /* get source string name */

    strcpy(temp, "VARX");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;

    if(mark == pi)           /* this is a temp var-name */
    {
        write_str("  mov  esi, offset ");
        write_str(srcname);
        writeln("\t\t\t; load temp variable address");
    }
    else
    {
        write_str("  mov  esi, ");
        write_str("[");
        write_str(srcname);
        write_str("]");
        writeln("\t\t\t; address of source string");
    }

    pi = e_pos;
    pi = get_alpha(pi, len);           /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());    /* get the count */

    write_str("  mov  eax, ");
    write_str(srcname);
    writeln("\t\t\t; load the count");
    writeln("  call rightstr");

    asnrightstr = 1;
}
/*---------- end rightstr ----------*/



void leftstr(int len)             /* LEFT$(a$, number) */
{   char srcname[VAR_NAME], temp[6];
    int pi, mark;


    pi = e_pos;                   /* pi enters pointing to: "(" */
    pi = get_alpha(pi, len);      /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());    /* get source string name */

    strcpy(temp, "VARX");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;

    if(mark == pi)           /* this is a temp var-name */
    {
        write_str("  mov  esi, offset ");
        write_str(srcname);
        writeln("\t\t\t; load temp variable address");
    }
    else
    {
        write_str("  mov  esi, ");
        write_str("[");
        write_str(srcname);
        write_str("]");
        writeln("\t\t\t; address of source string");
    }

    pi = e_pos;
    pi = get_alpha(pi, len);      /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());    /* get the count */

    write_str("  mov  eax, ");
    write_str(srcname);
    writeln("\t\t\t; load the count");
    writeln("  call leftstr");

    asnleftstr = 1;
}
/*---------- end leftstr ----------*/



void chrstr(int len)              /* CHR$(ascii character) */
{   char srcname[VAR_NAME];
    int pi;


    pi = e_pos;                   /* pi enters pointing to: "(" */
    pi = get_alpha(pi, len);      /* advance to varname */
    e_pos = pi;

    strcpy(srcname, get_varname());

    write_str("  mov  eax, ");
    write_str(srcname);
    writeln("\t\t\t; load the ascii value");
    writeln("  call chrstr");

    asnchrstr = 1;
}
/*---------- end chrstr ----------*/



void cat_string(int len)
{   char srcname[VAR_NAME], temp[6];
    int pi, mark, type;


    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;
    strcpy(srcname, get_varname());
    type = get_ObjectType(srcname);    /* object type specifier */

    if(type == 6)
    {
        e_pos = pi;
        cat_strarry();       /* source is an array-string */
    }
    else
    {
        strcpy(temp, "VARX");
        s_pos = pi;
        mark = find_strng(temp);
        mark--;

        if(mark == pi)       /* this is a temp var-name */
        {
            write_str("  mov  esi, offset ");
            write_str(srcname);
            writeln("\t\t\t; load temp variable address");
        }
        else                 /* this is a real var-name */
        {
            write_str("  mov  esi, [");
            write_str(srcname);
            write_str("]");
            writeln("\t\t\t; load real variable address");
        }

        writeln("  call catstrng");
    }
}
/*---------- end cat_string ----------*/



void copy_string(int len)
{   char srcname[VAR_NAME], temp[6];
    int pi, mark, type;


    pi = e_pos;              /* get source varname */
    pi = get_alpha(pi, len);
    e_pos = pi;
    strcpy(srcname, get_varname());
    type = get_ObjectType(srcname);    /* object type specifier */

    if(type == 6)
    {
        e_pos = pi;
        asn_strarry();            /* source is an array-string */
    }
    else
    {
        strcpy(temp, "VARX");
        s_pos = pi;
        mark = find_strng(temp);
        mark--;

        if(mark == pi)            /* this is a temp var-name */
        {
            write_str("  mov  esi, offset ");
            write_str(srcname);
            writeln("\t\t\t; load temp variable address");
        }
        else                      /* this is a real var-name */
        {
            write_str("  mov  esi, [");
            write_str(srcname);
            write_str("]");
            writeln("\t\t\t; load a real variable address");
        }

        writeln("  call copystrng");
    }
}
/*---------- end copy_string ----------*/



void asn_strarry()	         /* assign an array string */
{   char varname[VAR_NAME];
    int pi, len, xcnt;


    strcpy(varname, get_varname());    /* enter: a$ = array$(n,...) */

    len = strlen(p_string);
    pi = e_pos;
    pi = get_paren(pi, len);
    xcnt = get_ObjectParm(varname);
    get_offset(varname, len, xcnt);

    writeln("  mov  esi, [edi]");      /* load string address to ESI */
    writeln("  call copystrng");
}
/*---------- end asn_strarry ----------*/



void cat_strarry()           /* cat an array string */
{   char varname[VAR_NAME];
    int pi, len, xcnt;


    strcpy(varname, get_varname());    /* enter: a$ = array$(n,...) */

    len = strlen(p_string);
    pi = e_pos;
    pi = get_paren(pi, len);
    xcnt = get_ObjectParm(varname);
    get_offset(varname, len, xcnt);

    writeln("  mov  esi, [edi]");      /* load string address to ESI */
    writeln("  call catstrng");
}
/*---------- end cat_strarry ----------*/



























