/* Bxbasm : ASubs.c : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012     */



/* ----- function prototypes ----- */
#include "prototyp.h"





void do_callsub()            /* create a CALL subroutine */
{   char varname[VAR_NAME];
    int pi, ii, len, type, param;


    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;
    strcpy(varname, get_varname());    /* get SubName */

    pi = e_pos;
    pi = get_paren(pi, len);
    param = get_paramsCount(pi, len);  /* get number of parameters */

    if(param == 0)
    {
        write_str("  call ");
        writeln(varname);
    }
    else
    {
        write_str("  invoke ");
        write_str(varname);
        write_str(",");

        pi = get_alpha(pi, len);

        for(ii = 0; ii < param; ++ii)
        {
            e_pos = pi;
            strcpy(varname, get_varname()); /* get parameter name */
            pi = e_pos;

            write_str(" ");

            type = get_Nvtype(pi);

            switch(type)                    /* this is just-in-case */
            {   case 0:                     /* string       */
                    write_str(varname);
                    break;
                case 1:                     /* integer      */
                case 2:                     /* long integer */
                    write_str(varname);
                    break;
                case 3:                     /* single float */
                case 4:                     /* double float */
                    write_str(varname);
                    break;
                default:
                    break;
            }

            if(ii < (param - 1))
            {
                write_str(",");
            }

            pi = get_alpha(pi, len);
        }

        writeln(" ");
    }
}
/*------ end do_callsub ------*/



void Do_Sub()                /* create a SUB data file for output */
{   char varname[VAR_NAME];
    int pi, ii, len, type, param;
    int lndx;


    Switch_IOHandle();            /* switch I/O file handle */

    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;
    strcpy(varname, get_varname());    /* get SubName */
    strcpy(thisSubNam, varname);       /* store SubName */

    writeln("; --------------------------------------------------");
    write_str(varname);
    write_str("  proc  ");

    pi = e_pos;
    pi = get_paren(pi, len);
    param = get_paramsCount(pi, len);  /* get number of parameters */

    if(param > 0)
    {
        pi = get_alpha(pi, len);

        for(ii = 0; ii < param; ++ii)
        {
            e_pos = pi;
            strcpy(varname, get_varname()); /* get parameter name */
            pi = e_pos;

            write_str(" ");

            type = get_Nvtype(pi);

            switch(type)
            {   case 0:                     /* string       */
                    write_str(varname);
                    write_str(":dword");
                    break;
                case 1:                     /* integer      */
                case 2:                     /* long integer */
                    write_str(varname);
                    write_str(":dword");
                    break;
                case 3:                     /* single float */
                case 4:                     /* double float */
                    write_str(varname);
                    write_str(":qword");
                    break;
                default:
                    break;
            }

            if(ii < (param - 1))
            {
                write_str(",");
            }

            pi = get_alpha(pi, len);
        }

        writeln(" ");
    }
    else
    {
        writeln(" ");
    }

    writeln("; --------------------------------------------------");

    lndx = line_ndx;              /* save current line index */
    line_ndx++;
    get_token();

    while(token != 58)   /* while not ENDSUB */
    {
        e_pos = 0;
        s_pos = 0;

        switch(token)
        {
            case 46:              /* --- DIM: statement --- */
                PreScan_DimLocal();
                break;
            default:
                break;
        }

        line_ndx++;
        get_token();
    }

    line_ndx = lndx;              /* reset current line index */

}
/*------ end Do_Sub ------*/



void Do_EndSub()             /* finish up SUB data file */
{

    writeln("  ret");
    write_str(thisSubNam);
    writeln("  endp");
    writeln("; =========================================================================");

    Flip_IOHandle();              /* restore I/O handle */

}
/*------ end Do_EndSub ------*/



void Switch_IOHandle()            /* save original I/O handle */
{
    sub_iotemp = f_out;

    if(sw_sub_handle == 0)
    {
        f_out = fopen("q_subtemp.tmp","w"); /* open temp file */

        sw_sub_handle = 1;                  /* FLAG */
    }
    else
    {
        f_out = fopen("q_subtemp.tmp","a"); /* open temp file */
    }

}
/*------ end Switch_IOHandle ------*/



void Flip_IOHandle()              /* restore I/O handle */
{
    fclose(f_out);                /* close temp file */

    f_out = sub_iotemp;           /* switch back to original handle */

}
/*------ end Flip_IOHandle ------*/



void Do_sub_functions()      /* copy SUB data to output file */
{   char tmp_string[BUFSIZE];
    int x;


    if(sw_sub_handle == 1)
    {
        sub_iotemp = fopen("q_subtemp.tmp","r"); /* open temp file */

        while(!feof(sub_iotemp))
        {
            fgets(tmp_string, BUFSIZE, sub_iotemp);

            if(!feof(sub_iotemp))
            {
                write_str(tmp_string);      /* write data to file */
            }
            tmp_string[0] = '\0';
        }

        fclose(sub_iotemp);

        x = remove("q_subtemp.tmp");   /* if '0', successful */
    }

}
/*------ end Do_sub_functions ------*/



void PreScan_DimLocal()      /* search within SUBs for DIM statements */
{   char ch, varname[VAR_NAME];   /* turn DIM into LOCAL */
    int pi, len, type;


    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    ch = p_string[pi];

    while((ch != '\n') && (pi < len))
    {
        e_pos = pi;
        strcpy(varname, get_varname());    /* get variable name */
        pi = e_pos;
        type = get_ObjectType(varname);
        e_pos = pi;

        switch(type)
        {   case 0:                        /* string */
                write_str("  LOCAL ");
                write_str(varname);
                writeln(" :dword ");
                break;
            case 1:                        /* no type sign */
            case 2:                        /* long integer */
                write_str("  LOCAL ");
                write_str(varname);
                writeln(" :dword ");
                break;
            case 3:                        /* single float */
            case 4:                        /* double float */
                write_str("  LOCAL ");
                write_str(varname);
                writeln(" :qword ");
                break;
            default:
                break;
        }

        pi = e_pos;
        pi = get_rightExp(pi);    /* jump pi over this operator */
        pi = while_isalnum(pi);   /* jump over varname */
        pi = get_alpha(pi, len);
        ch = p_string[pi];
    }

}
/*------ end PreScan_DimLocal ------*/









