/* bxbasm : AUtils.c : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012      */



/* ----- function prototypes ----- */
#include "prototyp.h"




void Do_asm()                          /* write to asm file */
{
    write_str("  ");
    write_str(p_string);
}
/*---------- end Do_asm ----------*/



void write_str(char *string)           /* write to asm file */
{
    fprintf(f_out,"%s", string);
}
/*---------- end write_str ----------*/



void writeln(char *string)             /* write to asm file */
{
    write_str(string);

    fprintf(f_out, "\n");
}
/*---------- end writeln ----------*/



void s_write_str(char *string)         /* write to string temp file */
{
    fprintf(s_datatemp,"%s", string);
}
/*---------- end s_write_str ----------*/



void s_writeln(char *string)           /* write to string temp file */
{
    s_write_str(string);
    fprintf(s_datatemp, "\n");
}
/*---------- end s_writeln ----------*/



void i_write_str(char *string)         /* write to integer temp file */
{
    fprintf(i_datatemp,"%s", string);
}
/*---------- end i_write_str ----------*/



void i_writeln(char *string)           /* write to integer temp file */
{
    i_write_str(string);
    fprintf(i_datatemp, "\n");
}
/*---------- end i_writeln ----------*/



void f_write_str(char *string)         /* write to float temp file */
{
    fprintf(f_datatemp,"%s", string);
}
/*---------- end f_write_str ----------*/



void f_writeln(char *string)           /* write to float temp file */
{
    f_write_str(string);
    fprintf(f_datatemp, "\n");
}
/*---------- end f_writeln ----------*/



void x_write_str(char *string)         /* write to arrays temp file */
{
    fprintf(x_datatemp,"%s", string);
}
/*---------- end f_write_str ----------*/



void x_writeln(char *string)           /* write to arrays temp file */
{
    x_write_str(string);
    fprintf(x_datatemp, "\n");
}
/*---------- end f_writeln ----------*/



void PostLabel(char *string)           /* Post a Label To Output */
{
    fprintf(f_out, "%s:\n", string);
}
/*---------- end PostLabel ----------*/



char *get_varname()
{   char ch;
    static char varname[VAR_NAME];
    int pi, si=0;


    pi = e_pos;
    ch = p_string[pi];

    while((isalnum(ch) != 0) || (strchr("._", ch)))
    {
        varname[si] = ch;
        si++;
        pi++;
        ch = p_string[pi];
    }
    varname[si] = '\0';

    e_pos = pi;

    return varname;
}
/*---------- end get_varname ----------*/



char *get_NewLabel()                   /* generate a unique label */
{   char Val[6];
    static char NewLabel[LLEN];


    UnqLblNdx++;
    strcpy(NewLabel, "Unq_");
    sprintf(Val, "%d", UnqLblNdx);     /* generate an index */
    strcat(NewLabel, Val);
    strcat(NewLabel, "_Label");

    return NewLabel;
}
/*---------- end get_NewLabel ----------*/



double get_avalue()
{   char ch, varname[VAR_NAME];
    int pi, si=0;
    double value=0;


    pi = e_pos;
    ch = p_string[pi];

    if((isdigit(ch)) || (IsAddop(ch)))      /* this is a number */
    {
        if(IsAddop(ch))
        {
            varname[si] = ch;
            si++;
            pi++;
            ch = p_string[pi];
        }

        while(isdigit(ch) != 0)
        {
            varname[si] = ch;
            pi++;
            si++;
            ch = p_string[pi];
        }
        varname[si] = '\0';

        value = atof(varname);         /* convert alpha to float */
    }

    pi = iswhite(pi);
    e_pos = pi;

    return value;
}
/*-------- end get_avalue --------*/



void InitObj()               /* initialize object name/type array */
{   int ndx;
    unsigned size;


    if(ObjNdxCnt == 0)
    {
        ndx = ObjNdxCnt;
        ObjNdxCnt++;

        size = ObjNdxCnt;
        ObjIndx = malloc(size * sizeof(char *));
        ObjType = malloc(size * sizeof(int *));

        size = VAR_NAME;
        ObjIndx[ndx] = malloc(size * sizeof(char));

        size = 2;
        ObjType[ndx] = malloc(size * sizeof(int));
    }
    else
    {
        ndx = ObjNdxCnt;
        ObjNdxCnt++;

        size = ObjNdxCnt;
        ObjIndx = realloc(ObjIndx, size * sizeof(char *));
        ObjType = realloc(ObjType, size * sizeof(int *));

        size = VAR_NAME;
        ObjIndx[ndx] = malloc(size * sizeof(char));

        size = 2;
        ObjType[ndx] = malloc(size * sizeof(int));
    }
}
/*---------- end InitObj ----------*/



int get_ObjectType(char *name)    /* identify object type specifier */
{   char varname[VAR_NAME];
    int ndx=0, type=-1;


    strcpy(varname, name);

    while((ndx < ObjNdxCnt) && (strcmp(varname, ObjIndx[ndx]) != 0))
    {
        ndx++;
    }

    if(ndx < ObjNdxCnt)
    {
        type = ObjType[ndx][0];
    }

/*  printf("ndx=%d\n", ndx); */
/*  printf("getObj: name=%s type=%d\n", ObjIndx[ndx], ObjType[ndx][0]); */

    return type;
}
/*---------- end get_ObjectType ----------*/



int get_ObjectParm(char *name)    /* array parameter count */
{   char varname[VAR_NAME];
    int ndx=0, param;


    strcpy(varname, name);

    while((ndx < ObjNdxCnt) && (strcmp(varname, ObjIndx[ndx]) != 0))
    {
        ndx++;
    }

    if(ndx < ObjNdxCnt)
    {
        param = ObjType[ndx][1];
    }
 /* printf("getParm: name=%s param=%d\n", ObjIndx[ndx], ObjType[ndx][1]); */

    return param;
}
/*---------- end get_ObjectParm ----------*/



void InitVars()
{   int ndx;
    unsigned size;


    if(VarNdxCnt == 0)
    {
        ndx = VarNdxCnt;
        VarNdxCnt++;

        size = VarNdxCnt;
        VarIndx = malloc(size * sizeof(char *));

        size = VAR_NAME;
        VarIndx[ndx] = malloc(size * sizeof(char));
    }
    else
    {
        ndx = VarNdxCnt;
        VarNdxCnt++;

        size = VarNdxCnt;
        VarIndx = realloc(VarIndx, size * sizeof(char *));

        size = VAR_NAME;
        VarIndx[ndx] = malloc(size * sizeof(char));
    }
}
/*---------- end InitVars ----------*/



int check_VarName(char *name)
{   char varname[VAR_NAME];
    int ndx=0, ibool=0;


    strcpy(varname, name);

    if(VarNdxCnt == 0)                 /* no vars exist yet */
    {
        InitVars();
        ndx = VarNdxCnt - 1;
        strcpy(VarIndx[ndx], varname);
    }
    else
    {
        while((ndx < VarNdxCnt) && (strcmp(varname, VarIndx[ndx]) != 0))
        {
            ndx++;
        }

        if(ndx >= VarNdxCnt)           /* var name does not exist */
        {
            InitVars();
            ndx = VarNdxCnt - 1;
            strcpy(VarIndx[ndx], varname);
        }
        else
        {
            ibool = 1;                 /* var name exists */
        }
    }

    return ibool;
}
/*---------- end check_VarName ----------*/



int check_arrayName(char *name)
{   char varname[VAR_NAME];
    int ndx=0, ibool=0;
                                  /* ArryNdx;     name array */
                                  /* ArryNdxCnt;  counter */
    strcpy(varname, name);

    if(ArryNdxCnt == 0)
    {
        InitArrays();
        ndx = ArryNdxCnt - 1;
        strcpy(ArryNdx[ndx], varname);
    }
    else
    {
        while((ndx < ArryNdxCnt) && (strcmp(varname, ArryNdx[ndx]) != 0))
        {
            ndx++;
        }

        if(ndx >= ArryNdxCnt)
        {
            InitArrays();
            ndx = ArryNdxCnt - 1;
            strcpy(ArryNdx[ndx], varname);
        }
        else
        {
            ibool = 1;                 /* array name exists */
        }
    }

    return ibool;
}
/*---------- end check_arrayName ----------*/



int verify_arrayName(char *name)
{   char varname[VAR_NAME];
    int ndx=0, ibool=0;


    strcpy(varname, name);

    if(ArryNdxCnt != 0)                /* no arrays exist yet */
    {
        while((ndx < ArryNdxCnt) && (strcmp(varname, ArryNdx[ndx]) != 0))
        {
            ndx++;
        }

        if(ndx < ArryNdxCnt)
        {
            ibool = 1;                 /* array name exists */
        }
    }

    return ibool;
}
/*---------- end verify_arrayName ----------*/



int verify_VarName(char *name)
{   char varname[VAR_NAME];
    int ndx=0, ibool=0;


    strcpy(varname, name);

    if(VarNdxCnt != 0)                 /* no vars exist yet */
    {
        while((ndx < VarNdxCnt) && (strcmp(varname, VarIndx[ndx]) != 0))
        {
            ndx++;
        }

        if(ndx < VarNdxCnt)
        {
            ibool = 1;                 /* var name exists */
        }
    }

    return ibool;
}
/*---------- end verify_VarName ----------*/



void InitArrays()
{   int ndx;
    unsigned size;
                                  /* ArryNdx;     name array */
                                  /* ArryNdxCnt;  counter */
    if(ArryNdxCnt == 0)
    {
        ndx = ArryNdxCnt;
        ArryNdxCnt++;

        size = ArryNdxCnt;
        ArryNdx = malloc(size * sizeof(char *));
        ArryParams = malloc(size * sizeof(int));

        size = VAR_NAME;
        ArryNdx[ndx] = malloc(size * sizeof(char));
    }
    else
    {
        ndx = ArryNdxCnt;
        ArryNdxCnt++;

        size = ArryNdxCnt;
        ArryNdx = realloc(ArryNdx, size * sizeof(char *));
        ArryParams = realloc(ArryParams, size * sizeof(int));

        size = VAR_NAME;
        ArryNdx[ndx] = malloc(size * sizeof(char));
    }
}
/*---------- end InitArrays ----------*/



int get_paramsCount(int pi, int len)
{   char ch;
    int xcnt=0;


    ch = p_string[pi];

    while((ch != ')') && (pi < len))   /* get params count */
    {
        pi = get_alnum(pi, len);
        ch = p_string[pi];

        if(isalnum(ch))
        {
            xcnt++;
            pi = get_NextOp(pi);
            ch = p_string[pi];
        }
    }

    return xcnt;
}
/*---------- end get_paramsCount ----------*/



void GetNewVar()
{   char ch, NewVar[12], a_string[BUFSIZE];
    int pi, x=0, len, ab_code=23;


    len = strlen(p_string);
    pi = e_pos;
    s_pos = pi;

    strcpy(NewVar, NewVarname());      /* --- get new varname --- */

    write_str("\t");
    write_str(NewVar);                 /* NewVar  DB  # */
    write_str("\t\tDB  ");

    pi++;
    ch = p_string[pi];

    while((ch != '\"') && (pi < len))  /* copy up to quote */
    {
        a_string[x] = ch;
        x++;
        pi++;
        ch = p_string[pi];
    }
    a_string[x] = '\0';

    if(pi >= len)                 /* Error: missing closing quote */
    {
        x = line_ndx;
        a_bort(ab_code, x);
    }

    e_pos = pi;
    len = strlen(a_string);
    szLen = len;             /* save string length for textout */

    if(len == 0)
    {
        writeln("NULL");
    }
    else
    {
        write_str("\'");
        write_str(a_string);
        writeln("\',0");
    }

    StorVar(NewVar);         /* --- save varname in array --- */
    pi = e_pos;
    ch = p_string[pi];

    if(strchr(":;,", ch))
    {
        pi++;
        e_pos = pi;
    }
}
/*---------- end GetNewVar ----------*/



void Sav_String(char *Name)
{   char varname[VAR_NAME];
    int ab_code=29, x=line_ndx;


    strcpy(varname, Name);

    if(check_VarName(varname) == 0)
    {
        s_write_str("\t");
        s_write_str(varname);
        s_writeln("\t\tDD\t?");

        Sav_ObjName(varname, 0, 0);
    }
    else
    {                             /* found duplicate var-name */
        a_bort(ab_code, x);
    }
}
/*---------- end Sav_String ----------*/



void Sav_String_A(char *Name)
{   char varname[VAR_NAME];
    int ab_code=30, x=line_ndx;


    strcpy(varname, Name);

    if(check_VarName(varname) == 0)
    {
        a_bort(ab_code, x);       /* var-name not found */
    }
}
/*---------- end Sav_String_A ----------*/



void StorVar(char *name)
{   char ch, varname[12];
    int pi, x=0, ii, len;
    unsigned size;


    strcpy(varname, name);
    len = strlen(varname);
    ii = (s_pos + len);           /* how many chars to transfer */

    if(s_pos > 0)
    {
        for(;x < s_pos; x++)
        {
            s_holder[x] = p_string[x];
        }

        x = 0;
    }

    for(pi=s_pos; pi < ii; pi++,x++)
    {
        s_holder[pi] = varname[x];     /* copy varname */
    }

    x = pi;
    s_pos = pi;
    pi = e_pos;
    pi++;
    ch = p_string[pi];

    while(ch != '\0')
    {
        s_holder[x] = p_string[pi];
        x++;
        pi++;
        ch = p_string[pi];
    }
    s_holder[x] = '\0';

    strcpy(p_string, s_holder);
                                  /* --- save p_string to array --- */
    x = strlen(p_string);
    len = strlen(array1[line_ndx]);

    if(x > len)
    {
       size = (x+1);
       ii = line_ndx;
       array1[ii] = realloc(array1[ii], size * sizeof(char));
    }

    strcpy(array1[line_ndx], p_string);     /* store to array */
    e_pos = s_pos;
}
/*---------- end StorVar ----------*/



void Sav_ObjName(char *name, int type, int parm)
{   char varname[VAR_NAME];
    int ndx=0;


    strcpy(varname, name);
    InitObj();

    ndx = ObjNdxCnt - 1;
    strcpy(ObjIndx[ndx], varname);

    ObjType[ndx][0] = type;
    ObjType[ndx][1] = parm;

 /* printf("Obj: name=%s type=%d\n", ObjIndx[ndx], ObjType[ndx][0]); */
}
/*---------- end Sav_ObjName ----------*/



char *NewVarname()           /* generate a unique varname */
{   char Val[6];
    static char NewVar[12];
    int type=0;


    var_count++;
    strcpy(NewVar, "VARX");
    sprintf(Val, "%d", var_count);
    strcat(NewVar, Val);
    strcat(NewVar, "S");

    Sav_ObjName(NewVar, type, 0);

    return NewVar;
}
/*---------- end NewVarname ----------*/



void Fix_VarName(char *Name, int type)
{   char ch, varname[VAR_NAME];
    int pi, len;


    strcpy(varname, Name);
    len = strlen(varname);
    pi = e_pos;
    s_pos = pi - len;
    ch = p_string[pi];

    if(strchr("%!#@&", ch))
    {
        p_string[pi] = ' ';
    }
}
/*---------- end Fix_VarName----------*/



void Fix_StrArray2(char *Name)
{   char varname[VAR_NAME];
    int pi, len;
    int ab_code=26, x=line_ndx;


/* printf("%s", p_string); */

    strcpy(varname, Name);
    len = strlen(varname);
    pi = e_pos;
    s_pos = pi - len;
    StorVar(varname);

    if(check_VarName(varname) != 0)
    {
        a_bort(ab_code,x);
    }

    if(check_arrayName(varname) == 0)
    {
        x_write_str("\t");
        x_write_str(varname);
        x_writeln("\t\tDD\t?");
        x_writeln("\t\t\tDW\t61\tdup(?)");
    }

    Sav_ObjName(varname, 6, 1);
/* printf("%s", p_string); */
}
/*---------- end Fix_StrArray2 ----------*/



void Fix_VarArray2(char *Name, int type)
{   char varname[VAR_NAME];
    int pi, len;
    int ab_code=26, x=line_ndx;


/* printf("fixVA2::%s", p_string); */

    strcpy(varname, Name);
    len = strlen(varname);
    pi = e_pos;
    s_pos = pi - len;
    StorVar(varname);             /* save array name */

    if(check_VarName(varname) != 0)
    {
        a_bort(ab_code,x);
    }

    if(check_arrayName(varname) == 0)
    {
        x_write_str("\t");
        x_write_str(varname);
        x_writeln("\t\tDD\t?");
        x_writeln("\t\t\tDW\t61\tdup(?)");
    }

    Sav_ObjName(varname, type, 1);
/* printf("%s", p_string); */
}
/*---------- end Fix_VarArray2 ----------*/



int relocate(int pi, int px)
{   char ch;
    int mark, len;


    len = strlen(p_string);
    p_string[px] = '(';
    px++;
    pi = get_digit(pi, len);
    ch = p_string[pi];

    while(isdigit(ch))
    {
        p_string[px] = ch;
        px++;
        pi++;
        ch = p_string[pi];
    }
    p_string[px] = ')';

    px++;
    mark = px;

    while(ch != '\0')
    {
        p_string[px] = ch;
        px++;
        pi++;
        ch = p_string[pi];
    }
    p_string[px] = '\0';
                                  /* --- save p_string to array --- */
    strcpy(array1[line_ndx], p_string);     /* store to array */
    e_pos = mark;

    return mark;
}
/*---------- end relocate ----------*/



void GetNewTmp()
{   char ch, NewVar[12], a_string[BUFSIZE];
    int pi, x=0, dotflag=0;
    double ftest=0;


    pi = e_pos;
    s_pos = pi;
    strcpy(NewVar, NewFVarname());

    ch = p_string[pi];

    if(ch == '-')
    {
        a_string[x] = ch;
        x++;
        pi++;
        ch = p_string[pi];
    }
    else if(ch == '.')
    {
        a_string[x] = '0';
        x++;
    }

    while(isdigit(ch) || (ch == '.'))  /* copy digits */
    {
        if(ch == '.')
        {
            dotflag = 1;     /* flag: floating point number */
        }

        a_string[x] = ch;
        x++;
        pi++;
        ch = p_string[pi];
    }
    a_string[x] = '\0';

    e_pos = pi;
                             /* --- integers --- */
    if(dotflag == 0)
    {
        ftest = atof(a_string);

        if(ftest <= 32767)
        {
            strcat(NewVar, "I");

            write_str("\t");
            write_str(NewVar);         /* NewVar  DW  integer */
            write_str("\t\tDD  ");

            Sav_ObjName(NewVar, 1, 0);
        }
        else if(ftest <= 2147483647)
        {
            strcat(NewVar, "L");

            write_str("\t");
            write_str(NewVar);         /* NewVar  DD  long */
            write_str("\t\tDD  ");

            Sav_ObjName(NewVar, 2, 0);
        }
        else
        {
            strcat(NewVar, "Q");

            write_str("\t");
            write_str(NewVar);         /* NewVar  DD  long */
            write_str("\t\tDQ  ");

            Sav_ObjName(NewVar, 5, 0);
        }
    }
    else                          /* --- floats --- */
    {
        ftest = atof(a_string);

        if(ftest <= 2147483647)
        {
            strcat(NewVar, "F");

            write_str("\t");
            write_str(NewVar);         /* NewVar  DD  float */
            write_str("\t\tDQ  ");

            Sav_ObjName(NewVar, 3, 0);
        }
        else
        {
            strcat(NewVar, "D");

            write_str("\t");
            write_str(NewVar);         /* NewVar  DQ  double */
            write_str("\t\tDQ  ");

            Sav_ObjName(NewVar, 4, 0);
        }
    }

    writeln(a_string);                 /* write temp declaration */

    StorNVar(NewVar);             /* --- save varname in array --- */
}
/*---------- end GetNewTmp ----------*/



void StorNVar(char *name)
{   char ch, varname[VAR_NAME];
    int pi, x=0, ii, len;
    unsigned size;


    strcpy(varname, name);
    len = strlen(varname);
    ii = (s_pos + len);           /* how many chars to xfer */

    if(s_pos > 0)
    {
        for(x=0;x < s_pos; x++)
        {
            s_holder[x] = p_string[x];
        }
        x = 0;
    }

    for(pi=s_pos; pi < ii; pi++,x++)
    {
        s_holder[pi] = varname[x];     /* copy varname */
    }

    x = pi;
    s_pos = pi;
    pi = e_pos;
    ch = p_string[pi];

    while(ch != '\0')
    {
        s_holder[x] = p_string[pi];
        x++;
        pi++;
        ch = p_string[pi];
    }
    s_holder[x] = '\0';
    strcpy(p_string, s_holder);
                                  /* --- save p_string to array --- */
    x = strlen(p_string);
    len = strlen(array1[line_ndx]);

    if(x > len)
    {
       size = (x+1);
       ii = line_ndx;
       array1[ii] = realloc(array1[ii], size * sizeof(char));
    }

    strcpy(array1[line_ndx], p_string);     /* store to array */

    ch = p_string[s_pos];

    if(isalpha(ch))
    {
        s_pos = get_NextOp(s_pos);
    }

    e_pos = s_pos;
}
/*---------- end StorNVar ----------*/



void save_ArrayParam(char *name, int param)      /* save re-dimension count */
{   char varname[VAR_NAME];
    int ndx=0;


    strcpy(varname, name);

    while((ndx < ObjNdxCnt) && (strcmp(varname, ObjIndx[ndx]) != 0))
    {
        ndx++;
    }

    if(ndx < ObjNdxCnt)
    {
        ObjType[ndx][1] = param;
    }
}
/*------ end save_ArrayParam ------*/



void MakeNewVarA(char *NewVar)          /* this function is used */
{   char ch, a_string[BUFSIZE];        /* exclusively by ScanWindow */
    int pi, x=0, ndx, len, ab_code=23;


    len = strlen(p_string);
    pi = e_pos;
    s_pos = pi;

    write_str("\t");
    write_str(NewVar);                 /* NewVar  DB  # */
    write_str("\t\tDB  ");

    get_quotedStr();         /* fetch a quoted string */
    strcpy(a_string, s_holder);
    pi = e_pos;

    if(pi >= len)            /* Error: missing closing quote */
    {
        x = line_ndx;
        a_bort(ab_code, x);
    }
    else
    {
        write_str("\'");
        write_str(a_string);
        writeln("\',0");

        ndx = flag_gui;      /* hold this count, before it increments */
        wingui_table();           /* construct window handle table    */
                                       /* save appname to structure   */
        strcpy(WinHwnd[ndx].appName, a_string); // szAppName = 'MyWin'
        strcpy(szAppName, a_string);
    }

    e_pos = pi;

    StorVar(NewVar);         /* --- save varname in array --- */
    pi = e_pos;
    ch = p_string[pi];

    if(strchr(":;,", ch))
    {
        pi++;
        e_pos = pi;
    }
}
/*---------- end MakeNewVarA ----------*/



void MakeNewVarB()
{   char ch, NewVar[12], a_string[BUFSIZE];
    int pi, ndx, len;
    int ab_code=23, xx=line_ndx;


    len = strlen(p_string);
    pi = e_pos;
    s_pos = pi;

    strcpy(NewVar, NewVarname());      /* --- get new varname --- */

    write_str("\t");
    write_str(NewVar);                 /* NewVar  DB  # */
    write_str("\t\tDB  ");

    get_quotedStr();              /* fetch a quoted string */
    strcpy(a_string, s_holder);
    pi = e_pos;

    if(pi >= len)                 /* Error: missing closing quote */
    {
        a_bort(ab_code, xx);
    }
    else
    {
        write_str("\'");
        write_str(a_string);
        writeln("\',0");

 /* this needs to be incremented for each new window opened */
        ndx = 0;
        strcpy(WinHwnd[ndx].winName, a_string); // winName = 'Window1'
    }

    StorVar(NewVar);         /* --- save varname in array --- */
    pi = e_pos;
    ch = p_string[pi];

    if(strchr(":;,", ch))
    {
        pi++;
        e_pos = pi;
    }
}
/*---------- end MakeNewVarB ----------*/



void Trim_PString()          /* reduce this string:               */
{   char ch;                 /* "MyWin","MyWindow1",50,50,600,500 */
    int pi, x=0, len;        /* to this:                          */
                             /* "MyWindow1",50,50,600,500         */

    len = strlen(p_string);
    pi = e_pos;

    pi = get_quote(pi, len);
    pi--;
    ch = p_string[pi];

    while(pi < len)
    {
        s_holder[x] = p_string[pi];
        x++;
        pi++;
        ch = p_string[pi];
    }
    s_holder[x] = '\0';

    strcpy(p_string, s_holder);
    strcpy(array1[line_ndx], p_string);     /* store to array */
    e_pos = 0;
}
/*---------- end Trim_PString ----------*/



void Trim_PString2()         /* reduce this string:          */
{   char ch;                 /* "MyWindow1", 50, 50, 150, 50 */
    int pi, x=0, len;        /* to this:                     */
                             /* 50, 50, 150, 50              */

    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];

    if(ch != '\"')
    {
        pi = get_quote(pi, len);
        ch = p_string[pi];
    }

    pi = get_quote(pi, len);

    pi = get_rightExp(pi);

    ch = p_string[pi];

    while(pi < len)
    {
        s_holder[x] = p_string[pi];
        x++;
        pi++;
        ch = p_string[pi];
    }
    s_holder[x] = '\0';

    strcpy(p_string, s_holder);
    strcpy(array1[line_ndx], p_string);     /* store to array */
    e_pos = 0;
}
/*---------- end Trim_PString2 ----------*/






