/* Bxbasm : AVars.c : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012     */



/* ----- includes ----- */
#include "prototyp.h"


/* variable types:
    int    = no symbol,
    long   = %,
    float  = !,
    double = #,
    string = $
/* ---------------
   array types:
    long   = %,
    float  = !,
    double = #,
    string = $
*/





void Do_redimArray()
{   char ch, varname[VAR_NAME], temp[6];
    int pi, len, type, dim, value;
    int ab_code=25, x=line_ndx;


 /* printf("Do_redimArray:: %s", p_string); /**/

    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    ch = p_string[pi];
    e_pos = pi;

    strcpy(varname, get_varname());    /* get this array name */
    type = get_ObjectType(varname);    /* object type specifier */

    if((type >= 6) && (type <= 10))
    {
        pi = e_pos;
        pi = get_paren(pi, len);

        dim = get_paramsCount(pi, len);     /* get params count */
        save_ArrayParam(varname, dim);      /* save re-dimension count */

        writeln("; --------------------------------------------------");
        write_str("  mov  esi, offset ");   /* string array pointer */
        write_str(varname);
        writeln("\t\t\t; re-dimension an array");
        writeln("  mov  edi, esi");
        writeln("  add  edi, 4");

        sprintf(temp, "%d", dim);

        write_str("  mov word ptr [edi], ");
        writeln(temp);

        pi = e_pos;
        pi = get_paren(pi, len);            /* DIM array$(3,10) */
        s_pos = pi;                         /* ----------^      */
        ch = p_string[pi];

        while((ch != ')') && (ch != '\n'))
        {
            pi = get_alnum(pi, len);
            e_pos = pi;
            ch = p_string[pi];

            if(isdigit(ch))
            {
                value = (int) get_avalue();
                sprintf(temp, "%d", value);

                writeln("  add  edi, 2");
                write_str("  mov word ptr [edi], ");
                writeln(temp);
            }
            else if(isalpha(ch))
            {
                strcpy(varname, get_varname());

                write_str("  mov  eax, ");
                writeln(varname);
                writeln("  add  edi, 2");
                writeln("  mov word ptr [edi], ax");
            }

            pi = e_pos;
            ch = p_string[pi];
        }

        writeln("  call redimarray");

        redimarray = 1;
    }
    else
    {
        a_bort(ab_code,x);             /* varname is not an array */
    }
}
/*------ end Do_redimArray ------*/



void Do_erase()
{   char ch, varname[VAR_NAME];
    int pi, len, type;
    int ab_code=22, x=line_ndx;


    len = strlen(p_string);
    pi = e_pos;

    writeln("; --------------------------------------------------");

    while((pi < len) && (ch = '\n'))
    {
        pi = get_alpha(pi, len);
        e_pos = pi;

        if(pi < len)
        {
            strcpy(varname, get_varname());      /* get this array name */
            type = get_ObjectType(varname);      /* object type specifier */

            if(verify_arrayName(varname) == 0)
            {
                printf("-->\t%s", varname);
                a_bort(ab_code,x);          /* varname is not an array */
            }
            else
            {
                write_str("  mov  esi, offset ");     /* string array pointer */
                writeln(varname);
                writeln("  call freeArray");

                freeArray = 1;
            }

            pi = e_pos;
            ch = p_string[pi];
        }

        if(strchr("%!#@&", ch))        /* a numeric var type */
        {
            pi = get_rightExp(pi);
        }
    }
}
/*------ end Do_erase ------*/



void Do_dim()
{   int test, pi, len;            /* is this a "Dim var" or "Dim array" ? */


    pi = 0;
    e_pos = pi;
    len = strlen(p_string);

    test = isthis_anarray(pi, len);

    if(test == 0)                 /* not an array */
    {
        Do_dimVar();              /* Dim global or local var */
    }
    else
    {
        Do_dimArray();            /* Dim an array */
    }
}
/*------ end Do_dim ------*/



void Do_dimVar()
{   char ch, varname[VAR_NAME];
    int pi, len, ndx=0, type;
    int ab_code=6, x=line_ndx;


 /* printf("Do_dimVar:: %s", p_string); /**/

    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    ch = p_string[pi];
    e_pos = pi;

    if(pi == len)                 /* error: didn't find it */
    {
        a_bort(ab_code, x);
    }

    while((pi < len) && (ch != '\n'))
    {
        strcpy(varname, get_varname());
        type = get_ObjectType(varname);     /* object type specifier */

    /* printf("varname=%s type=%d\n", varname, type); /**/

        switch(type)
        {   case 0:
                asn_string(varname);   /* string variable assignment */
                break;
            case 1:                    /* integers assignment */
            case 2:
            case 5:
                asn_integer(type, varname);
                break;
            case 3:
            case 4:                    /* floating point assignment */
                asn_float(type, varname);
                break;
            default:
                a_bort(ab_code, x);
                break;
        }

        pi = e_pos;
        pi = get_rightExp(pi);
        ch = p_string[pi];
        e_pos = pi;

 /* printf("ch=%c pi=%d len=%d\n", ch, pi, len); /**/

    }
}
/*------ end Do_dimVar ------*/



void Do_dimArray()
{   char ch, varname[VAR_NAME], temp[6];
    int pi, len, type, dim, value;


 /* printf("Do_dimArray:: %s", p_string); /**/

    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    ch = p_string[pi];
    e_pos = pi;

    while((pi < len) && (ch != '\n'))
    {
        strcpy(varname, get_varname());     /* get this array name */

      /* printf("varname=%s pi=%d len=%d\n", varname, pi, len); /**/

        type = get_ObjectType(varname);     /* object type specifier */

      /* printf("varname=%s type=%d\n", varname, type); /**/

        if((type >= 6) && (type <= 10))
        {
            dim = get_ObjectParm(varname);

            writeln("; --------------------------------------------------");
            write_str("  mov  esi, offset ");    /* string array pointer */
            write_str(varname);
            writeln("\t\t\t; dimension an array");
            writeln("  mov  edi, esi");
            writeln("  add  edi, 4");

            sprintf(temp, "%d", dim);

            write_str("  mov word ptr [edi], ");
            writeln(temp);

            pi = e_pos;
            pi = get_paren(pi, len);        /* DIM array$(3,10) */
            s_pos = pi;                     /* ----------^      */
            ch = p_string[pi];

            while((ch != ')') && (ch != '\n'))
            {
                pi = get_alnum(pi, len);
                e_pos = pi;
                ch = p_string[pi];

                if(isdigit(ch))
                {
                    value = (int) get_avalue();
                    sprintf(temp, "%d", value);

                    writeln("  add  edi, 2");
                    write_str("  mov word ptr [edi], ");
                    writeln(temp);
                }
                else if(isalpha(ch))
                {
                    strcpy(varname, get_varname());

                    write_str("  mov  eax, ");
                    writeln(varname);
                    writeln("  add  edi, 2");
                    writeln("  mov word ptr [edi], ax");
                }

                pi = e_pos;
                ch = p_string[pi];
            }

            writeln("  call dimstrarray");

            dimstrarray = 1;
        }

        pi = e_pos;
        pi = get_rightExp(pi);
        ch = p_string[pi];
        e_pos = pi;

 /* printf("ch=%c pi=%d len=%d\n", ch, pi, len); */

    }
}
/*------ end Do_dimArray ------*/



void Do_color()
{   char varname[VAR_NAME];
    int pi, len;


    len = strlen(p_string);
    pi = e_pos;
    pi = iswhiter(pi);
    e_pos = pi;
    strcpy(varname, get_varname());

    write_str("  mov  eax, ");
    writeln(varname);

    pi = e_pos;
    pi = get_rightExp(pi);
    e_pos = pi;
    strcpy(varname, get_varname());

    write_str("  mov  ebx, ");
    writeln(varname);
    writeln("  call setcolortext");

    setcolortext = 1;
}
/*------ end Do_color ------*/



void clr_vars()
{   char varname[VAR_NAME];
    int pi, len, type;
    int ab_code=24, x=line_ndx;


    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);

    writeln("; --------------------------------------------------");

    if(pi == len)
    {
        writeln("  call clear_allvars");

        clearallvars = 1;
    }
    else
    {
        while(pi < len)
        {
            e_pos = pi;
            strcpy(varname, get_varname());
            pi = e_pos;
            type = get_ObjectType(varname);      /* object type specifier */

            if(type == 0)                   /* string variable */
            {
                write_str("  mov  esi, offset ");
                writeln(varname);
                writeln("  call clearstrvar");

                clearstrvar = 1;
            }
            else
            {
                if(type < 3)                /* clear integers */
                {
                    write_str("  mov  esi, offset ");
                    writeln(varname);
                    writeln("  call clearintvar");

                    clearintvar = 1;
                }
                else                        /* clear floats */
                {
                    write_str("  mov  esi, offset ");
                    writeln(varname);
                    writeln("  call clearfltvar");

                    clearfltvar = 1;
                }
            }

            if(verify_arrayName(varname) != 0)
            {
                printf("-->\t%s", varname);
                a_bort(ab_code,x);          /* varname is not an array */
            }

            pi = e_pos;
            pi = get_alpha(pi, len);
        }
    }
}
/*------ end clr_vars ------*/



void Do_let()
{   char varname[VAR_NAME];
    int pi, len, ndx=0, type;
    int ab_code=6, x=line_ndx;


 /* printf("dolet::%s", p_string); /**/

    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);           /* retrieve variable name */

    if(pi == len)                      /* error: didn't find it */
    {
        a_bort(ab_code, x);
    }

    e_pos = pi;
    strcpy(varname, get_varname());
    type = get_ObjectType(varname);    /* object type specifier */

 /* printf("varname=%s type=%d\n", varname, type); /**/

    switch(type)
    {   case 0:
            parse_str(varname);        /* string variable assignment */
            break;
        case 1:                        /* --- integers --- */
        case 2:
        case 5:
            asn_integer(type,varname);
            break;
        case 3:
        case 4:                        /* --- floating point --- */
            asn_float(type,varname);
            break;
        case 6:
            parse_strArry(varname);    /* string array assignment */
            break;
        case 8:
        case 9:
            parse_fltArry(varname, type);   /* float array assignment */
            break;
        case 7:
        case 10:
            parse_intArry(varname, type);   /* integer array assignment */
            break;
        default:
            a_bort(ab_code, x);
            break;
    }
}
/*------ end Do_let ------*/



void asn_integer(int type, char *name)
{   char ch, varname[VAR_NAME];
    int pi;


    pi = e_pos;
    ch = p_string[pi];
    strcpy(varname, name);

    if(strchr("%@&", ch))         /* 32/64-Bit Integer */
    {
        pi++;                     /* skip over 'type' symbol */
    }

    pi = iswhite(pi);
    e_pos = pi;

    writeln("; --------------------------------------------------");

    Assignment();                 /* call: recursive descent parser */

    write_str("  FISTP ");        /* --- store data --- */
    write_str(varname);
    writeln("\t\t; store integer, pop stack");

}
/*------ end asn_integer ------*/



void asn_float(int type, char *name)
{   char ch, varname[VAR_NAME];
    int pi;


    strcpy(varname, name);
    pi = e_pos;
    ch = p_string[pi];

    if(strchr("!#", ch))
    {
        pi++;                     /* skip over 'type' symbol */
    }

    pi = iswhite(pi);
    e_pos = pi;

    writeln("; --------------------------------------------------");

    Assignment();                 /* call: recursive descent parser */

    write_str("  FSTP  ");        /* --- store data --- */
    write_str(varname);
    writeln("\t\t; store float, pop stack");

}
/*------ end asn_float ------*/



void get_input()
{   char ch, varname[VAR_NAME], temp[6];
    int pi, len, type, mark, loc=0;
    int ab_code=5, x=line_ndx;


/* printf("input: %s", p_string); */

    pi = e_pos;                   /* INPUT;"text", var,[var,] */
    ch = p_string[pi];

    if(ch == '#')                 /* this is a file: [INPUT#1, var:] */
    {
        input_io();
        return;
    }
    else if(ch == ';')            /* do not echo newline */
    {
        loc = 1;                  /* Location Of Cursor */
        resetcursor = 1;
        pi = get_rightExp(pi);    /* get to next alpha or string */
        ch = p_string[pi];
        e_pos = pi;
    }

    len = strlen(p_string);

    while((pi < len) && (ch != '\n'))       /* process to end of line */
    {
        strcpy(temp, "VARX");
        s_pos = pi;
        mark = find_strng(temp);
        mark--;

        if((mark >= 0) && (mark == pi))
        {
            mark = 1;
        }
        else
        {
            mark = 0;
        }

        if(mark == 1)                       /* OUPUT a quoted string */
        {
            strcpy(varname, get_varname());

            write_str("  printstr ");
            writeln(varname);
        }
        else if(isalpha(ch))      /* INPUT a string$ or numeric variable */
        {
            strcpy(varname, get_varname());
            type = get_ObjectType(varname);      /* object type specifier */
            pi = e_pos;

            if(loc == 1)
            {
                writeln("  call wherexy");
            }

            if(type == 0)              /* a string$ assignment */
            {
                e_pos = pi;

                writeln("  lea  eax, StringBffr");
                writeln("  mov  [eax], byte ptr 0");
                writeln("  mov  eax, BUFSIZE");
                writeln("  call inputstr\t\t; console input");
                writeln("  call copystrng");
                write_str("  mov  edi, [");      /* make string assignment */
                write_str(varname);
                write_str("]");
                writeln("\t\t\t; load address-pointer");
                writeln("  call copystrng_bffr\t\t; alloc memory and copy");
                write_str("  mov  ");
                write_str(varname);
                writeln(", eax\t\t\t; store address-pointer");

                if(loc == 1)
                {
                    writeln("  call reset_cursor");
                }

                stringcopy = 1;        /* global flag */
                asninputstr = 1;
            }
            else                       /* numeric assignment */
            {
                writeln("  mov  eax, BUFFR_SIZ");
                writeln("  call inputstr\t\t; console input");
                writeln("  invoke StrToFloat, esi, addr qLVAR");
                writeln("  FLD   qLVAR");

                if((type < 3) || (type == 5))    /* integer types */
                {
                    write_str("  FISTP ");
                }
                else
                {
                    write_str("  FSTP ");
                }

                writeln(varname);

                if(loc == 1)
                {
                    writeln("  call reset_cursor");
                }

                asninputstr = 1;
            }
        }
        else
        {
            a_bort(ab_code, x);
        }

        pi = e_pos;
        ch = p_string[pi];

        if(strchr("; ,)$%!#@&", ch))   /* jump over punctuation */
        {
            pi = get_alpha(pi, len);   /* get to next alpha or string */
            ch = p_string[pi];
            e_pos = pi;
        }
    }
}
/*------ end get_input ------*/



void get_lninput()
{   char ch, varname[VAR_NAME], temp[6];
    int pi, len, mark, loc=0, flag=0;
    int ab_code=15, x=line_ndx;


    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);
    ch = p_string[pi];

    if(ch == '#')                 /* this is a file: [LINE INPUT#1, var:] */
    {
        lineinput_io();
        return;
    }
    else if(ch == ';')            /* do not echo newline */
    {
        loc = 1;                  /* Location Of Cursor */
        resetcursor = 1;
        pi = get_rightExp(pi);    /* get to next alpha or string */
        ch = p_string[pi];
        e_pos = pi;
    }

    while(flag == 0)
    {
        strcpy(temp, "VARX");
        s_pos = pi;
        mark = find_strng(temp);
        mark--;

        if((mark >= 0) && (mark == pi))
        {
            mark = 1;
        }
        else
        {
            mark = 0;
        }

        if(mark == 1)             /* DISPLAY a quoted string */
        {
            strcpy(varname, get_varname());

            write_str("  printstr ");
            writeln(varname);
        }
        else if(isalpha(ch))      /* INPUT a string$ variable */
        {
            strcpy(varname, get_varname());

            if(loc == 1)
            {
                writeln("  call wherexy");
            }

            writeln("  lea  eax, StringBffr");
            writeln("  mov  [eax], byte ptr 0");
            writeln("  mov  eax, BUFSIZE");
            writeln("  call inputstr\t\t; console input");

            if(loc != 1)
            {
                writeln("  printstr lf\t\t; add a line feed after Line Input");
            }

            writeln("  call copystrng");
            write_str("  mov  edi, [");     /* make string assignment */
            write_str(varname);
            write_str("]");
            writeln("\t\t\t; load address-pointer");
            writeln("  call copystrng_bffr\t\t; alloc memory and copy");
            write_str("  mov  ");
            write_str(varname);
            writeln(", eax\t\t\t; store address-pointer");

            if(loc == 1)
            {
                writeln("  call reset_cursor");
            }

            stringcopy = 1;            /* global flag */
            asninputstr = 1;
            flag = 1;
        }
        else
        {
            a_bort(ab_code, x);
        }

        pi = e_pos;
        ch = p_string[pi];

        if(flag == 1)
        {
            if(ch == ',')
            {
                writeln("  printstr tab\t\t; add a tab after Line Input");
            }
        }
        else if(strchr("; ,)$", ch))   /* jump over punctuation */
        {
            pi = get_alpha(pi, len);   /* get to next alpha or string */
            ch = p_string[pi];
            e_pos = pi;
        }
    }
}
/*------ end get_lninput ------*/



void parse_strArry(char *name)         /* string array assignment */
{   char varname[VAR_NAME];
    int pi, len, xcnt=0;


    strcpy(varname, name);             /* get destination */

    len = strlen(p_string);
    pi = e_pos;
    pi = get_paren(pi, len);
    xcnt = get_paramsCount(pi, len);   /* get params count */

    writeln("; --------------------------------------------------");

    get_offset(varname, len, xcnt);    /* get destination offset */

    writeln("  push edi");

    pi = e_pos;
    pi++;
    pi = iswhiter(pi);
    e_pos = pi;

    Match('=');

    writeln("  lea  eax, StringBffr");
    writeln("  mov  [eax], byte ptr 0\t\t; clear string-copy buffer");

    str_express(varname);              /* now get assignment string */

    writeln("  pop  edi");
    writeln("  push edi");
    writeln("  mov  eax, edi");
    writeln("  mov  edi, [eax]");      /* make string assignment */
    writeln("  call copystrng_bffr\t\t; alloc memory and copy");
    writeln("  pop  edi");             /* get destination address */
    writeln("  mov  [edi], eax\t\t\t; store address-pointer");

}
/*------ end parse_strArry ------*/



void get_offset(char *name, int len, int xcnt)
{   char ch, varname[VAR_NAME], temp[6];
    int pi, value;


    strcpy(varname, name);             /* get destination */

    write_str("  mov  edi, offset ");
    writeln(varname);
    writeln("  push edi");             /* save address to array */
    writeln("  add  edi, 6");
    writeln("  mov  esi, offset array_mtrx");
    writeln("  push esi");

    pi = e_pos;
    pi = get_paren(pi, len);           /* array$(3,1,0) = str$ */
    ch = p_string[pi];                 /* ------^              */

    while((xcnt > 1) && (ch != ')'))
    {
        pi = get_alnum(pi, len);
        e_pos = pi;
        ch = p_string[pi];

        if(isdigit(ch))
        {
            value = (int) get_avalue();     /* modifies: pi, ch */
            sprintf(temp, "%d", value);

            write_str("  mov  [esi], word ptr ");
            writeln(temp);
            writeln("  add  esi, 2");
        }
        else if(isalpha(ch))
        {
            strcpy(varname, get_varname()); /* modifies: pi, ch */

            write_str("  mov  eax, ");
            writeln(varname);
            writeln("  mov  [esi], ax");
            writeln("  add  esi, 2");
        }
        pi = e_pos;
        ch = p_string[pi];
        xcnt--;
    }

    writeln("  mov  [esi], word ptr 0");
    writeln("  add  esi, 2");

    pi = get_alnum(pi, len);
    e_pos = pi;
    ch = p_string[pi];

    if(isdigit(ch))
    {
        value = (int) get_avalue();
        sprintf(temp, "%d", value);

        write_str("  mov  [esi], word ptr ");
        writeln(temp);
    }
    else if(isalpha(ch))
    {
        strcpy(varname, get_varname());

        write_str("  mov  eax, ");
        writeln(varname);
        writeln("  mov  [esi], ax");
    }

    writeln("  pop  esi");
    writeln("  call getArryOffst");         /* get array(index) offset */
    writeln("  pop  esi");                  /* array base address */
    writeln("  mov  edi, [esi]");
    writeln("  add  edi, eax");

    getArryOffst = 1;
}
/*------ end get_offset ------*/



void parse_intArry(char *name, int type)    /* integer array assignment */
{   char varname[VAR_NAME];
    int pi, len, xcnt;


    strcpy(varname, name);             /* get destination */

    len = strlen(p_string);
    pi = e_pos;
    pi = get_paren(pi, len);
    xcnt = get_paramsCount(pi, len);   /* get params count */

    writeln("; --------------------------------------------------");

    get_offset(varname, len, xcnt);    /* get destination offset */

    writeln("  push edi");

    pi = e_pos;
    pi++;
    pi = iswhiter(pi);
    e_pos = pi;

    Assignment();                 /* call: recursive descent parser */


    writeln("  pop  edi");        /* --- store data --- */

    if(type == 7)
    {
        writeln("  call dblArryElement");
        writeln("  FISTP dword ptr [eax]\t\t; store integer, pop stack");

        dblArryElement = 1;
    }
    else if(type == 10)
    {
        writeln("  call quadArryElement");
        writeln("  FISTP qword ptr [eax]\t\t; store integer, pop stack");

        quadArryElement = 1;
    }
}
/*------ end parse_intArry ------*/



void parse_fltArry(char *name, int type)    /* float array assignment */
{   char varname[VAR_NAME];
    int pi, len, xcnt;


    strcpy(varname, name);             /* get destination */

    len = strlen(p_string);
    pi = e_pos;
    pi = get_paren(pi, len);
    xcnt = get_paramsCount(pi, len);   /* get params count */

    writeln("; --------------------------------------------------");

    get_offset(varname, len, xcnt);    /* get destination offset */

    writeln("  push edi");

    pi = e_pos;
    pi++;
    pi = iswhiter(pi);
    e_pos = pi;

    Assignment();                 /* call: recursive descent parser */

    writeln("  pop  edi");          /* --- store data --- */
    writeln("  call quadArryElement");
    writeln("  FSTP qword ptr [eax]\t\t; store integer, pop stack");

    quadArryElement = 1;
}
/*------ end parse_fltArry ------*/









