/* Bxbasm : AWingui.c : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012       */


/* ----- includes ----- */
#include "prototyp.h"


/***********************
   variable types:
    int    = no symbol,
    long   = %,
    float  = !,
    double = #,
    string = $
/* ---------------
   array types:
    long   = %,
    float  = !,
    double = #,
    string = $
***********************/










void ReSizeWin()
{
    char WinName[VAR_NAME], value[5];
    int ndx;


    fetch_sparam();               /* fetch the window name parameter */
    strcpy(WinName, s_holder);
    ndx = get_WinNdx(WinName);    /* convert index number to string */

    itoa(ndx, value, 10);

    write_str("  mov eax, ");
    writeln(value);
    writeln("  mov iLVAR, eax");


    fetch_sparam();
    strcpy(top, s_holder);        /* nX value */

    fetch_sparam();
    strcpy(left, s_holder);       /* nY value */

    fetch_sparam();
    strcpy(width, s_holder);      /* WIDTH value */

    fetch_sparam();
    strcpy(height, s_holder);     /* HEIGHT value */

    write_str("  invoke resize_win, ");
    write_str(top);
    write_str(", ");
    write_str(left);
    write_str(", ");
    write_str(width);
    write_str(", ");
    write_str(height);
    writeln(" \t ; resize client window");

    resizewin = 1;

}
/* ------ end ReSizeWin ------ */



void setBKMode()
{
    char myMode[VAR_NAME];


    fetch_sparam();
    strcpy(myMode, s_holder);    /* mode value */

    write_str("  invoke setbk_mode, ");
    write_str(myMode);
    writeln(" \t\t\t; TRANSPARENT or OPAQUE");

    setbkmode = 1;

}
/* ------ end setBKMode ------ */



void ClearWindow()
{
    char WinName[VAR_NAME], value[5];
    int ndx;


    fetch_sparam();               /* fetch the window name parameter */

    strcpy(WinName, s_holder);
    ndx = get_WinNdx(WinName);    /* convert index number to string */

    itoa(ndx, value, 10);

    write_str("  mov eax, ");
    writeln(value);
    writeln("  mov iLVAR, eax");
    writeln("  call clear_window");

    clearwindow = 1;

}
/* ------ end ClearWindow ------ */



void setBGColor()
{
    fetch_sparam();
    strcpy(C1, s_holder);    /* R color value */

    fetch_sparam();
    strcpy(C2, s_holder);    /* G color value */

    fetch_sparam();
    strcpy(C3, s_holder);    /* B color value */

    write_str("  invoke setbg_color, ");
    write_str(C1);
    write_str(", ");
    write_str(C2);
    write_str(", ");
    write_str(C3);
    writeln(" \t; change background color");

    setbgcolor = 1;

}
/* ------ end setBGColor ------ */



void setPenColor()
{
    fetch_sparam();
    strcpy(C1, s_holder);    /* R color value */

    fetch_sparam();
    strcpy(C2, s_holder);    /* G color value */

    fetch_sparam();
    strcpy(C3, s_holder);    /* B color value */

    write_str("  invoke pen_color, ");
    write_str(C1);
    write_str(", ");
    write_str(C2);
    write_str(", ");
    write_str(C3);
    writeln(" \t\t; change pen color");

    pencolor = 1;

}
/* ------ end setPenColor ------ */



void OldPen()
{
    writeln("  call old_pen");

    oldpen = 1;

}
/* ------ end OldPen ------ */



void NewPen()
{
    char W1[VAR_NAME];


    fetch_sparam();
    strcpy(W1, s_holder);    /* pen width value */

    fetch_sparam();
    strcpy(C1, s_holder);    /* R color value */

    fetch_sparam();
    strcpy(C2, s_holder);    /* G color value */

    fetch_sparam();
    strcpy(C3, s_holder);    /* B color value */

    write_str("  invoke new_pen, ");
    write_str(W1);
    write_str(", ");
    write_str(C1);
    write_str(", ");
    write_str(C2);
    write_str(", ");
    write_str(C3);
    writeln(" \t\t; change pen style");

    newpen = 1;

}
/* ------ end NewPen ------ */



void TextColor()
{
    fetch_sparam();
    strcpy(C1, s_holder);    /* R color value */

    fetch_sparam();
    strcpy(C2, s_holder);    /* G color value */

    fetch_sparam();
    strcpy(C3, s_holder);    /* B color value */

    write_str("  invoke text_color, ");
    write_str(C1);
    write_str(", ");
    write_str(C2);
    write_str(", ");
    write_str(C3);
    writeln(" \t\t; change text color");

    textColor = 1;

}
/* ------ end TextColor ------ */



void PixelSet()
{
    fetch_sparam();
    strcpy(X1, s_holder);    /* x:left edge coordinate */

    fetch_sparam();
    strcpy(Y1, s_holder);    /* y:top edge coordinate */

    write_str("  invoke pixel_set, ");
    write_str(X1);
    write_str(", ");
    write_str(Y1);
    writeln(" \t ; set a single pixel");

    pixelset = 1;

}
/* ------ end PixelSet ------ */



void DrawArc()
{
    char XS[VAR_NAME], YS[VAR_NAME], XE[VAR_NAME], YE[VAR_NAME];


    fetch_sparam();
    strcpy(X1, s_holder);    /* x:left edge coordinate */

    fetch_sparam();
    strcpy(Y1, s_holder);    /* y:top edge coordinate */

    fetch_sparam();
    strcpy(X2, s_holder);    /* x2:right edge coordinate */

    fetch_sparam();
    strcpy(Y2, s_holder);    /* y2:bottom edge coordinate */

    fetch_sparam();
    strcpy(XS, s_holder);

    fetch_sparam();
    strcpy(YS, s_holder);

    fetch_sparam();
    strcpy(XE, s_holder);

    fetch_sparam();
    strcpy(YE, s_holder);

    write_str("  invoke draw_arc, ");
    write_str(X1);
    write_str(", ");
    write_str(Y1);
    write_str(", ");
    write_str(X2);
    write_str(", ");
    write_str(Y2);
    write_str(", ");
    write_str(XS);
    write_str(", ");
    write_str(YS);
    write_str(", ");
    write_str(XE);
    write_str(", ");
    write_str(YE);
    writeln(" \t ; draw an arc shape");

    drawarc = 1;

}
/* ------ end DrawArc ------ */



void DrawChord()
{
    char XS[VAR_NAME], YS[VAR_NAME], XE[VAR_NAME], YE[VAR_NAME];


    fetch_sparam();
    strcpy(X1, s_holder);    /* x:left edge coordinate */

    fetch_sparam();
    strcpy(Y1, s_holder);    /* y:top edge coordinate */

    fetch_sparam();
    strcpy(X2, s_holder);    /* x2:right edge coordinate */

    fetch_sparam();
    strcpy(Y2, s_holder);    /* y2:bottom edge coordinate */

    fetch_sparam();
    strcpy(XS, s_holder);

    fetch_sparam();
    strcpy(YS, s_holder);

    fetch_sparam();
    strcpy(XE, s_holder);

    fetch_sparam();
    strcpy(YE, s_holder);

    write_str("  invoke draw_chord, ");
    write_str(X1);
    write_str(", ");
    write_str(Y1);
    write_str(", ");
    write_str(X2);
    write_str(", ");
    write_str(Y2);
    write_str(", ");
    write_str(XS);
    write_str(", ");
    write_str(YS);
    write_str(", ");
    write_str(XE);
    write_str(", ");
    write_str(YE);
    writeln(" \t ; draw a chord shape");

    drawchord = 1;

}
/* ------ end DrawChord ------ */



void DrawPie()
{
    char XS[VAR_NAME], YS[VAR_NAME], XE[VAR_NAME], YE[VAR_NAME];


    fetch_sparam();
    strcpy(X1, s_holder);    /* x:left edge coordinate */

    fetch_sparam();
    strcpy(Y1, s_holder);    /* y:top edge coordinate */

    fetch_sparam();
    strcpy(X2, s_holder);    /* x2:right edge coordinate */

    fetch_sparam();
    strcpy(Y2, s_holder);    /* y2:bottom edge coordinate */

    fetch_sparam();
    strcpy(XS, s_holder);

    fetch_sparam();
    strcpy(YS, s_holder);

    fetch_sparam();
    strcpy(XE, s_holder);

    fetch_sparam();
    strcpy(YE, s_holder);

    write_str("  invoke draw_pie, ");
    write_str(X1);
    write_str(", ");
    write_str(Y1);
    write_str(", ");
    write_str(X2);
    write_str(", ");
    write_str(Y2);
    write_str(", ");
    write_str(XS);
    write_str(", ");
    write_str(YS);
    write_str(", ");
    write_str(XE);
    write_str(", ");
    write_str(YE);
    writeln(" \t ; draw a pie shape");

    drawpie = 1;

}
/* ------ end DrawPie ------ */



void DrawCircle()
{
    char RAD[VAR_NAME];


    fetch_sparam();
    strcpy(C1, s_holder);         /* center:x coordinate */

    fetch_sparam();
    strcpy(C2, s_holder);         /* center:y coordinate */

    fetch_sparam();
    strcpy(RAD, s_holder);        /* radius coordinate */

    write_str("  invoke draw_circle, ");
    write_str(C1);
    write_str(", ");
    write_str(C2);
    write_str(", ");
    write_str(RAD);
    writeln(" \t ; draw a circle");

    drawcircle = 1;

}
/* ------ end DrawCircle ------ */



void DrawEllipse()
{
    fetch_sparam();
    strcpy(X1, s_holder);    /* x:left edge coordinate */

    fetch_sparam();
    strcpy(Y1, s_holder);    /* y:top edge coordinate */

    fetch_sparam();
    strcpy(X2, s_holder);    /* x2:right edge coordinate */

    fetch_sparam();
    strcpy(Y2, s_holder);    /* y2:bottom edge coordinate */

    write_str("  invoke draw_ellipse, ");
    write_str(X1);
    write_str(", ");
    write_str(Y1);
    write_str(", ");
    write_str(X2);
    write_str(", ");
    write_str(Y2);
    writeln(" \t ; draw an ellipse");

    drawellipse = 1;

}
/* ------ end DrawEllipse ------ */



void DrawSquare()
{
    char W1[VAR_NAME];


    fetch_sparam();
    strcpy(X1, s_holder);    /* x:left edge coordinate */

    fetch_sparam();
    strcpy(Y1, s_holder);    /* y:top edge coordinate */

    fetch_sparam();
    strcpy(W1, s_holder);    /* w: width */

    write_str("  invoke draw_square, ");
    write_str(X1);
    write_str(", ");
    write_str(Y1);
    write_str(", ");
    write_str(W1);
    writeln(" \t ; draw a square");

    drawsquare = 1;

}
/* ------ end DrawSquare ------ */



void DrawRndRect()
{
    char W1[VAR_NAME], H1[VAR_NAME];


    fetch_sparam();
    strcpy(X1, s_holder);    /* x:left edge coordinate */

    fetch_sparam();
    strcpy(Y1, s_holder);    /* y:top edge coordinate */

    fetch_sparam();
    strcpy(X2, s_holder);    /* x2:right edge coordinate */

    fetch_sparam();
    strcpy(Y2, s_holder);    /* y2:bottom edge coordinate */

    fetch_sparam();
    strcpy(W1, s_holder);    /* w rounding parameter */

    fetch_sparam();
    strcpy(H1, s_holder);    /* h rounding parameter */

    write_str("  invoke draw_rndrect, ");
    write_str(X1);
    write_str(", ");
    write_str(Y1);
    write_str(", ");
    write_str(X2);
    write_str(", ");
    write_str(Y2);
    write_str(", ");
    write_str(W1);
    write_str(", ");
    write_str(H1);
    writeln(" \t ; draw a rounded rectangle");

    drawroundedrect = 1;

}
/* ------ end DrawRndRect ------ */



void DrawRect()
{
    fetch_sparam();
    strcpy(X1, s_holder);    /* x:left edge coordinate */

    fetch_sparam();
    strcpy(Y1, s_holder);    /* y:top edge coordinate */

    fetch_sparam();
    strcpy(X2, s_holder);    /* x2:right edge coordinate */

    fetch_sparam();
    strcpy(Y2, s_holder);    /* y2:bottom edge coordinate */

    write_str("  invoke draw_rect, ");
    write_str(X1);
    write_str(", ");
    write_str(Y1);
    write_str(", ");
    write_str(X2);
    write_str(", ");
    write_str(Y2);
    writeln(" \t ; draw a rectangle function");

    drawrectangle = 1;

}
/* ------ end DrawRect ------ */



void ResetOldFont()
{
    writeln("  call reset_oldfont");

    resetoldfont = 1;

}
/* ------ end ResetOldFont ------ */



void getGDIFont()
{
    char myFont[VAR_NAME];


    fetch_sparam();                  /* fetch the font parameter */
    strcpy(myFont, s_holder);

    write_str("  invoke get_gdifont, ");
    writeln(myFont);

    getgdifont = 1;

}
/* ------ end getGDIFont ------ */



void PostMssge()
{
    char StrLn[VAR_NAME];
    int ndx;


    fetch_sparam();               /* fetch the text parameter */
    strcpy(szText, s_holder);

    fetch_sparam();               /* left edge */
    strcpy(X1, s_holder);

    fetch_sparam();               /* top edge  */
    strcpy(Y1, s_holder);

    fetch_sparam();               /* string length parameter */
    strcpy(StrLn, s_holder);

    write_str("  invoke post_mssge, addr ");
    write_str(szText);
    write_str(", ");
    write_str(X1);
    write_str(", ");
    write_str(Y1);
    write_str(", ");
    write_str(StrLn);
    writeln(" \t ; call text out function");

    postmessage = 1;

}
/* ------ end PostMssge ------ */



void DrawBox()
{
    fetch_sparam();
    strcpy(X1, s_holder);    /* x:left edge coordinate */

    fetch_sparam();
    strcpy(Y1, s_holder);    /* y:top edge coordinate */

    fetch_sparam();
    strcpy(X2, s_holder);    /* x2:right edge coordinate */

    fetch_sparam();
    strcpy(Y2, s_holder);    /* y2:bottom edge coordinate */

    fetch_sparam();
    strcpy(C1, s_holder);    /* R color value */

    fetch_sparam();
    strcpy(C2, s_holder);    /* G color value */

    fetch_sparam();
    strcpy(C3, s_holder);    /* B color value */

    write_str("  invoke draw_box, ");
    write_str(X1);
    write_str(", ");
    write_str(Y1);
    write_str(", ");
    write_str(X2);
    write_str(", ");
    write_str(Y2);
    write_str(", ");
    write_str(C1);
    write_str(", ");
    write_str(C2);
    write_str(", ");
    write_str(C3);
    writeln(" \t; draw rectangle in window");

    drawbox = 1;

}
/* ------ end DrawBox ------ */



void reDraw_Scrn()
{
    char WinName[VAR_NAME], value[5];
    int ndx;


    fetch_sparam();               /* fetch the window name parameter */

    strcpy(WinName, s_holder);
    ndx = get_WinNdx(WinName);    /* convert index number to string */

    itoa(ndx, value, 10);

    write_str("  mov eax, ");
    writeln(value);
    writeln("  mov iLVAR, eax");
    writeln("  call redraw_Scrn");

    redrawscreen = 1;

}
/* ------ end reDraw_Scrn ------ */



void DrawLine()
{
    fetch_sparam();
    strcpy(X1, s_holder);

    fetch_sparam();
    strcpy(Y1, s_holder);

    fetch_sparam();
    strcpy(X2, s_holder);

    fetch_sparam();
    strcpy(Y2, s_holder);

    write_str("  invoke draw_line, ");
    write_str(X1);
    write_str(", ");
    write_str(Y1);
    write_str(", ");
    write_str(X2);
    write_str(", ");
    write_str(Y2);
    writeln(" \t; draw line on gui window");

    drawline = 1;

}
/* ------ end DrawLine ------ */



void guiShow()
{
    int ndx;


    fetch_sparam();
    strcpy(WinName, s_holder);

    fetch_sparam();
    strcpy(top, s_holder);

    fetch_sparam();
    strcpy(left, s_holder);

    fetch_sparam();
    strcpy(width, s_holder);

    fetch_sparam();
    strcpy(height, s_holder);

    write_str("  invoke show_window, addr ");
    write_str(WinName);
    write_str(", ");
    write_str(top);
    write_str(", ");
    write_str(left);
    write_str(", ");
    write_str(width);
    write_str(", ");
    write_str(height);
    writeln(" \t; show new gui window");

    showwindow = 1;
}
/*--------- end guiShow ---------*/



void new_window()
{                       /* create GUI window */
    writeln("; --------------------------------------------------");
    writeln("  call new_window \t\t; open new gui window");

    newwindow = 1;

}
/*------- end new_window -------*/



int get_WinNdx(char *Name)
{
    int ndx = 0;
    int ab_code=55, xx=line_ndx;


    while((strcmp(WinHwnd[ndx].winName, Name) != 0) && (ndx <= flag_gui))
    {
        ndx++;
    }

    if(ndx >= flag_gui)
    {
        a_bort(ab_code, xx);         /* did not find window name */
    }

    return ndx;
}
/* ------ end get_WinNdx ------ */



void wingui_table()
{
    unsigned size;


    if(flag_gui == 0)
    {                            /* if this is the first window */
        flag_gui++;
        size = flag_gui;
        WinHwnd = (struct tagWinHwnd *) malloc(size * sizeof(struct tagWinHwnd));
    }
    else
    {                            /* prior windows have been created */
        flag_gui++;
        size = flag_gui;
        WinHwnd = (struct tagWinHwnd *) realloc(WinHwnd, size * sizeof(struct tagWinHwnd));
    }
}
/*---------- end wingui_table ----------*/



void fetch_sparam()
{   char ch;                 /* fetch a quoted string parameter */
    int pi, len;


    get_param_name();

    len = strlen(p_string);
    pi = e_pos;
    pi = get_alnum(pi, len);
    e_pos = pi;

}
/*------- end fetch_sparam -------*/



void fetch_nparam()
{   char ch, a_string[BUFSIZE];        /* fetch a numeric parameter */
    int pi, x=0, value;
    int ab_code=53, xx=line_ndx;


    pi = e_pos;
    pi = iswhiter(pi);
    ch = p_string[pi];
    e_pos = pi;

    if(ch == '-')
    {
        a_string[x] = ch;
        x++;
        pi++;
        ch = p_string[pi];
    }
    else if(ch == '.')
    {
        a_string[x] = '0';
        x++;
    }

    if(isdigit(ch) || (ch == '.'))    /* is this a digit ? */
    {
        while(isdigit(ch) || (ch == '.'))  /* copy digits */
        {
            a_string[x] = ch;
            x++;
            pi++;
            ch = p_string[pi];
        }
        a_string[x] = '\0';

        pi = iswhite(pi);
        ch = p_string[pi];
        e_pos = pi;
        strcpy(s_holder, a_string);
    }
    else if(isalpha(ch))          /* this is a variable name */
    {
        strcpy(s_holder, get_varname());
        pi = e_pos;
        pi = iswhite(pi);
        ch = p_string[pi];
        e_pos = pi;
    }
    else                       /* error: failed to find an alpha */
    {
        a_bort(ab_code, xx);
    }

    if(ch == ',')             /* comma separates parameters */
    {
        pi++;
        pi = iswhite(pi);
        ch = p_string[pi];
        e_pos = pi;
    }
}
/*------- end fetch_param -------*/


















