/* Bxbasm : Input.c : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012     */


/* ----- includes ----- */
#include "prototyp.h"


void line_cnt(char *argv[])
{   int pi, len, ii=0, x=0;
    int ab_code=2;
    unsigned fnam_len;


    nrows = 0;
                        /* --- get length of command line argument --- */
    fnam_len = strlen(argv[1]);
    len = fnam_len;
    fnam_len += 5;                          /* add padding */
    prog_name = malloc(fnam_len * sizeof(char));

    strcpy(prog_name, argv[1]);
    x = strcmp(prog_name, "include.src");

    if(x != 0)
    {                        /* --- does source filename end in: .bas --- */
        pi = (len-4);

        for(; pi < len; pi++)
        {
            p_string[ii] = prog_name[pi];
            ii++;
        }

        if(strcmp(p_string, ".bas") != 0)   /* if not, add it */
        {
            strcat(prog_name, ".bas");
        }
        p_string[0] = '\0';
        strcpy(s_holder, prog_name);
    }
    else
    {                        /* --- load source from include file --- */
        load_srx();
    }
                             /* --- open filename.bas for Read --- */
    f_in = fopen(prog_name,"r");

    if(f_in == NULL)         /* error:file not found */
    {
        a_bort(ab_code, x);
    }
    else
    {
        load_src();               /* read source-file, write temp-file */
        loader_1();               /* read temp-file, load temp arrays */
        loader_2();               /* load program arrays */
        free(prog_name);
        x = remove("source.tmp"); /* if test is '0', successful */
/*        x = remove("bxbsrc.src");   /* if test is '0', successful */
    }
}
/*------- end line_cnt ----------*/



void load_src()
{   char *tmp="source.tmp";
    int pi, len;


    f_out = fopen(tmp,"w");            /* open output file */

    while(!feof(f_in))
    {
        fgets(p_string, BUFSIZE, f_in);
        pi = 0;
        pi = iswhite(pi);
        len = strlen(p_string);

        if((len > 2) && (pi < len))    /* skip over blank lines */
        {
            if(!feof(f_in))
            {
                save_tmp();            /* write data to file */
            }
        }
    }

    fclose(f_in);
    fclose(f_out);
}
/*------- end load_src ----------*/



void save_tmp()
{   char ch;
    int pi, len;


    strcpy(xstring, "  ");        /* setup xstring to write indented line */
    strcat(xstring, p_string);
    pi = 0;
    ch = p_string[pi];

    if(isupper(ch) != 0)          /* test for a Label: */
    {
        len = (LLEN-2);
        pi = while_isalnum(pi);   /* loop thru "Label:" */
        ch = p_string[pi];

        if((ch == ':') && (pi <= len))
        {
            pi++;
            p_string[pi] = '\0';
            strcat(p_string, "\n\0");
            fprintf(f_out,"%s", p_string);  /* write block label */
            nrows++;
        }
        else
        {
            fprintf(f_out,"%s", xstring);   /* write indented line */
            nrows++;
        }
    }
                                  /* --- test for numbered line --- */
    else if(isdigit(ch))
    {
        fprintf(f_out,"%s", p_string);      /* write numbered line */
        nrows++;
    }
    else
    {
        pi = iswhite(pi);
        ch = p_string[pi];

        if(ch != '\'')                 	    /* eliminate comment lines */
        {
            fprintf(f_out,"%s", xstring);   /* write indented line */
            nrows++;
        }
    }
}
/*------- end save_tmp ----------*/



void loader_1()
{   char ch;
    char *tmp="source.tmp";
    int ii, len, pi;
    unsigned size=ncolumns;


    temp_prog = malloc(nrows * sizeof(char *));  /* create temp arrays */

    for(ii = 0; ii < nrows; ii++)
    {
        temp_prog[ii] = malloc(size * sizeof(char));
    }

    temp_label = malloc(nrows * sizeof(char *));

    for(ii = 0; ii < nrows; ii++)
    {
        temp_label[ii] = malloc(LLEN * sizeof(char));
    }

    temp_byte = malloc(nrows * sizeof(int));

    f_in = fopen(tmp,"r");             /* open source.tmp for Read */
    ii = 0;

    while(!feof(f_in))             	   /* p_string holds incoming-data */
    {
        fgets(p_string, BUFSIZE, f_in);

        if(!feof(f_in))
        {
            len = strlen(p_string);
                                  /* ----- fill temp_label[] here ----- */
            tmp_label(ii);             /* call label filter */
            pi = e_pos;
            ch = p_string[pi];

            if(ch == ':')              /* found a label */
            {
                temp_byte[ii] = -1;
                strcpy(temp_prog[ii], "\n\0");
            }
            else                  /* ----- fill temp_byte[] here ----- */
            {
                tmp_byte(ii);          /* call byte filter */
                tmp_prog(ii);
            }
        }
        ii++;
    }

    fclose(f_in);
}
/*---------- end loader_1 ----------*/



void tmp_label(int ii)
{   char ch, ln_label[LLEN];
    int pi;


    pi = 0;                  /* --- fill temp_label[] here --- */
    ch = p_string[pi];

    if(isalnum(ch))
    {
        while(isalnum(ch))
        {
            ln_label[pi] = ch;
            pi++;
            ch = p_string[pi];
        }
        ln_label[pi] = '\0';
        strcpy(temp_label[ii], ln_label);
    }
    else
    {
        strcpy(temp_label[ii], " \0");
    }

    e_pos = pi;
}
/*---------- end tmp_label ----------*/



void tmp_byte(int ii)
{   char ch;
    int pi, si, byte;
    int x=ii, ab_code=4;


    pi = e_pos;              /* ----- fill temp_byte[] here ----- */
    pi = iswhite(pi);
    ch = p_string[pi];

    if(ch == '\'')                /* it's a comment */
    {
        byte = 0;
        strcpy(temp_prog[ii], "\n\0");
    }
    else
    {
        if(isupper(ch))           /* is this a keyword */
        {
            e_pos = pi;
            byte = get_byte(ii);  /* call get_byte */
            pi = e_pos;
        }
        else if(isalpha(ch))      /* a possible assignment */
        {
            si = pi;              /* save pointer position */
            pi = while_isalnum(pi);
            //pi = while_isalnum_dd(pi); /* is alphanumeric-dot-dash */
            pi = iswhite(pi);
            ch = p_string[pi];

            if(strchr("=#%!$@&(", ch)) /* a variable assignment */
            {
                byte = 1;
                get_MOD(pi);           /* scan for a MOD expression */
                pi = si;
            }
            else
            {
                a_bort(ab_code, x);    /* not an assignment */
            }
        }
        else
        {
            a_bort(ab_code, x);        /* not a keyword or variable */
        }
    }

    temp_byte[ii] = byte;
    e_pos = pi;
}
/*---------- end tmp_byte ----------*/



void get_MOD(int pi)
{   char ch, temp[VAR_NAME];
    int i, si=0, xi, len;


    len = strlen(p_string);
    xi = pi;

    pi = get_quote(pi, len);      /* test, is this a quoted string ? */

    if(pi < len)
    {
        return;                   /* if so, exit now. */
    }
    else
    {
        pi = xi;
    }

    pi++;
    pi = iswhite(pi);
    ch = p_string[pi];

    while( pi < (len - 2))
    {
        if((ch == 'F') && (p_string[pi+1] == 'M'))
        {                              /* is this an FMOD ? */
            pi = pi + 2;
            ch = p_string[pi];
        }

        if(ch == 'M')
        {                              /* is this an MODF ? */
            if(p_string[pi+3] == 'F')
            {
                pi = pi + 2;
                ch = p_string[pi];
            }
            else if(p_string[pi+3] == '(')
            {                              /* is this an MOD() ? */
                pi = pi + 2;
                ch = p_string[pi];
            }
        }

        if(ch == 'M')                  /* is this a MOD */
        {
            si = pi;
            i = 0;

            while(isalnum(ch))
            {
                temp[i] = ch;
                pi++;
                i++;
                ch = p_string[pi];
            }
            temp[i] = '\0';

            if(strcmp(temp, "MOD") == 0)    /* compare(temp,"MOD") */
            {
                p_string[si] = '%';
                si++;
                xi = si;                    /* save si pointer */

                while(pi < len)             /* squeeze p_string */
                {
                    p_string[si] = p_string[pi];
                    pi++;
                    si++;
                }
                p_string[si] = '\0';
                pi = xi;                    /* restore pi */
            }
            pi++;
        }
        else
        {
            pi++;
        }
        ch = p_string[pi];
    }
}
/*---------- end get_MOD ----------*/



int get_byte(int ii)
{   char ch, keyword[TOKEN_LEN];
    int pi, si=0, pii, byte;
    int x=ii, ab_code=4;


    pi = e_pos;
    ch = p_string[pi];

    while(isalnum(ch))
    {
        keyword[si] = ch;
        si++;
        pi++;
        ch = p_string[pi];
    }
    keyword[si] = '\0';

                             /* --- assign byte code --- */
    if(strcmp(keyword, "REM") == 0)            byte=0;
    else if(strcmp(keyword, "LET") == 0)
    {                                          byte=1;
        get_MOD(pi);         /* scan for a MOD expression */
    }
    else if(strcmp(keyword, "CLEAR") == 0)     byte=2;
    else if(strcmp(keyword, "LOCATE") == 0)    byte=3;
    else if(strcmp(keyword, "PRINT") == 0)     byte=4;
    else if(strcmp(keyword, "GOTO") == 0)      byte=5;
    else if(strcmp(keyword, "BEEP") == 0)      byte=6;
    else if(strcmp(keyword, "CLS") == 0)       byte=7;
    else if(strcmp(keyword, "END") == 0)       byte=8;
    else if(strcmp(keyword, "STOP") == 0)      byte=8;
    else if(strcmp(keyword, "SYSTEM") == 0)    byte=8;
    else if(strcmp(keyword, "GOSUB") == 0)     byte=9;
    else if(strcmp(keyword, "RETURN") == 0)    byte=10;
    else if(strcmp(keyword, "FOR") == 0)       byte=11;
    else if(strcmp(keyword, "NEXT") == 0)      byte=12;
    else if(strcmp(keyword, "IF") == 0)        byte=13;
    else if(strcmp(keyword, "ELSEIF") == 0)    byte=14;
    else if(strcmp(keyword, "ELSE") == 0)      byte=15;
    else if(strcmp(keyword, "ENDIF") == 0)     byte=16;
    else if(strcmp(keyword, "INPUT") == 0)     byte=17;
    else if(strcmp(keyword, "LINE") == 0)
    {
        pii = pi;
        pii = iswhite(pii);
        ch = p_string[pii];
        if(ch == 'I')                          byte=18;
        else                                   byte=62;
    }
    else if(strcmp(keyword, "OPEN") == 0)      byte=19;
    else if(strcmp(keyword, "CLOSE") == 0)     byte=20;
    else if(strcmp(keyword, "WRITE") == 0)     byte=21;
    else if(strcmp(keyword, "FIELD") == 0)     byte=22;
    else if(strcmp(keyword, "LSET") == 0)      byte=23;
    else if(strcmp(keyword, "RSET") == 0)      byte=24;
    else if(strcmp(keyword, "PUT") == 0)       byte=25;
    else if(strcmp(keyword, "GET") == 0)       byte=26;
    else if(strcmp(keyword, "CHDIR") == 0)     byte=27;
    else if(strcmp(keyword, "MKDIR") == 0)     byte=28;
    else if(strcmp(keyword, "RMDIR") == 0)     byte=29;
    else if(strcmp(keyword, "KILL") == 0)      byte=30;
    else if(strcmp(keyword, "NAME") == 0)      byte=31;
    else if(strcmp(keyword, "RENAME") == 0)    byte=31;
    else if(strcmp(keyword, "FILES") == 0)     byte=32;
    else if(strcmp(keyword, "SHELL") == 0)     byte=33;
    else if(strcmp(keyword, "RANDOM") == 0)    byte=34;
    else if(strcmp(keyword, "READ") == 0)      byte=35;
    else if(strcmp(keyword, "CHDRIVE") == 0)   byte=36;
    else if(strcmp(keyword, "WHILE") == 0)     byte=37;
    else if(strcmp(keyword, "WEND") == 0)      byte=38;
    else if(strcmp(keyword, "LOOP") == 0)      byte=39;
    else if(strcmp(keyword, "ENDLOOP") == 0)   byte=40;
    else if(strcmp(keyword, "BREAK") == 0)     byte=41;
    else if(strcmp(keyword, "DO") == 0)        byte=42;
    else if(strcmp(keyword, "LPRINT") == 0)    byte=43;
    else if(strcmp(keyword, "COLOR") == 0)     byte=44;
    else if(strcmp(keyword, "ASM") == 0)       byte=45;
    else if(strcmp(keyword, "DIM") == 0)       byte=46;
    else if(strcmp(keyword, "ERASE") == 0)     byte=47;
    else if(strcmp(keyword, "FREE") == 0)      byte=47;
    else if(strcmp(keyword, "REDIM") == 0)     byte=48;
    else if(strcmp(keyword, "SWITCH") == 0)    byte=49;
    else if(strcmp(keyword, "CASE") == 0)      byte=50;
    else if(strcmp(keyword, "DEFAULT") == 0)   byte=51;
    else if(strcmp(keyword, "ENDSWITCH") == 0) byte=52;
    else if(strcmp(keyword, "SLEEP") == 0)     byte=53;
    else if(strcmp(keyword, "PAUSE") == 0)     byte=54;
    else if(strcmp(keyword, "MESSAGEBOX") == 0) byte=55;
    else if(strcmp(keyword, "MSGBOX") == 0)    byte=55;
    else if(strcmp(keyword, "DECLARE") == 0)   byte=56;
    else if(strcmp(keyword, "SUB") == 0)       byte=57;
    else if(strcmp(keyword, "ENDSUB") == 0)    byte=58;
    else if(strcmp(keyword, "CALL") == 0)      byte=59;
    else if(strcmp(keyword, "WINDOW") == 0)    byte=60;
    else if(strcmp(keyword, "SHOW") == 0)      byte=61;
  /*else if(strcmp(keyword, "LINE") == 0)      byte=62;*/  /* Line Draw */
    else if(strcmp(keyword, "REDRAW") == 0)    byte=63;
    else if(strcmp(keyword, "BOX") == 0)       byte=64;
    else if(strcmp(keyword, "TEXT") == 0)      byte=65;
    else if(strcmp(keyword, "FONT") == 0)      byte=66;
    else if(strcmp(keyword, "OLDFONT") == 0)   byte=67;
    else if(strcmp(keyword, "RECTANGLE") == 0) byte=68;
    else if(strcmp(keyword, "RNDRECT") == 0)   byte=69;
    else if(strcmp(keyword, "SQUARE") == 0)    byte=70;
    else if(strcmp(keyword, "ELLIPSE") == 0)   byte=71;
    else if(strcmp(keyword, "CIRCLE") == 0)    byte=72;
    else if(strcmp(keyword, "PIE") == 0)       byte=73;
    else if(strcmp(keyword, "CHORD") == 0)     byte=74;
    else if(strcmp(keyword, "ARC") == 0)       byte=75;
    else if(strcmp(keyword, "PSET") == 0)      byte=76;
    else if(strcmp(keyword, "TXTCOLOR") == 0)  byte=77;
    else if(strcmp(keyword, "NEWPEN") == 0)    byte=78;
    else if(strcmp(keyword, "OLDPEN") == 0)    byte=79;
    else if(strcmp(keyword, "PENCOLOR") == 0)  byte=80;
    else if(strcmp(keyword, "BGCOLOR") == 0)   byte=81;
    else if(strcmp(keyword, "CLRWIN") == 0)    byte=82;
    else if(strcmp(keyword, "BKMODE") == 0)    byte=83;
    else if(strcmp(keyword, "VIEW") == 0)      byte=84;
    else if(strcmp(keyword, "PEN") == 0)       byte=85;
    else if(strcmp(keyword, "LOGBRUSH") == 0)  byte=86;
    else if(strcmp(keyword, "BRUSHIND") == 0)  byte=87;
    else if(strcmp(keyword, "OLDBRUSH") == 0)  byte=88;



  /*xxx*/
    else if(strcmp(keyword, "DUMP") == 0)      byte=99;

    /* now test for lower case forms */

    else if(strcmp(keyword, "Rem") == 0)       byte=0;
    else if(strcmp(keyword, "Let") == 0)
    {                                          byte=1;
        get_MOD(pi);         /* scan for a MOD expression */
    }
    else if(strcmp(keyword, "Clear") == 0)     byte=2;
    else if(strcmp(keyword, "Locate") == 0)    byte=3;
    else if(strcmp(keyword, "Print") == 0)     byte=4;
    else if(strcmp(keyword, "Goto") == 0)      byte=5;
    else if(strcmp(keyword, "Beep") == 0)      byte=6;
    else if(strcmp(keyword, "Cls") == 0)       byte=7;
    else if(strcmp(keyword, "End") == 0)       byte=8;
    else if(strcmp(keyword, "Stop") == 0)      byte=8;
    else if(strcmp(keyword, "System") == 0)    byte=8;
    else if(strcmp(keyword, "Gosub") == 0)     byte=9;
    else if(strcmp(keyword, "Return") == 0)    byte=10;
    else if(strcmp(keyword, "For") == 0)       byte=11;
    else if(strcmp(keyword, "Next") == 0)      byte=12;
    else if(strcmp(keyword, "If") == 0)        byte=13;
    else if(strcmp(keyword, "Elseif") == 0)    byte=14;
    else if(strcmp(keyword, "Else") == 0)      byte=15;
    else if(strcmp(keyword, "Endif") == 0)     byte=16;
    else if(strcmp(keyword, "Input") == 0)     byte=17;
    else if(strcmp(keyword, "Line") == 0)
    {
        pii = pi;
        pii = iswhite(pii);
        ch = p_string[pii];
        if(ch == 'I')                          byte=18;
        else                                   byte=62;
    }
    else if(strcmp(keyword, "Open") == 0)      byte=19;
    else if(strcmp(keyword, "Close") == 0)     byte=20;
    else if(strcmp(keyword, "Write") == 0)     byte=21;
    else if(strcmp(keyword, "Field") == 0)     byte=22;
    else if(strcmp(keyword, "Lset") == 0)      byte=23;
    else if(strcmp(keyword, "Rset") == 0)      byte=24;
    else if(strcmp(keyword, "Put") == 0)       byte=25;
    else if(strcmp(keyword, "Get") == 0)       byte=26;
    else if(strcmp(keyword, "Chdir") == 0)     byte=27;
    else if(strcmp(keyword, "Mkdir") == 0)     byte=28;
    else if(strcmp(keyword, "Rmdir") == 0)     byte=29;
    else if(strcmp(keyword, "Kill") == 0)      byte=30;
    else if(strcmp(keyword, "Name") == 0)      byte=31;
    else if(strcmp(keyword, "Rename") == 0)    byte=31;
    else if(strcmp(keyword, "Files") == 0)     byte=32;
    else if(strcmp(keyword, "Shell") == 0)     byte=33;
    else if(strcmp(keyword, "Random") == 0)    byte=34;
    else if(strcmp(keyword, "Read") == 0)      byte=35;
    else if(strcmp(keyword, "Chdrive") == 0)   byte=36;
    else if(strcmp(keyword, "While") == 0)     byte=37;
    else if(strcmp(keyword, "Wend") == 0)      byte=38;
    else if(strcmp(keyword, "Loop") == 0)      byte=39;
    else if(strcmp(keyword, "Endloop") == 0)   byte=40;
    else if(strcmp(keyword, "Break") == 0)     byte=41;
    else if(strcmp(keyword, "Do") == 0)        byte=42;
    else if(strcmp(keyword, "Lprint") == 0)    byte=43;
    else if(strcmp(keyword, "Color") == 0)     byte=44;
    else if(strcmp(keyword, "Asm") == 0)       byte=45;
    else if(strcmp(keyword, "Dim") == 0)       byte=46;
    else if(strcmp(keyword, "Erase") == 0)     byte=47;
    else if(strcmp(keyword, "Free") == 0)      byte=47;
    else if(strcmp(keyword, "Redim") == 0)     byte=48;
    else if(strcmp(keyword, "Switch") == 0)    byte=49;
    else if(strcmp(keyword, "Case") == 0)      byte=50;
    else if(strcmp(keyword, "Default") == 0)   byte=51;
    else if(strcmp(keyword, "Endswitch") == 0) byte=52;
    else if(strcmp(keyword, "Sleep") == 0)     byte=53;
    else if(strcmp(keyword, "Pause") == 0)     byte=54;
    else if(strcmp(keyword, "Messagebox") == 0) byte=55;
    else if(strcmp(keyword, "Msgbox") == 0)    byte=55;
    else if(strcmp(keyword, "Declare") == 0)   byte=56;
    else if(strcmp(keyword, "Sub") == 0)       byte=57;
    else if(strcmp(keyword, "Endsub") == 0)    byte=58;
    else if(strcmp(keyword, "Call") == 0)      byte=59;
    else if(strcmp(keyword, "Window") == 0)    byte=60;
    else if(strcmp(keyword, "Show") == 0)      byte=61;
  /*else if(strcmp(keyword, "Line") == 0)      byte=62;*/  /* Line Draw */
    else if(strcmp(keyword, "Redraw") == 0)    byte=63;
    else if(strcmp(keyword, "Box") == 0)       byte=64;
    else if(strcmp(keyword, "Text") == 0)      byte=65;
    else if(strcmp(keyword, "Font") == 0)      byte=66;
    else if(strcmp(keyword, "Oldfont") == 0)   byte=67;
    else if(strcmp(keyword, "Rectangle") == 0) byte=68;
    else if(strcmp(keyword, "RndRect") == 0)   byte=69;
    else if(strcmp(keyword, "Square") == 0)    byte=70;
    else if(strcmp(keyword, "Ellipse") == 0)   byte=71;
    else if(strcmp(keyword, "Circle") == 0)    byte=72;
    else if(strcmp(keyword, "Pie") == 0)       byte=73;
    else if(strcmp(keyword, "Chord") == 0)     byte=74;
    else if(strcmp(keyword, "Arc") == 0)       byte=75;
    else if(strcmp(keyword, "Pset") == 0)      byte=76;
    else if(strcmp(keyword, "Txtcolor") == 0)  byte=77;
    else if(strcmp(keyword, "Newpen") == 0)    byte=78;
    else if(strcmp(keyword, "Oldpen") == 0)    byte=79;
    else if(strcmp(keyword, "Pencolor") == 0)  byte=80;
    else if(strcmp(keyword, "Bgcolor") == 0)   byte=81;
    else if(strcmp(keyword, "Clrwin") == 0)    byte=82;
    else if(strcmp(keyword, "Bkmode") == 0)    byte=83;
    else if(strcmp(keyword, "View") == 0)      byte=84;
    else if(strcmp(keyword, "Pen") == 0)       byte=85;
    else if(strcmp(keyword, "Logbrush") == 0)  byte=86;
    else if(strcmp(keyword, "Brushind") == 0)  byte=87;
    else if(strcmp(keyword, "Oldbrush") == 0)  byte=88;


  /*xxx*/
    else if(strcmp(keyword, "Dump") == 0)      byte=99;

    else
    {
        pi = iswhite(pi);
        ch = p_string[pi];

        if(strchr("=#%!$@&(", ch))     /* a variable assignment */
        {
            byte = 1;
            get_MOD(pi);          /* scan for a MOD expression */
            pi = e_pos;           /* push pointer back */
        }
        else
        {
            a_bort(ab_code, x);   /* not a keyword or variable */
        }
    }

    e_pos = pi;

    return byte;
}
/*---------- end get_byte ----------*/



void tmp_prog(int ii)
{   char ch, prog[BUFSIZE];
    int pi, si=0, len;


    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);

    if(temp_byte[ii] == 18)       /* --- correct: LINE INPUT --- */
    {
        ch = p_string[pi];

        while(isupper(ch))
        {
            pi++;                 /* advance past INPUT */
            ch = p_string[pi];
        }

        pi = iswhite(pi);
        ch = p_string[pi];

        while(ch != '\0')
        {
            prog[si] = ch;
            si++;
            pi++;
            ch = p_string[pi];
        }
        prog[si] = '\0';
    }
    else if((pi < len) && (temp_byte[ii] != 0))
    {
        ch = p_string[pi];

        while(ch != '\0')
        {
            prog[si] = ch;
            si++;
            pi++;
            ch = p_string[pi];
        }
        prog[si] = '\0';
    }
    else
    {
        strcpy(prog, "\n\0");
    }

    strcpy(temp_prog[ii], prog);
}
/*---------- end tmp_prog ----------*/



void loader_2()
{   int ndx, ii, line_count=0, lines=nrows;
    unsigned size;


    for(ndx=0; ndx < nrows; ndx++)     /* --- re-count number of lines --- */
    {
        if(temp_byte[ndx] != 0)
        {
            line_count++;
        }

        if((temp_byte[ndx] == 13) || (temp_byte[ndx] == 14))
        {
            token_if(ndx);             /* IF-ELSEIF */
        }                              /* tokenize expression */
        else if(temp_byte[ndx] == 1)   /* LET */
        {
            str_functn(ndx);           /* tokenize string functions */
        }
        else if(temp_byte[ndx] == 4)   /* PRINT */
        {
            str_funct2(ndx);           /* tokenize string functions */
        }
        else if(temp_byte[ndx] == 23)  /* LSET */
        {
            str_functn(ndx);           /* tokenize string functions */
        }
        else if(temp_byte[ndx] == 24)  /* RSET */
        {
            str_functn(ndx);           /* tokenize string functions */
        }
        else if(temp_byte[ndx] == 37)
        {
            token_if(ndx);             /* tokenize WHILE expression */
        }
//        else if(temp_byte[ndx] == 46)
//        {
//            var_types(ndx);            /* tokenize DIM: variable types */
//        }
    }

    nrows = line_count;

    array1 = malloc(nrows * sizeof(char *));     /* create program arrays */
    label_nam = malloc(nrows * sizeof(char *));

    for(ii = 0; ii < nrows; ii++)
    {
        label_nam[ii] = malloc(LLEN * sizeof(char));
    }

    byte_array = malloc(nrows * sizeof(int));

    ndx = 0;       /* --- transfer temp_arrays to program_arrays --- */

    for(ii=0; ii < lines; ii++)
    {
        if(temp_byte[ii] != 0)
        {
            strcpy(label_nam[ndx], temp_label[ii]);
            byte_array[ndx] = temp_byte[ii];

            size = strlen(temp_prog[ii]);
            size++;

            array1[ndx] = malloc(size * sizeof(char));

            strcpy(array1[ndx], temp_prog[ii]);
            ndx++;
        }
    }

    for(ii=0; ii < lines; ii++)   /* --- free temp array memory --- */
    {
        free(temp_label[ii]);
        free(temp_prog[ii]);
    }

    free(temp_label);
    free(temp_byte);
    free(temp_prog);
}
/*---------- end loader_2 ----------*/



void token_if(int ndx)
{   char temp[TOKEN_LEN];
    int loc;


    strcpy(p_string, temp_prog[ndx]);
    s_pos = 0;
    strcpy(temp, "AND");
    loc = 0;

    while(loc >= 0)
    {
        loc = find_strng(temp);
        loc--;

        if(loc > 0)
        {
            p_string[loc] = '&';       /* replace AND w/token */
            p_string[(loc+1)] = ' ';
            p_string[(loc+2)] = ' ';
        }
    }

    strcpy(temp, "OR");
    loc = 0;

    while(loc >= 0)
    {
        loc = find_strng(temp);
        loc--;

        if(loc > 0)
        {
            p_string[loc] = '|';       /* replace OR w/token */
            p_string[(loc+1)] = ' ';
        }
    }

    strcpy(temp, "NOT");
    loc = 0;

    while(loc >= 0)
    {
        loc = find_strng(temp);
        loc--;

        if(loc > 0)
        {
            p_string[loc] = '^';       /* replace NOT w/token */
            p_string[(loc+1)] = ' ';
            p_string[(loc+2)] = ' ';
        }
    }

    strcpy(temp, "THEN");
    loc = 0;

    while(loc >= 0)
    {
        loc = find_strng(temp);
        loc--;

        if(loc > 0)
        {
            p_string[loc] = '\n';      /* replace THEN w/EOL */
            p_string[(loc+1)] = '\0';
        }
    }

    strcpy(temp_prog[ndx], p_string);
}
/*---------- end token_if ----------*/



void str_functn(int ndx)               /* isolate math/string functions */
{   char ch, temp[VAR_NAME]; 	       /* tokenize string functions */
    int pi=0, len;


    strcpy(p_string, temp_prog[ndx]);

    while(IsEqu(pi) == 0)		       /* advance to '=' sign */
    {
        pi = e_pos;
        pi++;
    }

    pi = e_pos;	        /* <-- leave this here!!!, IsEqu() changes e_pos */
    len = strlen(p_string);
    pi++;                              /* added 03/18/11 */
                                       /* --- loop --- */
    while(pi < len)
    {
        pi = iswhiter(pi);             /* added 03/18/11 */
        ch = p_string[pi];             /* trap for quotes string */
                                       /* ie: string$ = "SIN" */
        if(ch == '\"')                 /* added 03/18/11 */
        {
            pi = get_quote(pi, len);
        }
        else
        {                              /* else: advance to uppercase */
            pi = get_upper(pi, len);

            if(pi < len)
            {
                e_pos = pi;
                strcpy(temp, get_varname());     /* get varname */
                s_pos = e_pos;
                ch = p_string[s_pos];
                    /* printf("spos=%d, ch=%c, name=%s\n", s_pos, ch, temp);*/

                if(ch == '$')               /* valid '$' symbol */
                {
                    e_pos = pi;
                    get_strfunc(temp,ndx);  /* identify function */
                }
                else
                {
                    e_pos = pi;
                    get_mathfunc(temp,ndx);	/* identify math function */
                }

                pi = e_pos;
                pi++;
            }
        }
    }
}
/*---------- end str_functn ----------*/



void str_funct2(int ndx)          /* Print */
{   char ch, temp[VAR_NAME];      /* tokenize string functions */
    int pi=0, len;


    strcpy(p_string, temp_prog[ndx]);
    len = strlen(p_string);
    ch = p_string[pi];
                                  /* --- loop --- */
    while((pi < len) && (ch != '\n'))
    {
        if(ch == '\"')
        {
            pi = get_quote(pi, len);
            pi = iswhite(pi);
        }
        else if(isupper(ch))
        {
            if(pi < len)
            {
                e_pos = pi;
                strcpy(temp, get_varname());     /* get varname */
                s_pos = e_pos;
                ch = p_string[s_pos];

                if(ch == '$')               /* valid '$' symbol */
                {
                    e_pos = pi;
                    get_strfunc(temp,ndx);  /* identify function */
                }
                else
                {
                    e_pos = pi;
                    get_mathfunc(temp,ndx); /* identify math function */
                }

                len = strlen(p_string);
                pi = e_pos;
                pi = get_paren(pi, len);
                pi++;
                pi = get_paren(pi, len);
                e_pos = pi;
            }
        }
        else
        {
            pi = while_isalnum(pi);
        }

        ch = p_string[pi];
        len = strlen(p_string);

        if(strchr(":; ,)(", ch))       /* jump over punctuation */
        {
            pi = get_rightExp(pi);     /* get to next alpha or string */
            ch = p_string[pi];
        }
        else if(strchr("$%!#@&", ch))  /* jump over var types */
        {
            pi = get_rightExp(pi);     /* get to next alpha or string */
            ch = p_string[pi];
        }
        else if(strchr("+-*/^", ch))   /* jump over operators */
        {
            pi = get_rightExp(pi);     /* get to next alpha or string */
            ch = p_string[pi];
        }

   /* printf("%sch=%c pi=%d len=%d\n", p_string, ch, pi, len); */

    }
}
/*---------- end str_funct2 ----------*/



void get_strfunc(char *name,int ndx)		/* identify function */
{   char varname[VAR_NAME], temp[TOKEN_LEN];


    strcpy(varname, name);
    temp[0] = '\0';

                                  /* --- now compare to functions --- */
    if(strcmp(varname, "CHR") == 0)
    {
        strcpy(temp, "   1");               /* a CHR$(n) assignment */
    }
    else if(strcmp(varname, "LEFT") == 0)
    {
        strcpy(temp, "    2");              /* a LEFT$(a$,n) assignment */
    }
    else if(strcmp(varname, "RIGHT") == 0)
    {
        strcpy(temp, "     3");             /* a RIGHT$(a$,n) assignment */
    }
    else if(strcmp(varname, "MID") == 0)
    {
        strcpy(temp, "   4");               /* a MID$(a$,s,n) assignment */
    }
    else if(strcmp(varname, "SPACE") == 0)
    {
        strcpy(temp, "     5");             /* a SPACE$(n) assignment */
    }
    else if(strcmp(varname, "STR") == 0)
    {
        strcpy(temp, "   6");               /* a STR$(x) assignment */
    }
    else if(strcmp(varname, "STRING") == 0)
    {
        strcpy(temp, "      7");            /* a STRING$(n,a) assignment */
    }
    else if(strcmp(varname, "INKEY") == 0)
    {
        strcpy(temp, "     8");             /* an INKEY$ assignment */
    }
    else if(strcmp(varname, "INPUT") == 0)
    {
        strcpy(temp, "     9");             /* an INPUT$(n) assignment */
    }
    else if(strcmp(varname, "MKD") == 0)
    {
        strcpy(temp, "  10");               /* a MKD$(n) assignment */
    }
    else if(strcmp(varname, "MKI") == 0)
    {
        strcpy(temp, "  11");               /* a MKI$(n) assignment */
    }
    else if(strcmp(varname, "MKS") == 0)
    {
        strcpy(temp, "  12");               /* a MKS$(n) assignment */
    }
    else if(strcmp(varname, "DATE") == 0)
    {
        strcpy(temp, "   13");              /* a DATE$ assignment */
    }
    else if(strcmp(varname, "TIME") == 0)
    {
        strcpy(temp, "   14");              /* a TIME$ assignment */
    }
    else if(strcmp(varname, "UCASE") == 0)
    {
        strcpy(temp, "    15");             /* a UCASE$ assnmnt */
    }
    else if(strcmp(varname, "LCASE") == 0)
    {
        strcpy(temp, "    16");             /* a LCASE$ assnmnt */
    }



    str_copy(temp,ndx);                /* replace function name w/token */
}
/*---------- end get_strfunc ----------*/



void get_mathfunc(char *name,int ndx)       /* identify math function */
{   char varname[VAR_NAME], temp[TOKEN_LEN];


    strcpy(varname, name);
    temp[0] = '\0';

                                  /* --- now compare to functions --- */
    if(strcmp(varname, "ABS") == 0)
    {
        strcpy(temp, " ?1");                /* a abs(n) assignment */
    }
    else if(strcmp(varname, "ASC") == 0)
    {
        strcpy(temp, " ?2");                /* a asc(a$) assignment */
    }
    else if(strcmp(varname, "ATN") == 0)
    {
        strcpy(temp, " ?3");                /* a atn(n) assignment */
    }
    else if(strcmp(varname, "COS") == 0)
    {
        strcpy(temp, " ?4");                /* a cos(n) assignment */
    }
    else if(strcmp(varname, "SIN") == 0)
    {
        strcpy(temp, " ?5");                /* a sin(n) assignment */
    }
    else if(strcmp(varname, "TAN") == 0)
    {
        strcpy(temp, " ?6");                /* a tan(n) assignment */
    }
    else if(strcmp(varname, "SQRT") == 0)
    {
        strcpy(temp, "  ?7");                /* a sqrt(n) assignment */
    }
    else if(strcmp(varname, "INT") == 0)
    {
        strcpy(temp, " ?8");                /* a int(n) assignment */
    }
    else if(strcmp(varname, "LEN") == 0)
    {
        strcpy(temp, " ?9");                /* a len($) assignment */
    }
    else if(strcmp(varname, "LOF") == 0)
    {
        strcpy(temp, "?10");                /* a lof(n) assignment */
    }
    else if(strcmp(varname, "LOC") == 0)
    {
        strcpy(temp, "?11");                /* a loc(n) assignment */
    }
    else if(strcmp(varname, "CVD") == 0)
    {
        strcpy(temp, "?12");                /* a cvd($) assignment */
    }
    else if(strcmp(varname, "CVI") == 0)
    {
        strcpy(temp, "?13");                /* a cvi($) assignment */
    }
    else if(strcmp(varname, "CVS") == 0)
    {
        strcpy(temp, "?14");                /* a cvs($) assignment */
    }
    else if(strcmp(varname, "ATAN2") == 0)
    {
        strcpy(temp, "  ?15");              /* a atan2(n,n) assignment */
    }
    else if(strcmp(varname, "COSH") == 0)
    {
        strcpy(temp, " ?16");               /* a cosh(n) assignment */
    }
    else if(strcmp(varname, "SINH") == 0)
    {
        strcpy(temp, " ?17");               /* a sinh(n) assignment */
    }
    else if(strcmp(varname, "TANH") == 0)
    {
        strcpy(temp, " ?18");               /* a tanh(n) assignment */
    }
    else if(strcmp(varname, "ACOS") == 0)
    {
        strcpy(temp, " ?19");               /* a acos(n) assignment */
    }
    else if(strcmp(varname, "ASIN") == 0)
    {
        strcpy(temp, " ?20");               /* a asin(n) assignment */
    }
    else if(strcmp(varname, "CEIL") == 0)
    {
        strcpy(temp, " ?21");               /* a ceil(n) assignment */
    }
    else if(strcmp(varname, "FLOOR") == 0)
    {
        strcpy(temp, "  ?22");              /* a floor(n) assignment */
    }
    else if(strcmp(varname, "HYPOT") == 0)
    {
        strcpy(temp, "  ?23");              /* a hypot(n,n) assignment */
    }
    else if(strcmp(varname, "LOG") == 0)
    {
        strcpy(temp, "?24");                /* a log(n) assignment */
    }
    else if(strcmp(varname, "LOG10") == 0)
    {
        strcpy(temp, "  ?25");              /* a log10(n) assignment */
    }
    else if(strcmp(varname, "RAND") == 0)
    {
        strcpy(temp, " ?26");               /* a rand() assignment */
    }
    else if(strcmp(varname, "CLOCK") == 0)
    {
        strcpy(temp, "  ?27");              /* a clock() assignment */
    }
    else if(strcmp(varname, "VAL") == 0)
    {
        strcpy(temp, "?28");                /* a val($) assignment */
    }
    else if(strcmp(varname, "EOF") == 0)
    {
        strcpy(temp, "?29");                /* a eof() assignment */
    }
    else if(strcmp(varname, "SECONDS") == 0)
    {
        strcpy(temp, "    ?30");            /* seconds since 0:0:0 GMT */
    }
    else if(strcmp(varname, "DRIVE") == 0)
    {
        strcpy(temp, "  ?31");              /* current disk drive */
    }
    else if(strcmp(varname, "EXP") == 0)
    {
        strcpy(temp, "?32");                /* a# = exp(n) */
    }
    else if(strcmp(varname, "FABS") == 0)
    {
        strcpy(temp, " ?33");               /* a# = fabs(n) */
    }
    else if(strcmp(varname, "FMOD") == 0)
    {
        strcpy(temp, " ?34");               /* a# = fmod(n1,n2) */
    }
    else if(strcmp(varname, "LDEXP") == 0)
    {
        strcpy(temp, "  ?35");              /* a# = ldexp(n1,n2) */
    }
    else if(strcmp(varname, "MODF") == 0)
    {
        strcpy(temp, " ?36");               /* a# = modf(n1,n2) */
    }
    else if(strcmp(varname, "POW") == 0)
    {
        strcpy(temp, "?37");                /* a# = pow(n1,n2) */
    }
    else if(strcmp(varname, "POW10") == 0)
    {
        strcpy(temp, "  ?38");              /* a# = pow10(n) */
    }
    else if(strcmp(varname, "FREXP") == 0)
    {
        strcpy(temp, "  ?39");              /* a# = frexp(n1,n2) */
    }
    else if(strcmp(varname, "LABS") == 0)
    {
        strcpy(temp, " ?40");               /* a! = labs(n) */
    }
    else if(strcmp(varname, "TIMER") == 0)
    {
        strcpy(temp, "  ?41");              /* a# = hi-resolution timer */
    }
    else if(strcmp(varname, "SGN") == 0)
    {
        strcpy(temp, "?42");                /* a = sgn(n) */
    }
    else if(strcmp(varname, "MOD") == 0)
    {
        strcpy(temp, "?43");                /* a = MOD(n1,n2) */
    }
    else if(strcmp(varname, "CINT") == 0)
    {
        strcpy(temp, " ?44");               /* a = CINT(f) */
    }
    else if(strcmp(varname, "CDBL") == 0)
    {
        strcpy(temp, " ?45");               /* a# = CDBL(n) */
    }
    else if(strcmp(varname, "CSNG") == 0)
    {
        strcpy(temp, " ?46");               /* a! = CSNG(f) */
    }
    else if(strcmp(varname, "CLNG") == 0)
    {
        strcpy(temp, " ?47");               /* a% = CLNG(f) */
    }
    else if(strcmp(varname, "INSTR") == 0)
    {
        strcpy(temp, "  ?48");              /* a = INSTR(n,$,$) */
    }
    else if(strcmp(varname, "TXTCOLOR") == 0)
    {
        strcpy(temp, "     ?49");           /* a% = TXTCOLOR */
    }
    else if(strcmp(varname, "BGCOLOR") == 0)
    {
        strcpy(temp, "    ?50");            /* a% = BGCOLOR */
    }
    else if(strcmp(varname, "BKMODE") == 0)
    {
        strcpy(temp, "   ?51");             /* a = BKMODE */
    }
    else if(strcmp(varname, "POINT") == 0)
    {
        strcpy(temp, "  ?52");              /* a% = POINT */
    }



    str_copy(temp, ndx);          /* replace function name w/token */
}
/*---------- end get_mathfunc ----------*/



void str_copy(char *temp,int ndx)
{   char ch, tok[TOKEN_LEN];      /* replace function name w/token */
    int pi, si=0;


    strcpy(tok, temp);
    pi = e_pos;
    ch = tok[si];

    if(ch != '\0')
    {
        while(ch != '\0')
        {
            p_string[pi] = ch;
            si++;
            pi++;
            ch = tok[si];
        }

        strcpy(temp_prog[ndx], p_string);
        e_pos = pi;
    }
    else
    {
        e_pos = s_pos;       /* not a function */
    }

 /* printf("%s", p_string); */

}
/*---------- end str_copy ----------*/



int IsEqu(int pi)
{   char ch;                      /* is equal sign */
    int ibool=0;


    pi = iswhite(pi);
    e_pos = pi;
    ch = p_string[pi];

    if(ch == '=')
    {
        ibool = 1;
    }

    return ibool;
}
/*---------- end IsEqu ----------*/



void var_types(int ndx)           /* tokenize variable types */
{   char ch, token[VAR_NAME], temp[VAR_NAME], charx[3];
    int pi, len;


    strcpy(p_string, temp_prog[ndx]);
/* printf("vartypes::%s", p_string); */

    len = strlen(p_string);
    pi = 0;
    ch = p_string[pi];
    e_pos = pi;

    while((pi < len) && (ch != '\n'))
    {
        strcpy(charx, " ");            /* clear symbol */
        pi = get_alpha(pi, len);       /* get token */

/*    ch = p_string[pi];
/*    printf("ch=%c pi=%d\n", ch, pi); */

        e_pos = pi;
        strcpy(token, get_varname());
        e_pos = pi;
        temp[0] = '\0';

        if(strcmp(token, "AS") == 0)        /* now compare to tokens */
        {   strcpy(temp, "  ");
        }
        else if(strcmp(token, "STRING") == 0)
        {   strcpy(temp, "     $");
        }
        else if(strcmp(token, "INTEGER") == 0)
        {   strcpy(temp, "      %");
        }
        else if(strcmp(token, "LONG") == 0)
        {   strcpy(temp, "   &");
        }
        else if(strcmp(token, "SINGLE") == 0)
        {   strcpy(temp, "     !");
        }
        else if(strcmp(token, "DOUBLE") == 0)
        {   strcpy(temp, "     #");
        }
        else
        {   pi = get_NextOp(pi);
        }
        if(temp[0] != '\0')
        {   str_copy(temp, ndx);
            pi = e_pos;
        }
        ch = p_string[pi];

/* printf("%s", p_string); */
    }
}
/*---------- end var_types ----------*/



void load_srx()
{   char **source, filename[VAR_NAME];
    char inc_file[VAR_NAME], src_file[VAR_NAME];
    int ndx, cnt, pi, len;
    unsigned size = 100;               /* max number of include files */


    strcpy(inc_file, "include.src");        /* source file list */
    strcpy(src_file, "bxbsrc.src");         /* destination file */

    source = malloc(size * sizeof(char *)); /* create name list array */

    for(ndx = 0; ndx < size; ndx++)
    {
        source[ndx] = malloc(VAR_NAME * sizeof(char));
    }

    f_in = fopen(inc_file, "r");
    cnt = -1;

    while(!feof(f_in))
    {
        fgets(p_string, VAR_NAME, f_in);    /* read-in list file */
        pi = 0;
        pi = iswhite(pi);
        len = strlen(p_string);
        len--;
        p_string[len] = '\0';               /* remove '\n' char */

        if((len > 2) && (pi < len))         /* make sure it's not garbage */
        {
            cnt++;                          /* count list entries */
            strcpy(source[cnt], p_string);  /* store list */
            p_string[0] = '\0';             /* clear p_string */
        }
    }
    fclose(f_in);
    f_out = fopen(src_file, "w");           /* open destination file */

    printf("loading...\n");

    for(ndx = 0; ndx <= cnt; ndx++)         /* number of entries */
    {
        strcpy(filename, source[ndx]);
        printf("%s\n", filename);

        f_in = fopen(filename, "r");        /* open list entry */

        while(!feof(f_in))
        {
            p_string[0] = '\0';

            fgets(p_string, BUFSIZE, f_in);      /* read-in file to end */

            if(p_string[0] != '\0')              /* if(p_string != NULL) */
            {
                fprintf(f_out, "%s", p_string);  /* write each line */
            }
        }

        fclose(f_in);
    }

    fclose(f_out);
    printf("\n");

    for(ndx = 99; ndx >= 0; ndx--)
    {
        if(source[ndx] != NULL)
        {
            free(source[ndx]);    /* erase list array */
        }
    }

    free(source);

    strcpy(prog_name, src_file);
    strcpy(s_holder, prog_name);

}
/*------- end load_srx ----------*/



