/* bxbasm : Scanfile.c : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012        */


/* ----- function prototypes ----- */
#include "prototyp.h"



void ScanOpen()                   /* parse OPEN statement */
{   char ch, temp[BUFSIZE];
    int pi, len, ii;
    int ab_code=16, x=line_ndx;
    unsigned size;


    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];

    if(ch != '\"')
    {
        pi = get_quote(pi, len);
        pi--;
    }

    s_pos = pi;
    pi = get_upper(pi, len);
    ch = p_string[pi];

    if(isalpha(ch))               /* isolate access mode: I,O,A,R (B) */
    {
        switch(ch)
        {   case 'I':
                p_string[pi] = 'r';
                strcpy(temp, "0,");
                break;
            case 'O':
                p_string[pi] = 'w';
                strcpy(temp, "0,");
                break;
            case 'A':
                p_string[pi] = 'a';
                strcpy(temp, "0,");
                break;
            case 'R':
                p_string[pi] = 'r';
                p_string[(pi+1)] = 'b';
                p_string[(pi+2)] = '+';
                p_string[(pi+3)] = '\"';
                strcpy(temp, "1,");
                break;
            default:
                a_bort(ab_code,x);
                break;
        }

        e_pos = s_pos;
        GetNewVar();                   /* get new varname */
        pi = e_pos;
    }

    pi = get_digit(pi, len);           /* file number: #1,2,3... */
    ch = p_string[pi];

    if(isdigit(ch))
    {
        pi = get_NextOp(pi);           /* skip over file number */
        pi = get_rightExp(pi);
    }
    else
    {
        ab_code = 17;
        a_bort(ab_code,x);
    }

    ch = p_string[pi];

    if(ch == '\"')
    {
        e_pos = pi;
        GetNewVar();                   /* get new varname */
    }
    else if(isalpha(ch))               /* a varname */
    {                   /* do nothing, pass on varname */
    }
    else
    {
        ab_code = 18;
        a_bort(ab_code,x);
    }

    strcat(temp, p_string);

    len = strlen(temp);      /* --- save p_string to array --- */
    size = len + 1;
    ii = line_ndx;

    array1[ii] = realloc(array1[ii], size * sizeof(char));
    strcpy(array1[line_ndx], temp);    /* store to array */

}
/*---------- end ScanOpen ----------*/



void ScanWrite()                  /* parse WRITE statement */
{   char ch, NVar[12], varname[VAR_NAME], format[BUFSIZE];
    int pi, len, type, wflag=0, ii;
    unsigned size;


/* printf("scanwrite: %s", p_string); */

    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];
    format[0] = '\0';

    while((pi < len) && (ch != '\n'))  /* process up to line terminator */
    {
        pi = get_alpha(pi, len);

        if(pi < len)
        {
            type = get_vtype(pi);

            if(type == 0)
            {
                e_pos = pi;
                strcpy(varname, get_varname());  /* get varname */
                Fix_String_A(varname);

                if(wflag == 1)
                {
                    strcat(format, ",");
                }

                strcat(format, "%s");
                wflag = 1;
            }
            else                  /* output a value */
            {
                e_pos = pi;
                type = get_Nvtype(pi);

                AddNewVar_A();

                if(wflag == 1)
                {
                    strcat(format, ",");
                }

                if(type < 3)
                {
                    strcat(format, "%d");
                }
                else if(type == 4)
                {
                    strcat(format, "%.20f");
                }
                else if(type == 3)
                {
                    strcat(format, "%f");
                }
                else              /* if(type == 5) */
                {
                    strcat(format, "%lu");
                }
                wflag = 1;
            }
            pi = get_NextOp(pi);
        }
        ch = p_string[pi];
    }

 /* printf("format=%s\n", format); */

    strcpy(NVar, NewFVarname());       /* --- get new varname --- */
    strcat(NVar, "S");

    write_str("\t");
    write_str(NVar);
    write_str("\t\tDB\t\'");
    write_str(format);
    writeln("\',10,0");

    strcpy(format, NVar);
    strcat(format, ", ");
    strcat(format, p_string);

    len = strlen(format);         /* --- save p_string to array --- */
    size = len + 1;
    ii = line_ndx;

    array1[ii] = realloc(array1[ii], size * sizeof(char));
    strcpy(array1[line_ndx], format);       /* store to array */

/* printf("scanwrite:%s", format); */

}
/*------- end ScanWrite ----------*/



void ScanField()
{   char ch, temp[6], varname[VAR_NAME], string[BUFSIZE];
    int pi, len, mark, var_cnt=0, ii;
    unsigned size;


 /* printf("pstring:: %s", p_string); /**/

    len = strlen(p_string);
    pi = e_pos;
    strcpy(temp, " AS ");

    while(pi < len)
    {
        s_pos = pi;
        mark = find_strng(temp);
        mark--;

        if(mark > 0)
        {
            pi = mark + 3;
            pi = iswhiter(pi);
            ch = p_string[pi];

            if(isalpha(ch))
            {
                e_pos = pi;
                strcpy(varname, get_varname());  /* get varname */
                Fix_String_A(varname);
                var_cnt++;
            }
        }
        else
        {
            pi = len;
        }
    }

    sprintf(temp, "%d", var_cnt);
    strcpy(string, temp);
    strcat(string, ",");
    strcat(string, p_string);

    len = strlen(string);         /* --- save p_string to array --- */
    size = len + 1;
    ii = line_ndx;

    array1[ii] = realloc(array1[ii], size * sizeof(char));
    strcpy(array1[line_ndx], string);       /* store to array */

 /* printf("string:: %s", string); /**/

}
/*------- end ScanField ----------*/



void ScanPut()
{   int pi, len;


    pi = e_pos;
    len = strlen(p_string);
    pi = get_alnum(pi, len);
    pi = get_NextOp(pi);
    e_pos = pi;

    ScanParam();                  /* parse paramaters */
}
/*------- end ScanPut ----------*/



void ScanRename()
{   char temp[6];
    int pi, len, mark;


    len = strlen(p_string);
    pi = e_pos;

    strcpy(temp, "AS ");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;
    pi = mark;

    if(pi < len)
    {
        p_string[pi] = ',';
        p_string[(pi+1)] = ' ';
    }

    e_pos = 0;
    ScanPrint();
}
/*---------- end ScanRename ----------*/



void ScanFiles()
{   char ch, temp[BUFSIZE];
    int pi, len;


    strcpy(temp, "\"dir ");
    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);

    if(pi < len)
    {
        ch = p_string[pi];

        if(ch == '\"')
        {
            p_string[pi] = ' ';
            strcat(temp, p_string);
        }
        else
        {
            strcat(temp, p_string);
        }
    }
    else
    {
        strcat(temp, "\"\n");
    }

    strcpy(p_string, temp);
    e_pos = 0;

    GetNewVar();                  /* get new varname */
}
/*---------- end ScanFiles ----------*/



void ScanShell()
{   char temp[BUFSIZE];
    int pi, len;


    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);

    if(pi < len)
    {
        strcpy(temp, p_string);
    }
    else
    {
        strcpy(temp, "\"command\"");
    }

    strcpy(p_string, temp);
    e_pos = 0;

    GetNewVar();                  /* get new varname */
}
/*---------- end ScanShell ----------*/



void ScanErase()
{   char ch, varname[VAR_NAME];
    int pi, type, len;
    int ab_code=22, x=line_ndx;


    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);
    ch = p_string[pi];

    while((pi < len) && (ch != '\n'))
    {
        e_pos = pi;

        if(isalpha(ch))
        {
            strcpy(varname, get_varname());      /* get varname */
            s_pos = pi;
            pi = e_pos;
            type = get_ObjectType(varname);

            if(type == 6)                        /* string array */
            {
                Fix_StrArray(varname);
            }
            else if((type >= 7) && (type <= 10)) /* numeric array */
            {
                Fix_VarArray(varname);
            }
            else
            {   a_bort(ab_code, x);
            }
        }
        else
        {
            a_bort(ab_code, x);
        }

        pi = e_pos;
        ch = p_string[pi];
        len = strlen(p_string);

        if(strchr(",()", ch))          /* jump over punctuation */
        {
            pi = get_rightExp(pi);     /* get to next alpha or string */
        }

        e_pos = pi;
        ch = p_string[pi];
    }
}
/*---------- end ScanErase ----------*/



























