/* bxbasm : Scanfor.c : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012       */


/* ----- function prototypes ----- */
#include "prototyp.h"



void ScanFor()
{   char varname[VAR_NAME];
    int pi, type, len;
    int ab_code=9, x=line_ndx;


    pi = 0;
    e_pos = pi;
    strcpy(varname, get_varname());    /* get varname */
    type = get_vtype(pi);              /* get variable type */

    if(type == 1)                      /* numeric expressions */
    {
        LexFor(varname);
        pi = e_pos;
        e_pos = pi + 2;                /* skip over: TO */

        LexTo();
        pi = e_pos + 4;                /* skip over: STEP */
        len = strlen(p_string);

        if(len > pi)                   /* if: STEP n */
        {
            e_pos = pi;
            LexStep(len);
        }
        else
        {
            e_pos = len;
            defaultStep(len);          /* create default STEP n */
        }
    }
    else
    {
        a_bort(ab_code, x);
    }
}
/*---------- end ScanFor ----------*/



void LexFor(char *name)
{   char ch, varname[VAR_NAME];
    int pi, type, len, TO;
    int ab_code=9, x=line_ndx;


    strcpy(varname, name);
    pi = e_pos;
    len = strlen(varname);
    s_pos = pi - len;
    type = get_Nvtype(pi);             /* get var-type length */

    if((type == 1) || (type == 2))     /* must be type: integer */
    {
        Sav_Destin_A(type, varname);   /* save destination name */
    }
    else
    {
        a_bort(ab_code, x);
    }

    pi = e_pos;                   /* handle expresions */
    s_pos = pi;
    TO = find_strng("TO");        /* work up to: TO */
    TO--;

    while(pi < TO)
    {
        ch = p_string[pi];

        while((isalnum(ch) == 0) && (pi < TO))
        {
            pi++;
            ch = p_string[pi];
        }

        if(pi < TO)
        {
            e_pos = pi;

            if(isdigit(ch))
            {
                GetNewTmp();      /* get new temp varname */
            }
            else if(isalpha(ch))
            {
                AddNewVar_A();      /* a variable name */
            }

            pi = e_pos;
            s_pos = pi;
            TO = find_strng("TO");     /* work up to: TO */
            TO--;
        }
    }

    e_pos = pi;
}
/*---------- end LexFor ----------*/



void LexTo()
{   char ch;
    int pi, STEP;


    pi = e_pos;
    s_pos = pi;
    STEP = find_strng("STEP");    /* work up to: STEP */
    STEP--;

    if(STEP < 0)                  /* if STEP does not exist */
    {
        STEP = strlen(p_string);  /* use p_string length */
    }

    while(pi < STEP)
    {
        ch = p_string[pi];

        while((isalnum(ch) == 0) && (pi < STEP))
        {
            pi++;
            ch = p_string[pi];
        }

        if(pi < STEP)
        {
            e_pos = pi;

            if(isdigit(ch))
            {
                GetNewTmp();      /* get new temp varname */
            }
            else if(isalpha(ch))  /* a variable name */
            {
                AddNewVar_A();
            }

            pi = e_pos;
            s_pos = pi;
            STEP = find_strng("STEP"); /* work up to: STEP */
            STEP--;

            if(STEP < 0)
            {
                STEP = strlen(p_string);
            }
        }
    }

    e_pos = pi;
}
/*---------- end LexTo ----------*/



void LexStep(int len)
{   char ch;
    int pi;


    pi = e_pos;

    while(pi < len)
    {
        ch = p_string[pi];

        while((isalnum(ch) == 0) && (pi < len))
        {
            pi++;
            ch = p_string[pi];
        }

        if(pi < len)
        {
            e_pos = pi;

            if(isdigit(ch))
            {
                GetNewTmp();      /* get new temp varname */
            }
            else if(isalpha(ch))  /* a variable name */
            {
                AddNewVar_A();
            }

            pi = e_pos;
        }
    }
}
/*---------- end LexStep ----------*/



void defaultStep(int len)
{   int pi;


    pi = e_pos;
    len--;
    p_string[len] = '\0';
    strcat(p_string, " STEP 1\n");

    len = strlen(p_string);       /* --- skip over STEP --- */
    pi = while_isalnum(pi);
    pi = get_digit(pi, len);

    e_pos = pi;                   /* convert digit to var-name */
    GetNewTmp();                  /* get new temp varname */
}
/*---------- end defaultStep ----------*/
























