/* bxbasm : Scanlet.c : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012       */


/* ----- function prototypes ----- */
#include "prototyp.h"



void ScanLet()
{   char ch, varname[VAR_NAME];
    int pi, type;
    int ab_code=5, x=line_ndx;


    pi = e_pos;
    strcpy(varname, get_varname());    /* get varname */

    pi = e_pos;
    ch = p_string[pi];

    if(strchr("$%!#@&", ch))
    {
        type = get_vtype(pi);          /* get variable type */

        if(type == 0)                  /* strings */
        {
            ScanString(varname);
        }
        else if(type == 6)             /* string array */
        {
            ScanStrArray(varname);
        }
        else if((type >= 7) && (type <= 10))     /* numeric array */
        {
            ScanNumArray(varname, type);
        }
        else                           /* numeric expressions */
        {
            ScanNumeric(varname);
        }
    }
    else
    {
        type = get_ObjectType(varname);     /* object type specifier */

        if(type == 0)                  /* strings */
        {
            ScanString(varname);
        }
        else if(type == 6)             /* string array */
        {
            ScanStrArray(varname);
        }
        else if((type >= 7) && (type <= 10))     /* numeric array */
        {
            ScanNumArray(varname, type);
        }
        else                           /* numeric expressions */
        {
            ScanNumeric(varname);
        }
    }
}
/*---------- end ScanLet ----------*/



void ScanString(char *Name)
{   char ch, varname[VAR_NAME];   /* LET MyString$ = "hello world" */
    int pi, len, type;


    strcpy(varname, Name);
    Fix_String_A(varname);

    len = strlen(p_string);
    pi = e_pos;
    pi = get_rightExp(pi);        /* jump pi over this operator */
    ch = p_string[pi];

    while((ch != '\n') && (pi < len))
    {
        e_pos = pi;

        if(ch == '\"')            /* found a quoted string */
        {
            GetNewVar();          /* get new varname */
        }
        else if(isalpha(ch))
        {
            strcpy(varname, get_varname());      /* get varname */
            type = get_ObjectType(varname);

            if(type == 6)
            {
                Fix_StrArray(varname);
                pi = e_pos;
                pi = get_paren(pi, len);
                ScanArrayParam();
            }
            else
            {
                Fix_String_A(varname);
            }
        }
        else if(isdigit(ch))      /* a string function number */
        {
            len = scanStr_funct(len);
        }

        pi = e_pos;
        pi = get_rightExp(pi);
        ch = p_string[pi];
    }

 /* printf("%s", p_string); /**/

}
/*---------- end ScanString ----------*/



void Fix_String_A(char *Name)
{   char ch, varname[VAR_NAME];
    int pi, len;


    strcpy(varname, Name);
    len = strlen(varname);
    pi = e_pos;
    s_pos = pi - len;
    ch = p_string[pi];

    if(ch == '$')
    {
        p_string[pi] = ' ';
        Sav_String_A(varname);
        StorVar(varname);
    }
}
/*---------- end Fix_String_A ----------*/



void ScanArrayParam()
{   char ch;
    int pi;


    pi = e_pos;
    ch = p_string[pi];

    while(ch != ')')
    {
        e_pos = pi;

        if(isalpha(ch))
        {
            AddNewVar_A();
            pi = e_pos;
        }
        else
        {
            pi++;
        }
        ch = p_string[pi];
    }

    e_pos = pi;
}
/*---------- end ScanArrayParam ----------*/



void ScanStrArray(char *Name)
{   char ch, varname[VAR_NAME];
    int pi, len, type;


    strcpy(varname, Name);
    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];

    if(ch == '$')
    {
        Fix_StrArray(varname);
    }

    pi = e_pos;
    pi = get_paren(pi, len);
    e_pos = pi;
    ScanArrayParam();             /* assign variables: abc$(1,3,n) */

    pi = e_pos;
    pi = get_rightExp(pi);        /* jump pi over this operator */
    ch = p_string[pi];

    while((ch != '\n') && (pi < len))
    {
        e_pos = pi;

        if(ch == '\"')            /* found a quoted string */
        {
            GetNewVar();          /* get new varname */
        }
        else if(isalpha(ch))
        {
            strcpy(varname, get_varname());      /* get varname */
            type = get_ObjectType(varname);

            if(type == 6)
            {
                Fix_StrArray(varname);
                pi = e_pos;
                pi = get_paren(pi, len);
                ScanArrayParam();
            }
            else
            {
                Sav_String_A(varname);
            }
        }
        else if(isdigit(ch))      /* a string function number */
        {
            len = scanStr_funct(len);
        }

        pi = e_pos;
        pi = get_rightExp(pi);
        ch = p_string[pi];
    }

/* printf("%s", p_string); */

}
/*---------- end ScanStrArray ----------*/



void ScanNumArray(char *name, int type)
{   char ch, varname[VAR_NAME];
    int pi, len, ival, funcflag=0;
    int ab_code=21, x=line_ndx;


    strcpy(varname, name);
    pi = e_pos;
    s_pos = 0;

    Scan_Array(varname, type);

    len = strlen(p_string);
    pi = e_pos;
    pi = get_rightExp(pi);        /* jump pi over this operator */
    ch = p_string[pi];

    while((ch != '\n') && (pi < len))
    {
        ch = p_string[pi];

        while((isalnum(ch) == 0) && (pi < len) && (strchr(".\"",ch) == 0))
        {
            pi++;
            ch = p_string[pi];

            if(ch == '?')         /* math function: ?1(num) */
            {
                e_pos = pi + 1;
                ival = (int) get_avalue();

                if((ival == 10) || (ival == 11) || (ival == 29))
                {
                    pi = len;     /* LOC, LOF, EOF */
                }
                else
                {                                /* any other function */
                    pi = get_paren(pi, len);     /* ?num(string$) */
                    ch = p_string[pi];           /* ----^	     */
                    funcflag = 1;
                }
            }
        }

        if(pi < len)
        {
            e_pos = pi;

            if(funcflag == 1)          /* this is a math function */
            {
                ScanMathFunc(len);
                funcflag = 0;
            }
            else if((isdigit(ch)) || (ch == '.'))
            {
                GetNewTmp();           /* get new temp varname */
            }
            else if(isalpha(ch))       /* an array or variable name */
            {
                pi = e_pos;
                strcpy(varname, get_varname());  /* get varname */
                type = get_ObjectType(varname);

                if((type >= 7) && (type <= 10))  /* an array name */
                {
                    Fix_VarArray(varname);
                    pi = e_pos;
                    pi = get_paren(pi, len);
                    ScanArrayParam();
                }
                else
                {
                    e_pos = pi;
                    AddNewVar_A();     /* a variable name */
                }
            }
            else
            {
                a_bort(ab_code, x);
            }

            pi = e_pos;
            len = strlen(p_string);
        }
    }

/* printf("sna::%s", p_string); */
}
/*---------- end ScanNumArray ----------*/



void Scan_Array(char *name, int type)
{   char ch, varname[VAR_NAME];
    int pi, len;


    strcpy(varname, name);
    pi = e_pos;
    ch = p_string[pi];

    if(strchr("%!#@&", ch))
    {
        p_string[pi] = ' ';
        e_pos++;
    }

    StorNVar(varname);       /* save destination array name */

    len = strlen(p_string);
    pi = e_pos;
    pi = get_paren(pi, len);
    e_pos = pi;

    ScanArrayParam();        /* assign variables: abc%(1,3,n) */
}
/*---------- end Scan_Array ----------*/



void ScanMathFunc(int len)
{   char ch, varname[VAR_NAME];
    int pi, type;


/* printf("ScanMathFunc:: %s", p_string); /**/

    pi = e_pos;
    ch = p_string[pi];

    while((ch != ')') && (pi < len))
    {
        if(ch == '\"')                 /* found a quoted string */
        {
            GetNewVar();               /* get new varname */
        }
        else if((isdigit(ch)) || (ch == '.'))
        {
            GetNewTmp();               /* get new temp varname */
        }
        else if(isalpha(ch))           /* a variable name */
        {
            type = get_vtype(pi);      /* get variable type */

            if(type == 0)              /* string variables */
            {
                strcpy(varname, get_varname());
                Fix_String_A(varname);
            }
            else if(type == 6)
            {
                strcpy(varname, get_varname());
                Fix_StrArray(varname);

                pi = e_pos;
                pi = get_paren(pi, len);
                e_pos = pi;

                ScanArrayParam();
                pi = e_pos;
                pi++;
                e_pos = pi;
            }
            else
            {
                AddNewVar_A();
            }
        }

        pi = e_pos;
        len = strlen(p_string);
        ch = p_string[pi];

        if(ch != ')')
        {
            pi++;
            ch = p_string[pi];
            e_pos = pi;
        }
    }

/* printf("ScanMath::%s", p_string); /**/

}
/*---------- end ScanMathFunc ----------*/



void ScanNumeric(char *name)
{   char ch, varname[VAR_NAME];
    int pi, type, len, ival, funcflag=0;
    int ab_code=5, x=line_ndx;


/* printf("ScanNumeric::%s", p_string); /**/

    strcpy(varname, name);
    pi = e_pos;
    len = strlen(varname);
    s_pos = pi - len;
    type = get_Nvtype(pi);             /* get var-type length */

/* printf("var type=%d\n", type); /**/

    Sav_Destin_A(type, varname);       /* save destination name */

    pi = e_pos;                        /* handle expresions */
    len = strlen(p_string);

/* printf("pi=%d, len=%d, pstring=%s", pi, len, p_string); /**/

    while(pi < len)
    {
        ch = p_string[pi];

        while((isalnum(ch) == 0) && (pi < len) && (strchr(".\"",ch) == 0))
        {
            pi++;
            ch = p_string[pi];

            if(ch == '?')              /* math function: ?1(num) */
            {
                e_pos = pi + 1;
                ival = (int) get_avalue();

                if((ival == 10) || (ival == 11) || (ival == 29))
                {
                    pi = len;          /* LOC, LOF, EOF */
                }
                else
                {                                /* any other function */
                    pi = get_paren(pi, len);     /* ?num(string$) */
                    ch = p_string[pi];           /* ----^	     */
                    funcflag = 1;
                }
            }
        }

        if(pi < len)
        {
            e_pos = pi;

   /* printf("funcflag=%d, ch=%c\n", funcflag, ch); /**/

            if(funcflag == 1)          /* this is a math function */
            {
                ScanMathFunc(len);
                funcflag = 0;
            }
            else if((isdigit(ch)) || (ch == '.'))
            {
                GetNewTmp();           /* get new temp varname */
            }
            else if(isalpha(ch))       /* an array or variable name */
            {
                pi = e_pos;
                strcpy(varname, get_varname());  /* get varname */
                type = get_ObjectType(varname);

           /* printf("type=%d\n", type); /**/

                if((type >= 7) && (type <= 10))  /* an array name */
                {
                    Fix_VarArray(varname);
                    pi = e_pos;
                    pi = get_paren(pi, len);
                    ScanArrayParam();
                }
                else
                {
                    e_pos = pi;
                    AddNewVar_A();     /* a variable name */
                }
            }
            pi = e_pos;
            len = strlen(p_string);
        }
    }

/* printf("ScanNumeric: %s", p_string); /**/

}
/*---------- end ScanNumeric ----------*/



void Sav_Destin_A(int type, char *Name)
{   char ch, varname[VAR_NAME];
    int pi, ab_code=5, x=line_ndx;


    strcpy(varname, Name);

/* printf("varname=%s\n", varname); /**/

    pi = e_pos;
    ch = p_string[pi];

    if(strchr("%!#@&", ch))
    {
        p_string[pi] = ' ';
    }

    if((type == 1) || (type == 2))     /* 16 or 32 Bit Integer */
    {
        if(check_VarName(varname) == 0)
        {
            ab_code = 30;
            a_bort(ab_code, x);        /* varname not found */
        }
    }
    else if((type >= 3) && (type <= 5))     /* 32 or 64 Bit Float -or- */
    {                                       /* 64 Bit Long-Long Integer */
        if(check_VarName(varname) == 0)     /* verify no duplicates */
        {
            ab_code = 30;
            a_bort(ab_code, x);        /* varname not found */
        }
    }
    else
    {
        a_bort(ab_code, x);
    }

    StorNVar(varname);                 /* save destination name */
}
/*---------- end Sav_Destin_A ----------*/




















