/* bxbasm : Scanmisc.c : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012        */


/* ----- function prototypes ----- */
#include "prototyp.h"



void ScanParam()                  /* parse function paramaters */
{   char ch;
    int pi, len;


    pi = e_pos;
    len = strlen(p_string);

    while(pi < len)
    {
        pi = get_alnum(pi, len);
        ch = p_string[pi];

        if(pi < len)
        {
            e_pos = pi;

            if((isdigit(ch)) || (ch == '.'))
            {
                GetNewTmp();      /* get new temp varname */
            }
            else if(isalpha(ch))  /* a variable name */
            {
                AddNewVar_A();
            }

            pi = e_pos;
            len = strlen(p_string);
        }
    }
}
/*---------- end ScanParam ----------*/



void ScanJump()                   /* parse numeric jump label */
{   char ch, newlabel[LLEN], label[LLEN];
    int pi, len;


    pi = e_pos;
    len = strlen(p_string);
    pi = get_alnum(pi, len);

    if(pi < len)
    {
        ch = p_string[pi];
        e_pos = pi;

        if(isdigit(ch))
        {
            strcpy(newlabel, "L");     /* correct numeric label */
            strcpy(label, get_varname());
            strcat(newlabel, label);
            StorNVar(newlabel);        /* save new label name */
        }
    }
}
/*---------- end ScanJump ----------*/



void ScanIf()
{   char ch, varname[VAR_NAME];
    int pi, len, type;


/* printf("ScanIf::%s", p_string); /**/

    pi = 0;
    ch = p_string[pi];
    len = strlen(p_string);

    while((ch != '\n') && (pi < len))
    {
        pi = iswhite(pi);
        ch = p_string[pi];
        e_pos = pi;

        if(ch == '\"')                 /* found a quoted string */
        {
            GetNewVar();               /* get new varname */
        }
        else if(isalpha(ch))
        {
            strcpy(varname, get_varname());      /* get varname */
            pi = e_pos;
            type = get_vtype(pi);                /* get variable type */

            if(type == 0)
            {
                Fix_String_A(varname);
            }
            else
            {
                if(strcmp(varname, "EOF") != 0)  /* not an EOF(f) */
                {
                    len = strlen(varname);
                    s_pos = pi - len;
                    type = get_Nvtype(pi);
                    Sav_Destin_A(type, varname); /* save destination name */
                }
                else
                {
                    pi++;              /* it's an EOF(f) */
                    pi = get_paren(pi, len);
                    e_pos = pi;
                }
            }
        }
        else if(isdigit(ch))
        {
            GetNewTmp();               /* get new temp varname */
        }

        pi = e_pos;
        len = strlen(p_string);
        pi = get_rightExp(pi);
        ch = p_string[pi];
    }

/* printf("scanif::%s", p_string); */

}
/*---------- end ScanIf ----------*/



void ScanFInput()                 /* parse INPUT# statement */
{   char ch, varname[VAR_NAME];
    int pi, len, type;


    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];

    while((pi < len) && (ch != '\n'))  /* process up to line terminator */
    {
        pi = get_alpha(pi, len);

        if(pi < len)
        {
            type = get_vtype(pi);

            if(type == 0)
            {
                e_pos = pi;
                strcpy(varname, get_varname());  /* get varname */
                Fix_String_A(varname);
            }
            else
            {
                e_pos = pi;            /* output a value */
                AddNewVar_A();
            }

            pi = get_NextOp(pi);
        }

        ch = p_string[pi];
    }

 /* printf("p_string:%s", format); */

}
/*------ end ScanFInput ------*/



void ScanMsgBox()
{   char ch, varname[VAR_NAME];
    int pi, len, type;
                        /*--- MessageBox "Text", "Caption", Type    ---*/
                        /*              ^--- pi */
    pi = 0;
    pi = iswhite(pi);
    e_pos = pi;
    ch = p_string[pi];

    if(ch == '\"')                /* found a quoted string */
    {
        GetNewVar();              /* get new varname */
    }
    else if(isalpha(ch))
    {
        strcpy(varname, get_varname());     /* get varname */
    }
                        /*--- MessageBox "Text", "Caption", Type    ---*/
                        /*                     ^--- pi */
    pi = e_pos;
    pi = get_rightExp(pi);
    e_pos = pi;
    ch = p_string[pi];

    if(ch == '\"')                /* found a quoted string */
    {
        GetNewVar();              /* get new varname */
    }
    else if(isalpha(ch))
    {
        strcpy(varname, get_varname());     /* get varname */
    }
                        /*--- MessageBox "Text", "Caption", Type    ---*/
                        /*                                ^--- pi */
    pi = e_pos;
    pi = get_rightExp(pi);
    e_pos = pi;
    ch = p_string[pi];

    if(isdigit(ch))
    {
        GetNewTmp();         /* get new temp varname */
    }

}
/*------ end ScanMsgBox ------*/



void ScanDeclare()
{

    line_ndx = 0;

    while(line_ndx < nrows)
    {
        get_token();
        e_pos = 0;
        s_pos = 0;

        switch(token)
        {
            case 56:              /* --- DECLARE SUB: statement --- */
                DeclareSub();
                break;
            default:
                break;
        }

        line_ndx++;
    }
}
/*------ end ScanDeclare ------*/



void DeclareSub()
{   char varname[VAR_NAME];
    int pi, ii, len, type, param;
    int ab_code=32, xx = line_ndx;


    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;
    strcpy(varname, get_varname());         /* get "SUB" */

    if(strcmp(varname, "SUB") == 0)
    {
        pi = e_pos;
        pi = iswhite(pi);
        pi = get_alpha(pi, len);
        e_pos = pi;
        strcpy(varname, get_varname());     /* get SubName */

        write_str("  ");
        write_str(varname);
        write_str("    proto  ");

        pi = e_pos;
        pi = get_paren(pi, len);
        param = get_paramsCount(pi, len);   /* get number of parameters */

        if(param > 0)
        {
            pi = get_alnum(pi, len);

            for(ii = 0; ii < param; ii++)
            {
                pi = while_isalnum(pi);
                type = get_Nvtype(pi);

                switch(type)
                {   case 0:                      /* string       */
                    case 1:                      /* integer      */
                    case 2:                      /* long integer */
                        write_str(" :dword");
                        break;
                    case 3:                      /* single float */
                    case 4:                      /* double float */
                        write_str(" :qword");
                        break;
                    default:
                        break;
                }

                if(ii < (param - 1))
                {
                    write_str(",");
                }

                pi = get_alnum(pi, len);
            }

            writeln(" ");
        }
        else
        {
            writeln(" ");
        }
    }
    else
    {
        a_bort(ab_code, xx);           /* no Sub's declared */
    }

}
/*------ end DeclareSub ------*/



void ScanSub()
{   char varname[VAR_NAME];
    int pi, ii, len, type, param;


    len = strlen(p_string);
    pi = e_pos;

    pi = get_paren(pi, len);
    param = get_paramsCount(pi, len);  /* get number of parameters */


    if(param > 0)
    {
        pi = get_alpha(pi, len);

        for(ii = 0; ii < param; ++ii)
        {
            e_pos = pi;
            strcpy(varname, get_varname()); /* get parameter name */
            pi = e_pos;

            type = get_Nvtype(pi);

            e_pos = pi;

            if(check_VarName(varname) == 0)
            {
                Sav_ObjName(varname, type, 0);   /* save this param name */
            }

            pi = get_alpha(pi, len);
        }
    }
}
/*------ end ScanSub ------*/








