/* bxbasm : Utility.c : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012       */



/* ----- function prototypes ----- */
#include "prototyp.h"



int get_Dvtype(int pi)
{   char ch, chx;
    int type;


    ch = p_string[pi];

/* printf("Dvtype:ch=>%c< pi=%d\n", ch, pi); /**/

    if(ch == '$')
    {
        type = 0;                 /* a string variable */
        ch = p_string[(pi+1)];

        if(ch == '(')             /* an array subscript */
        {
            type = 6;             /* abc$(1,2,3)        */
        }
    }
    else if(strchr("%!#@&", ch))
    {
        type = get_Nvtype(pi);
        chx = p_string[(pi+1)];

        if(chx == '(')            /* an array subscript */
        {
            switch(ch)
            {   case '%':
                    type = 7;     /* integer array */
                    break;
                case '!':
                    type = 8;     /* float array */
                    break;
                case '#':
                    type = 9;     /* double array */
                    break;
                case '@':
                case '&':
                    type = 10;    /* long-long integer */
                    break;
            }
        }
    }
    else if(ch == '(')
    {
        type = 11;
    }
    else
    {
        type = 1;
    }

    return type;
}
/*------- end get_Dvtype --------*/



int get_vtype(int pi)
{   char ch, chx;
    int type=-1;


    ch = p_string[pi];

    while(isalnum(ch))
    {
        pi++;
        ch = p_string[pi];
    }

    if(ch == '$')
    {
        type = 0;                 /* a string variable */
        ch = p_string[(pi+1)];

        if(ch == '(')             /* an array subscript */
        {
            type = 6;             /* abc$(1,2,3)        */
        }
    }
    else if(strchr("\n =<>%!#@&", ch))
    {
        type = 1;            /* a numeric or unspecified variable */

        if(strchr("%!#@&", ch))
        {
            chx = p_string[(pi+1)];

            if(chx == '(')   /* an array subscript */
            {
                switch(ch)
                {   case '%':
                        type = 7;      /* integer array */
                        break;
                    case '!':
                        type = 8;      /* float array */
                        break;
                    case '#':
                        type = 9;      /* double array */
                        break;
                    case '@':
                    case '&':
                        type = 10;     /* long integer */
                        break;
                }
            }
        }
    }
    else if(ch == '(')       /* a function */
    {
        type = 11;           /* it's an: EOF(fp) */
    }

    return type;
}
/*------- end get_vtype --------*/



int get_Nvtype(int pi)
{   char ch;
    int type=0;


    pi = while_isalnum(pi);
    ch = p_string[pi];

    if(strchr(",; )=+*-/\n", ch))
    {
        type = 1;                 /* a 16 Bit Word Integer */
    }
    else if(ch == '%')
    {
        type = 2;                 /* a 32 Bit Long Integer */
    }
    else if(ch == '!')
    {
        type = 3;                 /* a 32 Bit Floating Point */
    }
    else if(ch == '#')
    {
        type = 4;                 /* a 64 Bit Double Float */
    }
    else if(ch == '@')
    {
        type = 5;                 /* a 64 Bit Long Integer */
    }
    else if(ch == '&')
    {
        type = 5;                 /* a 64 Bit Long Integer */
    }

    return type;
}
/*------- end get_Nvtype --------*/



int get_rightExp(int pi)          /* get to rightside expression */
{   char ch;


    ch = p_string[pi];

    while((isalnum(ch) == 0) && (ch != '\"') && (ch != '\n'))
    {
        pi++;
        ch = p_string[pi];
    }

    return pi;
}
/*---------- end get_rightExp ----------*/



int get_NextOp(int pi)
{
    pi = while_isalnum(pi);       /* skip over any variable or string */
    pi = iswhiter(pi);

    return pi;
}
/*---------- end get_NextOp ----------*/



int get_paren(int pi, int stlen)
{   char ch;


    ch = p_string[pi];

    while((strchr("()", ch) == 0) && (pi < stlen))
    {
        pi++;
        ch = p_string[pi];
    }

    return pi;
}
/*---------- end get_paren ----------*/



int get_upper(int pi, int stlen)
{   char ch;


    ch = p_string[pi];

    while((isupper(ch) == 0) && (pi < stlen))
    {
        pi++;
        ch = p_string[pi];
    }

    return pi;
}
/*---------- end get_upper ----------*/



int get_alpha(int pi, int stlen)
{   char ch;


    ch = p_string[pi];

    while((isalpha(ch) == 0) && (pi < stlen))
    {
        pi++;
        ch = p_string[pi];
    }

    return pi;
}
/*---------- end get_alpha ----------*/



int get_digit(int pi, int stlen)
{   char ch;


    ch = p_string[pi];

    while((isdigit(ch) == 0) && (pi < stlen))
    {
        pi++;
        ch = p_string[pi];
    }

    return pi;
}
/*---------- end get_digit ----------*/



int get_alnum(int pi, int len)
{   char ch;


    ch = p_string[pi];

    while((isalnum(ch) == 0) && (pi < len))
    {
        pi++;
        ch = p_string[pi];
    }

    return pi;
}
/*---------- end get_alnum ---------*/



int iswhite(int pi)
{   char ch;


    ch = p_string[pi];            /* if next char is "whitespace" */

    while(isspace(ch) != 0)       /* get rid of it */
    {
        pi++;
        ch = p_string[pi];
    }

    return pi;
}
/*-------- end iswhite ----------*/



int iswhiter(int pi)
{   char ch, space=32;


    ch = p_string[pi];            /* if next char is "space" */

    while(ch == space)            /* get rid of it */
    {
        pi++;
        ch = p_string[pi];
    }

    return pi;
}
/*-------- end iswhiter ---------*/



int while_isalnum(int pi)
{   char ch;


    ch = p_string[pi];

    while(isalnum(ch))
    {
        pi++;
        ch = p_string[pi];
    }

    return pi;
}
/*-------- end while_isalnum ---------*/



int get_quote(int pi, int len)
{   char ch, quote='\"';


    pi++;
    ch = p_string[pi];

    while((ch != quote) && (pi < len))
    {
        pi++;
        ch = p_string[pi];
    }

    if(ch == quote)
    {
        pi++;
    }

    return pi;
}
/*-------- end get_quote ---------*/



void clr_arrays()
{   int ii;


    for(ii=0; ii < nrows; ii++)   /* free program array memory */
    {
        free(label_nam[ii]);
        free(array1[ii]);
    }

    free(label_nam);
    free(byte_array);
    free(array1);

    Kill_arrays();           /* For/Next loops */
}
/*-------- end clr_arrays ----------*/



int find_strng(char *tmp)
{   char ch, cx, quote='\"';
    char temp[TOKEN_LEN], xxstring[TOKEN_LEN];
    int pi, i, mark, len, len2;


    strcpy(xxstring, tmp);
    len = strlen(p_string);       /* locate xxstring within p_string */
    len2 = strlen(xxstring);
    pi = s_pos;                   /* plant pi w/starting position */
    ch = p_string[pi];
    cx = xxstring[0];             /* plant cx with 1st char in xxstring */

    while(pi < len)
    {
        while((ch != cx) && (pi < len))     /* find cx in p_string */
        {
            if(ch == quote)            /* line contains a quoted string */
            {
                pi++;                  /* advance past quoted strings */
                ch = p_string[pi];

                while(ch != quote)
                {
                    pi++;
                    ch = p_string[pi];
                }
            }
            pi++;
            ch = p_string[pi];
        }

        if((pi == len) || (pi > len))
        {
            mark = 0;        /* an error trap, in case string not found */
            return mark;
        }

        mark = pi;           /* this marks the beginning of search string */

        for(i=0; i < len2; i++)   /* load temp with test string */
        {
            temp[i] = ch;
            pi++;
            ch = p_string[pi];
        }
        temp[i] = '\0';

        if(strcmp(temp, xxstring) != 0)     /* test failed, loop again */
        {
            pi = (mark+1);             /* advance pi by 1 from "mark" */
            ch = p_string[pi];
        }
        else
        {
            mark++;
            pi = len;
        }
    }

    return mark;
}
/*-------- end find_strng ---------*/



void Build_arrays()
{   int ii;
    unsigned size=128;


    ForArray = malloc(size * sizeof(char *));

    for(ii=0; ii < size; ii++)
    {
        ForArray[ii] = malloc(LLEN * sizeof(char));
    }

    label_endif = malloc(size * sizeof(char *));

    for(ii=0; ii < size; ii++)
    {
        label_endif[ii] = malloc(LLEN * sizeof(char));
    }

    label_block = malloc(size * sizeof(char *));

    for(ii=0; ii < size; ii++)
    {
        label_block[ii] = malloc(LLEN * sizeof(char));
    }

    label_elseif = malloc(size * sizeof(char *));

    for(ii=0; ii < size; ii++)
    {
        label_elseif[ii] = malloc(LLEN * sizeof(char));
    }

    label_else = malloc(size * sizeof(char *));

    for(ii=0; ii < size; ii++)
    {
        label_else[ii] = malloc(LLEN * sizeof(char));
    }

    WhileArray = malloc(size * sizeof(char *));

    for(ii=0; ii < size; ii++)
    {
        WhileArray[ii] = malloc(LLEN * sizeof(char));
    }

    LoopArray = malloc(size * sizeof(char *));

    for(ii=0; ii < size; ii++)
    {
        LoopArray[ii] = malloc(LLEN * sizeof(char));
    }

    BreakArray = malloc(size * sizeof(char *));

    for(ii=0; ii < size; ii++)
    {
        BreakArray[ii] = malloc(LLEN * sizeof(char));
    }

    /* ... */

}
/*-------- end Build_arrays ---------*/



void Kill_arrays()
{   int ii;
    unsigned size=128;


    for(ii=0; ii < size; ii++)
    {
        free(ForArray[ii]);
    }
    free(ForArray);

    for(ii=0; ii < size; ii++)
    {
        free(label_endif[ii]);
    }
    free(label_endif);

    for(ii=0; ii < size; ii++)
    {
        free(label_block[ii]);
    }
    free(label_block);

    for(ii=0; ii < size; ii++)
    {
        free(label_elseif[ii]);
    }
    free(label_elseif);

    for(ii=0; ii < size; ii++)
    {
        free(label_else[ii]);
    }
    free(label_else);

    for(ii=0; ii < size; ii++)
    {
        free(WhileArray[ii]);
    }
    free(WhileArray);

    for(ii=0; ii < size; ii++)
    {
        free(LoopArray[ii]);
    }
    free(LoopArray);

    for(ii=0; ii < size; ii++)
    {
        free(BreakArray[ii]);
    }
    free(BreakArray);

    /* ... */

}
/*-------- end Kill_arrays ---------*/



int isthis_anarray(int pi, int stlen)
{   char ch;


    pi = get_NextOp(pi);
    ch = p_string[pi];

    if(strchr("$%!#~", ch) != 0)
    {
        pi++;
        pi = iswhiter(pi);
        ch = p_string[pi];
    }

    if(ch != '(')
    {
        pi = 0;
    }

    return pi;
}
/*---------- end isthis_anarray ----------*/



void get_param_name()
{
    char ch, quote='\"';
    int pi, indx, len, si;


    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];

    if(ch == quote)
    {
        si = 0;
        pi++;
        ch = p_string[pi];

        while((ch != quote) && (pi < len))
        {
            s_holder[si] = ch;
            si++;
            pi++;
            ch = p_string[pi];
        }
        s_holder[si] = '\0';
        e_pos = pi;
    }
    else
    {
        strcpy(s_holder, get_varname());
    }

    /* return param/varname in s_holder */
}
/*---------- end get_param_name ----------*/



void get_quotedStr()
{
    char ch, quote='\"';
    int pi, len, si;


    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];

    si = 0;
    pi++;
    ch = p_string[pi];

    while((ch != quote) && (pi < len))
    {
        s_holder[si] = ch;
        si++;
        pi++;
        ch = p_string[pi];
    }
    s_holder[si] = '\0';
    e_pos = pi;

    /* return param/varname in s_holder */
}
/*---------- end get_quotedStr ----------*/






