/* bxbasm : globals.h : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012       */



/* --- declare constants --- */
#define BUFSIZE     256
#define TOKEN_LEN   21
#define VAR_NAME    33
#define LLEN        33
#define IOARRAY     99
#define PATH        129
#define REC_LEN     128


/* ------ global vars ------------ */
    FILE *f_in, *f_out;      /* these are the i/o file handles    */
    FILE *s_datatemp;        /* these are temp i/o file handles   */
    FILE *i_datatemp;        /* these are temp i/o file handles   */
    FILE *f_datatemp;        /* these are temp i/o file handles   */
    FILE *x_datatemp;        /* these are temp i/o file handles   */
    FILE *sub_iotemp;        /* SUB temp i/o file handle          */
    char *prog_name;         /* program source-file name          */
    char p_string[BUFSIZE];  /* file input string                 */
    char **array1;           /* program array                     */
    char t_holder[20];       /* token data holder                 */
    char s_holder[BUFSIZE];  /* xstring (print) data holder       */
     int nrows;              /* numbers of lines in source file   */
     int ncolumns=BUFSIZE;   /* dimension for array1[][columns]   */
     int line_ndx;           /* current execution line            */
     int s_pos, e_pos;       /* pointers to start & end of token  */
    char xstring[BUFSIZE];   /* the print string                  */
    char **temp_prog;        /* temp program array                */
    char **temp_label;       /* temp label name array             */
     int *temp_byte;         /* temp byte code array              */
     int *byte_array;        /* byte code array                   */
    char **label_nam;        /* labels name array                 */
     int token;              /* token: current byte code          */
     int var_type;           /* current variable type             */
     int var_count=0;        /* variables counter                 */
    char **VarIndx;          /* unique variables name index       */
     int VarNdxCnt=0;        /* unique variables count            */
     int UnqLblNdx=0;        /* unique labels count               */
    char **ForArray;         /* FOR: nested FOR labels            */
     int forLabelCtr=0;      /* FOR: nested label counter         */
    char indent[BUFSIZE] = {0,0}; /* IF: indentation string       */
     int indcnt=0;           /* IF: indentations for nested code  */
     int opcntr=0;           /* IF: number of nested ANDs/ORs     */
    char **label_endif;      /* IF: array, nested labels          */
     int endifCtr=-1;        /* IF: nested ENDIF counter          */
    char **label_block;      /* IF: array, nested blocks          */
    char label_Or[LLEN];     /* IF: label, OR                     */
     int Or_pi=0;            /* IF:                               */
    char **label_elseif;     /* ELSEIF: array, nested ELSEIF's    */
    char **label_else;       /* ELSE: array, nested ELSE's        */
    char **WhileArray;       /* WHILE: nested While labels        */
     int whileLblCtr=0;      /* WHILE: nested label counter       */
    char wlabel_block[LLEN]; /* WHILE: block label                */
    char **LoopArray;        /* LOOP: nested LOOP labels          */
     int loopLblCtr=0;       /* LOOP: nested label counter        */
    char **BreakArray;       /* BREAK: nested LOOP labels         */
     int breakCtr=0;         /* BREAK: nested BREAK counter       */
     int dowhileflag=0;      /* FLAG: DO-WHILE                    */
    char **ObjIndx;          /* object/variables name index       */
     int **ObjType;          /* object/variables type specifier   */
     int ObjNdxCnt=0;        /* object/variables index count      */

    char swlabel_block[LLEN];/* SWITCH: block label               */
     int switchLblCtr=0;     /* SWITCH: label counter             */

    char thisSubNam[VAR_NAME]; /* SUB: current sub name           */



/*------ dynamic arrays ------*/
    char **ArryNdx;          /* Array: name array                 */
     int *ArryParams;        /* Array: parameters count array     */
     int ArryNdxCnt=0;       /* Array: counter                    */
/*------ all arrays are dynamic ------*/


/*------ File I/O structures ---------*/
  struct field_buffer        /* File: Field Buffer structure      */
     {   char *f_bffr;            /* I/O buffer */
     unsigned bfr_size;           /* buffer length */
          int *str_len;           /* string length */
         char **str_name;         /* string name */
          int fld_count;          /* number of strings */
         long record;             /* current record number */
          int flag;               /* PUT flag, to clear buffer */
     };                      /* File: handles structure           */

  struct field_buffer fld_bffr[IOARRAY];
     int lset_ndx;           /* File: global Lset/Rset var_index  */

  struct lset_rset
     {    int ndx;
          int cnt;
     } lrs;
/*------ end File I/O structures ---------*/


/*--- FLAGS ---*/
     int stringcopy=0;       /* Flag: string copy: function       */
     int asnchrstr=0;        /* Flag: CHR$ function               */
     int asnleftstr=0;       /* Flag: LEFT$ function              */
     int asnrightstr=0;      /* Flag: RIGHT$ function             */
     int asnmidstr=0;        /* Flag: MID$ function               */
     int asnspacestr=0;      /* Flag: SPACE$ function             */
     int asnstrsIval=0;      /* Flag: STR$(integer) function      */
     int asnstrsFval=0;      /* Flag: STR$(double) function       */
     int asnstringstr=0;     /* Flag: STRING$ function            */
     int asninkeystr=0;      /* Flag: INKEY$  function            */
     int asninputstr=0;      /* Flag: INPUT$  function            */
     int asnmkdstr=0;        /* Flag: MKD$    function            */
     int asnmkistr=0;        /* Flag: MKI$    function            */
     int asnmkqstr=0;        /* Flag: MKI$ (quad) function        */
     int resetcursor=0;      /* Flag: INPUT   function            */
     int getsysdate=0;       /* Flag: DATE    function            */
     int getsystime=0;       /* Flag: TIME    function            */
     int asndatestr=0;       /* Flag: DATE$   function            */
     int asntimestr=0;       /* Flag: DATE$   function            */
     int filecloseall=0;     /* Flag: close all files function    */
     int closeafile=0;       /* Flag: close a file function       */
     int getfilehandle=0;    /* Flag: get file handle function    */
     int clearstrngbffr=0;   /* Flag: clear I/O string function   */
     int setupiobuffer=0;    /* Flag: file I/O buffer function    */
     int asnlsetstr=0;       /* Flag: file LSET string function   */
     int asnrsetstr=0;       /* Flag: file RSET string function   */
     int clearallvars=0;     /* Flag: CLEAR variables function    */
     int clearstrvar=0;      /* Flag: CLEAR string    function    */
     int clearintvar=0;      /* Flag: CLEAR integer   function    */
     int clearfltvar=0;      /* Flag: CLEAR float     function    */
     int clearLngstrngbffr=0; /* Flag: clear i/o string function  */
     int movstrngbffr=0;     /* Flag: move input string function  */
     int readintstr=0;       /* Flag: move input integer function */
     int readfltstr=0;       /* Flag: move input float function   */
     int readQintstr=0;      /* Flag: move input integer function */
     int getfilelength=0;    /* Flag: LOF function                */
     int setcolortext=0;     /* Flag: COLOR function              */
     int dimstrarray=0;      /* Flag: DIM type:string function    */
     int getArryOffst=0;     /* Flag: array offset function       */
     int dblArryElement=0;   /* Flag: array integer element       */
     int quadArryElement=0;  /* Flag: array float element         */
     int freeArray=0;        /* Flag: array erase function        */
     int redimarray=0;       /* Flag: REDIM array function        */
     int sw_sub_handle=0;    /* Flag: open SUB handle             */
     int scansubflag=0;      /* Flag: scan SUB flag               */
     int hrtimer=0;          /* Flag: HiRezTimer function         */
     int newwindow=0;        /* Flag: Open new Window function    */
     int showwindow=0;       /* Flag: Show new Window function    */
     int drawline=0;         /* Flag: Draw Line function          */
     int redrawscreen=0;     /* Flag: ReDraw GUI Screen function  */
     int drawbox=0;          /* Flag: Draw rectangle function     */
     int postmessage=0;      /* Flag: Textout function            */
     int getgdifont=0;       /* Flag: new GDI Font function       */
     int resetoldfont=0;     /* Flag: reinstate 'Old' Font        */
     int drawrectangle=0;    /* Flag: Draw Rectangle function     */
     int drawroundedrect=0;  /* Flag: Draw Rounded Rectangle      */
     int drawsquare=0;       /* Flag: Draw Square function        */
     int drawellipse=0;      /* Flag: Draw Ellipse function       */
     int drawcircle=0;       /* Flag: Draw Circle function        */
     int drawpie=0;          /* Flag: Draw Pie shape function     */
     int drawchord=0;        /* Flag: Draw Chord shape function   */
     int drawarc=0;          /* Flag: Draw ARC shape function     */
     int pixelset=0;         /* Flag: PSET pixel set function     */
     int textColor=0;        /* Flag: set text color function     */
     int newpen=0;           /* Flag: set pen style function      */
     int oldpen=0;           /* Flag: reset old pen style         */
     int pencolor=0;         /* Flag: change pen color function   */
     int setbgcolor=0;       /* Flag: change background color     */
     int clearwindow=0;      /* Flag: Clear Window function       */
     int setbkmode=0;        /* Flag: set background mode         */
     int resizewin=0;        /* Flag: resize client window        */
     int getpoint=0;         /* Flag: get current pixel color     */
     int gdicreatepen=0;     /* Flag: create new GDI pen          */
     int gdilogbrush=0;      /* Flag: create logical brush        */
     int createbrushind=0;   /* Flag: create brush indirect       */
     int resetoldbrush=0;    /* Flag: restore old brush function  */


/*--- FLAGS ---*/


/*----------------- Windows GUI VARIABLES -----------------*/
/*---------------------------      ------------------------*/

    struct tagWinHwnd
    {
       char appName[VAR_NAME];
       char winName[VAR_NAME];
       HWND handle;
       HDC  buffer;
    };
    struct tagWinHwnd *WinHwnd;

     int flag_gui = 0;       /* flag: gui exists                  */
     int bkbffrndx = -1;

    char szAppName[VAR_NAME];/* WINDOW: this window ID            */
    char WinName[VAR_NAME];  /* SHOW: this window name            */
    char top[VAR_NAME];      /* SHOW: window top row coordinate   */
    char left[VAR_NAME];     /* SHOW: window left row coordinate  */
    char width[VAR_NAME];    /* SHOW: window width coordinate     */
    char height[VAR_NAME];   /* SHOW: window height coordinate    */
    char X1[VAR_NAME];       /* LINE: window x1 coordinate        */
    char Y1[VAR_NAME];       /* LINE: window y1 coordinate        */
    char X2[VAR_NAME];       /* LINE: window x2 coordinate        */
    char Y2[VAR_NAME];       /* LINE: window y2 coordinate        */

    char C1[VAR_NAME];       /* RGB:  c1 color red                */
    char C2[VAR_NAME];       /* RGB:  c2 color green              */
    char C3[VAR_NAME];       /* RGB:  c3 color blue               */

    char szText[VAR_NAME];   /* TEXT: textout string name         */
     int szLen;              /* TEXT: length of textout string    */



/*---------------------------------------------------------*/





















