;--- include file created by h2incx v0.99.20 (copyright 2005-2009 japheth)
;--- source file: C:\PROGRA~2\MinGW-461\include\time.h, last modified: 8/23/2011 15:59
;--- cmdline used for creation: -b -c -d3 -o inc -y time.h

;* 
;* time.h
;* This file has no copyright assigned and is placed in the Public Domain.
;* This file is a part of the mingw-runtime package.
;* No warranty is given; refer to the file DISCLAIMER within the package.
;*
;* Date and time functions and types.
;*
;*
ifndef _TIME_H_
_TIME_H_	EQU	<>
;* All the headers include this file. *

__need_wchar_t	EQU	<>
__need_size_t	EQU	<>
__need_NULL	EQU	<>

__MSVCRT_VERSION__  EQU	<>

;*
;* Number of clock ticks per second. A clock tick is the unit by which
;* processor time is measured and is returned by 'clock'.
;*
CLOCKS_PER_SEC	EQU	( ( clock_t ) 1000 )
CLK_TCK	EQU	<CLOCKS_PER_SEC>
ifndef RC_INVOKED
;*
;* A type for storing the current time and date. This is the number of
;* seconds since midnight Jan 1, 1970.
;* NOTE: This is also defined in non-ISO sys/types.h.
;*
ifndef _TIME32_T_DEFINED
__time32_t typedef SDWORD
_TIME32_T_DEFINED	EQU	<>
endif 
ifndef __STRICT_ANSI__
;* A 64-bit time_t to get to Y3K *
ifndef _TIME64_T_DEFINED
__time64_t typedef QWORD
_TIME64_T_DEFINED	EQU	<>
endif 
endif 


_TIME_T_DEFINED	EQU	<>
endif 
;*
;* A type for measuring processor time (in clock ticks).
;*
ifndef _CLOCK_T_DEFINED
clock_t typedef SDWORD
_CLOCK_T_DEFINED	EQU	<>
endif 
ifndef _TM_DEFINED
;*
;* A structure for storing all kinds of useful information about the
;* current (or another) time.
;*
tm	struct 
tm_sec	DWORD	?;* Seconds: 0-59 (K&R says 0-61?) *
tm_min	DWORD	?;* Minutes: 0-59 *
tm_hour	DWORD	?;* Hours since midnight: 0-23 *
tm_mday	DWORD	?;* Day of the month: 1-31 *
tm_mon	DWORD	?;* Months *since* january: 0-11 *
tm_year	DWORD	?;* Years since 1900 *
tm_wday	DWORD	?;* Days since Sunday (0-6) *
tm_yday	DWORD	?;* Days since Jan. 1: 0-365 *
tm_isdst	DWORD	?;* +1 Daylight Savings Time, 0 No DST,
;* -1 don't know *
tm	ends

_TM_DEFINED	EQU	<>
endif 
ifdef __cplusplus
;extern "C"
;{
endif 
clock proto c 
;if __MSVCRT_VERSION__ lt 0800h
time proto c :ptr time_t
difftime proto c :time_t, :time_t
mktime proto c :ptr tm
;endif 
;*
;* These functions write to and return pointers to static buffers that may
;* be overwritten by other function calls. Yikes!
;*
;* NOTE: localtime, and perhaps the others of the four functions grouped
;* below may return NULL if their argument is not 'acceptable'. Also note
;* that calling asctime with a NULL pointer will produce an Invalid Page
;* Fault and crap out your program. Guess how I know. Hint: stat called on
;* a directory gives 'invalid' times in st_atime etc...
;*
asctime proto c :ptr tm
;if __MSVCRT_VERSION__ lt 0800h
ctime proto c :ptr time_t
gmtime proto c :ptr time_t
localtime proto c :ptr time_t
;endif 
strftime proto c :ptr SBYTE, :size_t, :ptr SBYTE, :ptr tm
ifndef __STRICT_ANSI__
_tzset proto c 
ifndef _NO_OLDNAMES
tzset proto c 
endif 
_strdate proto c :ptr SBYTE
_strtime proto c :ptr SBYTE

;*
;* _daylight: non zero if daylight savings time is used.
;* _timezone: difference in seconds between GMT and local time.
;* _tzname: standard/daylight savings time zone names (an array with two
;*          elements).
;*
ifdef __MSVCRT__
;* These are for compatibility with pre-VC 5.0 suppied MSVCRT. *
__p__daylight proto c 
__p__timezone proto c 
__p__tzname proto c 
;* not __MSVCRT (ie. crtdll) *
else 
ifndef __DECLSPEC_SUPPORTED
_daylight	EQU	( * _imp___daylight_dll )
_timezone	EQU	( * _imp___timezone_dll )
_tzname	EQU	( * _imp___tzname )
;* __DECLSPEC_SUPPORTED *
else 
_daylight	EQU	<_daylight_dll>
_timezone	EQU	<_timezone_dll>
;* __DECLSPEC_SUPPORTED *
endif 
;* not __MSVCRT__ *
endif 
;* Not __STRICT_ANSI__ *
endif 
ifndef _NO_OLDNAMES
ifdef __MSVCRT__
;* These go in the oldnames import library for MSVCRT. *
;* not __MSVCRT__ *
else 
;* CRTDLL is royally messed up when it comes to these macros.
;TODO: import and alias these via oldnames import library instead 
;of macros.  *
daylight	EQU	<_daylight>
;* NOTE: timezone not defined as macro because it would conflict with
;struct timezone in sys/time.h.
;Also, tzname used to a be macro, but now it's in moldname. *
;* not __MSVCRT__ *
endif 
;* Not _NO_OLDNAMES *
endif 
ifndef _WTIME_DEFINED
;* wide function prototypes, also declared in wchar.h *
ifndef __STRICT_ANSI__
ifdef __MSVCRT__
_wasctime proto c :ptr tm
if __MSVCRT_VERSION__ lt 0800h
_wctime proto c :ptr time_t
endif 
_wstrdate proto c :ptr WORD
_wstrtime proto c :ptr WORD
if __MSVCRT_VERSION__ ge 0601h
_wctime64 proto c :ptr __time64_t
endif 
if __MSVCRT_VERSION__ ge 0800h
_wctime32 proto c :ptr __time32_t
ifndef _USE_32BIT_TIME_T
_wctime proto c :ptr time_t
;{
return proto c :_wctime64
;}
else 
_wctime proto c :ptr time_t
;{
return proto c :_wctime32
;}
endif 
;* __MSVCRT_VERSION__ >= 0x0800 *
endif 
;*  __MSVCRT__ *
endif 
;* __STRICT_ANSI__ *
endif 
wcsftime proto c :ptr WORD, :size_t, :ptr WORD, :ptr tm
_WTIME_DEFINED	EQU	<>
;* _WTIME_DEFINED *
endif 
ifdef __cplusplus
;}
endif 
;* Not RC_INVOKED *
endif 
;* Not _TIME_H_ *

;--- errors: 0
;--- end of file ---
